#!/bin/bash
# Escrito por : Hamacker (sirhamacker@gmail.com)   2008-10-30
# Função :
# Este script cria um .deb para o script Ubuntu Perfeito
# Ele poderá ser facilmente modificado para ser usado para 
# empacotar outros scripts, ou até mesmo programas.
# Licença : LGPL

CURRENT=`pwd`
SUFIXO="$1"
# So para testes
TESTE="N"
if [ "$TESTE" = "S" ] ; then
  SUFIXO="-testing-`date +%Y%m%d%H%M`"
fi
# Informacoes peculiares sobre o pacote
# Variaveis importantes
. $CURRENT/ubuntu-perfeito.var

if [ -z "$EMAILME" ] || \
   [ -z "$PACKAGE_NAME" ] || \
   [ -z "$ICONE" ] || \
   [ -z "$PASTA_TMP" ] ; then
  echo "Arquivo de variaiveis [ubuntu-perfeito.var]  não foi encontrado."
  exit 2;
fi

#APPLICATION_NAME="Ubuntu Perfeito"
# nome do icone que sera utilizado (nao colocar barra no inicio)
APPLICATION_ICON="$ICONE"
#PACKAGE_NAME="ubuntuperfeito-lucid"
PACKAGE_VERSION="10.04.11${SUFIXO}"
PACKAGE_SECTION="X11/Application"
PACKAGE_MAINTAINER="$EMAILME"
PACKAGE_ARCH="all"
SHORTCUT_CATEGORIES="System;Settings;"
BUILD_NAME="${PACKAGE_NAME}-${PACKAGE_VERSION}_${PACKAGE_ARCH}"

# descricao curta e longa
PACKAGE_DESCRIPTION="Um pratico menu que permite deixar o seu ubuntu perfeito para uso."
PACKAGE_LONG_DESC="Ubuntu Perfeito é um script que lhe traz varias tarefas para serem selecionados e depois o script trata de aplica-los em seu sistema.É um método simples para deixar o seu sistema pronto para uso."

# destino do pacote :
PROJECT_NAME="/tmp/$BUILD_NAME"

if [ -z "$BUILD_NAME" ] || \
   [ "$BUILD_NAME" = "" ] || \
   [ -z "$PROJECT_NAME" ] || \
   [ "$PROJECT_NAME" = "" ]  ; then
  echo "Nome do projeto é invalido !"
  exit 2;
fi

[ -d "$PROJECT_NAME" ] && rm -fR "$PROJECT_NAME"
! [ -d "$PROJECT_NAME" ] && mkdir -p "$PROJECT_NAME"
if ! [ -d "$PROJECT_NAME/DEBIAN" ] ; then
   mkdir -p "$PROJECT_NAME/DEBIAN"
   chmod 0755 "$PROJECT_NAME/DEBIAN"
fi
####################################################################
# binarios, scripts,...programas em si deverao ser copiados aqui   #
# para a estrutura em $PROJECT_NAME/usr/share/$PACKAGE_NAME        #
####################################################################
if ! [ -d "$PROJECT_NAME/usr/share/$PACKAGE_NAME" ] ; then
  mkdir -p "$PROJECT_NAME/usr/share/$PACKAGE_NAME"
  chmod 0755 "$PROJECT_NAME/usr/share/$PACKAGE_NAME"
fi

cp $CURRENT/ubuntu-perfeito.sh "$PROJECT_NAME/usr/share/$PACKAGE_NAME/ubuntu-perfeito.sh"
cp $CURRENT/ubuntu-perfeito.var "$PROJECT_NAME/usr/share/$PACKAGE_NAME/ubuntu-perfeito.var"
cp $CURRENT/criar-pacote-ubuntuperfeito.sh "$PROJECT_NAME/usr/share/$PACKAGE_NAME/criar-pacote-ubuntuperfeito.sh"
cp $CURRENT/ubuntuperfeito-menu.sh "$PROJECT_NAME/usr/share/$PACKAGE_NAME/ubuntuperfeito-menu.sh"
cp $CURRENT/ubuntuperfeito-aplicar_tema.sh "$PROJECT_NAME/usr/share/$PACKAGE_NAME/ubuntuperfeito-aplicar_tema.sh"
cp $CURRENT/ubuntuperfeito-aplicar_tema_ubuntu.sh "$PROJECT_NAME/usr/share/$PACKAGE_NAME/ubuntuperfeito-aplicar_tema_ubuntu.sh"
cp $CURRENT/ubuntuperfeito-copiar_manuais.sh "$PROJECT_NAME/usr/share/$PACKAGE_NAME/ubuntuperfeito-copiar_manuais.sh"
cp $CURRENT/ubuntuperfeito-exibir_icones.sh "$PROJECT_NAME/usr/share/$PACKAGE_NAME/ubuntuperfeito-exibir_icones.sh"
cp $CURRENT/ubuntuperfeito-gnomesystemmonitor.sh "$PROJECT_NAME/usr/share/$PACKAGE_NAME/ubuntuperfeito-gnomesystemmonitor.sh"
cp $CURRENT/ubuntuperfeito-roda_uma_unica_vez.sh "$PROJECT_NAME/usr/share/$PACKAGE_NAME/ubuntuperfeito-roda_uma_unica_vez.sh"
cp $CURRENT/ubuntuperfeito-set_font_liberation.sh "$PROJECT_NAME/usr/share/$PACKAGE_NAME/ubuntuperfeito-set_font_liberation.sh"
cp $CURRENT/ubuntuperfeito-hdd-spin-fix.sh "$PROJECT_NAME/usr/share/$PACKAGE_NAME/ubuntuperfeito-hdd-spin-fix.sh"
cp $CURRENT/ubuntuperfeito-converter_videos.sh "$PROJECT_NAME/usr/share/$PACKAGE_NAME/ubuntuperfeito-converter_videos.sh"
cp $CURRENT/ubuntuperfeito-corrigir-bug-teclado-rdesktop.sh "$PROJECT_NAME/usr/share/$PACKAGE_NAME/ubuntuperfeito-corrigir-bug-teclado-rdesktop.sh"

[ -f "$CURRENT/changelog.txt" ] && cp "$CURRENT/changelog.txt" "$PROJECT_NAME/usr/share/$PACKAGE_NAME/changelog.txt"
[ -f "$CURRENT/readme.txt" ] && cp "$CURRENT/readme.txt" "$PROJECT_NAME/usr/share/$PACKAGE_NAME/readme.txt"

if ! [ -d "$PROJECT_NAME/var/cache/$PACKAGE_NAME" ] ; then
  mkdir -p "$PROJECT_NAME/var/cache/$PACKAGE_NAME"
  chmod 0755 "$PROJECT_NAME/var/cache/$PACKAGE_NAME"
fi

if [ -f $CURRENT/ubuntuperfeito-profile-compiz.xml ] ; then
   cp "$CURRENT/ubuntuperfeito-profile-compiz.xml" "$PROJECT_NAME/var/cache/$PACKAGE_NAME/ubuntuperfeito-profile-compiz.xml"
   chmod 0755 "$PROJECT_NAME/var/cache/$PACKAGE_NAME/ubuntuperfeito-profile-compiz.xml"
fi
VAR_CACHE="N"
if [ -d "/var/cache/$PACKAGE_NAME" ] ; then
  echo -ne "Posso copiar /var/cache/$PACKAGE_NAME ? (s/n)"
  read VAR_CACHE
  if [ "$VAR_CACHE" = "S" ] || [ "$VAR_CACHE" = "s" ]  ; then
    #mkdir -p $PROJECT_NAME/var/cache/$PACKAGE_NAME
    #chmod 0755 $PROJECT_NAME/var/cache/$PACKAGE_NAME
    echo "iniciando a copia, apenas aguarde..."
    cp /var/cache/$PACKAGE_NAME/* "$PROJECT_NAME/var/cache/$PACKAGE_NAME"
    rm -f "$PROJECT_NAME/var/cache/$PACKAGE_NAME/menu.cat"
  fi
fi

###############################################################
# documentacao devera ser copiada aqui                        #
# para a estrutura $PROJECT_NAME/usr/share/doc/$PACKAGE_NAME  #
###############################################################
! [ -d "$PROJECT_NAME/usr/share/doc/$PACKAGE_NAME" ] && mkdir -p "$PROJECT_NAME/usr/share/doc/$PACKAGE_NAME"
[ -f "$CURRENT/changelog.txt" ] && cp "$CURRENT/changelog.txt" "$PROJECT_NAME/usr/share/doc/$PACKAGE_NAME/Changelog"
[ -f "$CURRENT/readme.txt" ] && cp "$CURRENT/readme.txt" "$PROJECT_NAME/usr/share/doc/$PACKAGE_NAME/README"

###############################################################
# definindo permissoes de pastas e arquivos convencionais     #
# para a estrutura $PROJECT_NAME/....                         #
###############################################################
if [ "$USER" = "root" ] ; then
  chown -R root.users "$PROJECT_NAME/"
  find "$PROJECT_NAME/" -type f -exec chmod 655  {} \;
  find "$PROJECT_NAME/" -name '*.sh' -type f -exec chmod a+x  {} \;
  find "$PROJECT_NAME/" -type d -exec chmod 0755  {} \;
fi

##########################################
# criando um atalho para minha aplicação #
##########################################
! [ -d "$PROJECT_NAME/usr/share/applications" ] && mkdir -p "$PROJECT_NAME/usr/share/applications"
cat > "$PROJECT_NAME/usr/share/applications/$PACKAGE_NAME.desktop" <<END
[Desktop Entry]
Name=$APPLICATION_NAME
GenericName=$PACKAGE_DESCRIPTION
Comment=$PACKAGE_DESCRIPTION
Exec=gksudo /usr/share/$PACKAGE_NAME/ubuntu-perfeito.sh
Icon=$APPLICATION_ICON
Terminal=false
Type=Application
Categories=$SHORTCUT_CATEGORIES
END
chmod 0755 "$PROJECT_NAME/usr/share/applications/$PACKAGE_NAME.desktop"

#############################################
# criando um atalho para o menu de serviços #
#############################################
cat > "$PROJECT_NAME/usr/share/applications/ubuntuperfeito-menu.desktop" <<END
[Desktop Entry]
Name=Menu de Serviços do Ubuntu Perfeito
GenericName=Menu de Serviços do Ubuntu Perfeito
Comment=Menu de Serviços do Ubuntu Perfeito
Exec=/usr/share/$PACKAGE_NAME/ubuntuperfeito-menu.sh
Icon=$APPLICATION_ICON
Terminal=false
Type=Application
Categories=Settings;DesktopSettings;
END
chmod 0755 "$PROJECT_NAME/usr/share/applications/ubuntuperfeito-menu.desktop"

cat > $PROJECT_NAME/DEBIAN/control <<END
Package: $PACKAGE_NAME
Version: $PACKAGE_VERSION
Architecture: $PACKAGE_ARCH
Maintainer: $PACKAGE_MAINTAINER
Installed-Size: `du -ks $PROJECT_NAME|cut -f 1`
Section: $PACKAGE_SECTION
Priority: optional
Depends:  bash, sed, zenity, wget, libnotify-bin, x11-xserver-utils
Description: $PACKAGE_DESCRIPTION.
  $PACKAGE_LONG_DESC.
  Após a instalação, você encontrará o Ubuntu Perfeito em Sistema|Administração|Ubuntu Perfeito.
  Depois de instalado os componentes de que você precisa, não esqueça de usar o Menu de Serviços do
  Ubuntu Perfeito, este se localiza em Sistema|Preferencias|Menu de Serviços do Ubuntu Perfeito.
END
chmod 0755 $PROJECT_NAME/DEBIAN/control

##################################
# Criando um md5sum dos arquivos #
##################################
tempfile=`mktemp`
[ -f "$PROJECT_NAME/DEBIAN/md5sums" ] && rm -f "$PROJECT_NAME/DEBIAN/md5sums"

find $PROJECT_NAME/ -type f > $tempfile
while read linha ; do
  md5sum=`md5sum $linha |cut -d" " -f1`
  arquivo=${linha//$PROJECT_NAME\//}
  particao=`echo $arquivo|cut -d "/" -f1`
  if [ "$particao" = "bin" ] || \
     [ "$particao" = "boot" ] || \
     [ "$particao" = "etc" ] || \
     [ "$particao" = "home" ] || \
     [ "$particao" = "lib" ] || \
     [ "$particao" = "lib32" ] || \
     [ "$particao" = "lib64" ] || \
     [ "$particao" = "opt" ] || \
     [ "$particao" = "sbin" ] || \
     [ "$particao" = "srv" ] || \
     [ "$particao" = "sys" ] || \
     [ "$particao" = "usr" ] || \
     [ "$particao" = "var" ] ; then
    echo "empacotando : $arquivo"
    echo "$md5sum $arquivo" >>$PROJECT_NAME/DEBIAN/md5sums
  fi
done <$tempfile
chmod 644 $PROJECT_NAME/DEBIAN/md5sums
[ -f $tempfile ] && rm -f $tempfile

##########################################################################
# gerando o pacote .deb a partir da estrutura criada e arquivos copiados #
##########################################################################
#debuild -S -sd
dpkg -b $PROJECT_NAME /tmp/$BUILD_NAME.deb
if  [ $? -ne 0 ] ; then
    sucesso="N"
    echo "ops! falhou a criação do pacote /tmp/$BUILD_NAME.deb !"
    exit;
else
  sucesso="S"
fi

if [ "$sucesso" = "S" ] ; then
  chmod 644 /tmp/$BUILD_NAME.deb
  if [ -z "$BUILD_NAME" ] || \
     [ "$BUILD_NAME" = "" ] || \
     [ -z "$PROJECT_NAME" ] || \
     [ "$PROJECT_NAME" = "" ]  ; then
    echo "Nome do projeto é invalido !"
    exit 2;
  else
    [ -d "$PROJECT_NAME" ] && rm -fR "$PROJECT_NAME"    
  fi
  echo "[sucesso] Pacote /tmp/$BUILD_NAME.deb criado com sucesso."
  [ "$VAR_CACHE" = "S" ] && echo "Copie-o para onde quiser e instale-o, os downloads obtidos serão reaproveitados."
  echo "Para instalar :"
  echo "  sudo dpkg -i /tmp/$BUILD_NAME.deb"
  echo "Para remover :"
  echo "  sudo apt-get -y --purge remove $PACKAGE_NAME"
fi

# retornar ao diretorio inicial
cd $CURRENT 

echo "fim."
