#!/bin/bash
# Guia Ubuntu Perfeito
# By Gladiston Hamacker Santana
# sirhamacker [em] gmail.com

#
# No inicio o programa era vazio
# ...no primeiro dia Ele criou o cabeçalho e as funcoes
#
# trap ctrl-c and call ctrl_c() trap ctrl_c INT
trap ctrl_c INT
function ctrl_c() {
  echo "*** botao de cancelamento acionado pelo usuario ***" ;
  [ -f "$PASTA_TMP/ubuntuperfeito-main-task.sh" ] && rm -f "$PASTA_TMP/ubuntuperfeito-main-task.sh" 
  [ -f "$PASTA_TMP/ubuntuperfeito-batch.sh" ] && rm -f "$PASTA_TMP/ubuntuperfeito-batch.sh"
  [ -f "$PASTA_TMP/ubuntuperfeito-batch.err" ] && rm -f "$PASTA_TMP/ubuntuperfeito-batch.err"
  ! [ -z "$XTERM_PID" ] && kill -9 $XTERM_PID;
  ! [ -z "$CURRENT_PID" ] && kill -9 $CURRENT_PID;
  exit 2;
}

function do_install_deps() {
  do_apt_install "zenity wget sed gdebi x11-xserver-utils libnotify-bin gxmessage"
}

function do_notificar() {
  titulo="$1"
  mensagem="$2"
  stayontop="$3"
  tempo_espera="$4"   # em segundos
  [ "$tempo_espera" = "" ] || [ -z "$tempo_espera" ] && tempo_espera=5
  tempo_espera_milisec=$((tempo_espera*100))
  [ "$tempo_espera" = "" ] && tempo_espera=30
  [ "$titulo" = "" ] && titulo="Aviso importante :"
  [ "$mensagem" = "" ] && titulo="Nada de importante a dizer"
  [ "$stayontop" = "S" ] && zenity --notification --title="$titulo"  --text "$mensagem"&
  if [ -f /usr/bin/notify-send ] ; then
    /usr/bin/notify-send -t $tempo_espera_milisec "$titulo" "$mensagem"  & 
  else 
    zenity --notification --title="$titulo"  --text "$mensagem"&
  fi
  [ "$MODO_TAGARELA" = "S" ] && $SPEAK "$mensagem"&
  #gxmessage -borderless -buttons "Prosseguir" -nofocus -center -iconic -timeout $tempo_espera -title "$titulo" "$mensagem"
}

function do_relatorio() {
  TEXTO="$1"
  if ! [ -f "$LEIAME" ] ; then
      zenity --question --title="Sair?"  --text "O arquivo de log $LEIAME simplesmente sumiu e com isso fico incapacitado de registrar as modificações que estão sendo feitas, devo sair deste script (botão [Não]) ou prosseguir (botão [Sim]) ?"
      [ $? -ne 0 ] &&  exit 2;
  fi    
  echo "$TEXTO" >>"$LEIAME"  
  echo $TEXTO 
  #do_notificar "Aviso importante :" "$TEXTO"
  # limpando variaveis utilizadas
  unset TEXTO  
}

function do_test_internet() {
  # funcao para testar a conectividade com a internet
  # é usado como referencia o logo do google porque acho que
  # é o link mais estavel do mundo para realizar teste de 
  # conectividade
  unset RESULT_VALUE
  INTERNET_OK="N"
  STARTING=0
  FINISH=30
  DOWNLOAD_URL="http://www.google.com.br/intl/pt-BR_br/images/logo.gif"
  DOWNLOAD_AS=`basename $DOWNLOAD_URL`
  [ -f "$PASTA_TMP/$DOWNLOAD_AS" ] && rm -f "$PASTA_TMP/$DOWNLOAD_AS"

  wget -q --timeout=30 --tries=3 "$DOWNLOAD_URL" -O "$PASTA_TMP/$DOWNLOAD_AS" &
  MYPID=$!
  while ! [ -z `ps -p ${MYPID} | grep ${MYPID}` 2>/dev/null ] ; do
    STARTING=$((STARTING+1))
    echo $((STARTING*100/$FINISH))
    sleep 1s;
  done |zenity --progress --auto-kill --auto-close --title="Aguarde..." --text "Testando conectividade com a internet\nURL de referencia :\n\t$DOWNLOAD_URL"
  if [ $? -ne 0 ] ; then
     return;
  fi  
  # -s = o arquivo existe e tamanho > 0 bytes
  if [ -s "$PASTA_TMP/$DOWNLOAD_AS" ] ; then
    INTERNET_OK="S"
    rm -f "$PASTA_TMP/$DOWNLOAD_AS"
  fi

  [ "$http_proxy" != "" ] && do_nothtificar "Voce esta usando as seguintes definições de proxy :" "http_proxy=$PROXY_ENV_NOPASSWD ; ftp_proxy=$PROXY_ENV_NOPASSWD"   
}

function do_confere_todos_repositorios() {
  do_check_for_repository "main"
  TEM_MAIN=$?
  do_check_for_repository "restricted"
  TEM_RESTRICTED=$?
  do_check_for_repository "universe"
  TEM_UNIVERSE=$?
  do_check_for_repository "multiverse"
  TEM_MULTIVERSE=$?
  do_check_for_repository "partner"
  TEM_PARTNER=$?
  #
  # Repositorios inexistentes serao automaticamente instalados
  #
  if [ "$TEM_MAIN" -ne 0 ] ; then
    cmdlist=( "${cmdlist[@]}" "add-apt-repository \"deb http://archive.ubuntu.com/ubuntu $ppa_repos main\"" )
  fi
  if [ "$TEM_RESTRICTED" -ne 0 ] ; then
    cmdlist=( "${cmdlist[@]}" "add-apt-repository \"deb http://archive.ubuntu.com/ubuntu $ppa_repos restricted\"" )
  fi
  if [ "$TEM_UNIVERSE" -ne 0 ] ; then
    cmdlist=( "${cmdlist[@]}" "add-apt-repository \"deb http://archive.ubuntu.com/ubuntu $ppa_repos universe\"" )
  fi
  if [ "$TEM_MULTIVERSE" -ne 0 ] ; then
    cmdlist=( "${cmdlist[@]}" "add-apt-repository \"deb http://archive.ubuntu.com/ubuntu $ppa_repos multiverse\"" )
  fi
  if [ "$TEM_PARTNER" -ne 0 ] ; then
    cmdlist=( "${cmdlist[@]}" "add-apt-repository \"deb http://archive.canonical.com/ubuntu $ppa_repos partner\"" )
    #cmdlist=( "${cmdlist[@]}" "add-apt-repository \"deb http://archive.ubuntu.com/ubuntu $ppa_repos partner\"" )
  fi
  if [ ${#cmdlist[*]} -ne 0 ] ; then
    cmdlist=( "${cmdlist[@]}" "apt-get -y --force-yes update" )
    do_cmd_exec
  fi
  #
  # Confere novamente os repositorios 
  # Se ainda são inexistentes entao a instalacao nao deverá prosseguir
  #
  do_check_for_repository "main"
  TEM_MAIN=$?
  do_check_for_repository "restricted"
  TEM_RESTRICTED=$?
  do_check_for_repository "universe"
  TEM_UNIVERSE=$?
  do_check_for_repository "multiverse"
  TEM_MULTIVERSE=$?
  do_check_for_repository "partner"
  TEM_PARTNER=$?
  FALTA_REPOSITORIOS=""
  [ "$TEM_MAIN" -ne 0 ] && FALTA_REPOSITORIOS="$FALTA_REPOSITORIOS main"
  [ "$TEM_RESTRICTED" -ne 0 ] && FALTA_REPOSITORIOS="$FALTA_REPOSITORIOS restricted"
  [ "$TEM_UNIVERSE" -ne 0 ] && FALTA_REPOSITORIOS="$FALTA_REPOSITORIOS universe"
  [ "$TEM_MULTIVERSE" -ne 0 ] && FALTA_REPOSITORIOS="$FALTA_REPOSITORIOS multiverse"
  [ "$TEM_PARTNER" -ne 0 ] && FALTA_REPOSITORIOS="$FALTA_REPOSITORIOS partner"
  if [ "$FALTA_REPOSITORIOS" != "" ] ; then
    zenity --question --title="Repositório inexistente :"  --text "Infelizmente este script só funcionará com o(s) repositório(s) habilitado :\n$FALTA_REPOSITORIOS\n. Siga o seguinte procedimento :\n1) Vá em Sistema->Administração->Gerenciador de pacotes Synaptic\n2) Dentro do Synaptic selecione o menu Configurações->Repositórios e habite o(s) repositório(s) alistados acima.\n3)Depois de habilitado o repositório, feche o Synaptic.\nPosso prosseguir com a execução do script assim mesmo ?\nLembre-se : Sem o repositório mencionado habilitado o script provavelmente falhará em alguns pontos.\n\nDevo sair deste script (botão [Não]) ou prosseguir (botão [Sim])."    
    [ $? -ne 0 ] &&  exit 2;
  fi
}

function do_check_for_repository() {
  REPO="$1"
  if [ -z "$REPO" ] ; then
     do_cmd_exec "echo \"Foi solicitado conferir um repositorio, mas nao foi passado o nome do repositorio como parametro de funcao.\"" 
  fi  
  
  tempfile="/tmp/ubuntuperfeito-repositorios-$ppa_repos.txt"
  [ -f "$tempfile" ] && rm -f "$tempfile"
  find /etc/apt/*.list -exec cat "{}" >> $tempfile \; 
  if [ `cat $tempfile|grep ^deb|grep $REPO|wc -l` -eq 0 ] ; then
     return 2
  fi
  return 0;
}

function do_remover_do_menu() {
  unset ITEM
  unset EXISTE
  ITEM=$1
  EXISTE=0
  if [ -f "$PASTA_TMP/menu_$ppa_repos.cat" ] ; then
    EXISTE=`cat "$PASTA_TMP/menu_$ppa_repos.cat"|grep "$ITEM"|wc -l`
  fi
  if [ "$EXISTE" -eq 0 2>/dev/null ] ; then
    # acrescentando o item ao menu.cat saberei
    # que tal opcao ja foi executada e nao
    # precisará ser exibida novamente no menu principal
    echo "$ITEM" >>"$PASTA_TMP/menu_$ppa_repos.cat"
  fi
}

function do_selecionar_usuario() {
  unset RESULT_VALUE
  menu_titulo=$1
  [ "$menu_titulo" = "" ] && menu_titulo="Quem sou eu?"
  menu_texto=$2
  [ "$menu_texto" = "" ] && menu_texto="Para a correta execução desse script,\nPreciso saber quem é que está executando-o neste instante."
  menu_usuarios=""
  LAST_LOGINNAME=""
  QTD_USUARIOS=0
  for linha_passwd in `cat /etc/passwd` ; do
    GET_UID=`echo "$linha_passwd"|cut -d":" -f3`
    GET_LOGINNAME=`echo "$linha_passwd"|cut -d":" -f1`
    GET_NAME=`echo "$linha_passwd"|cut -d":" -f5`
    #echo "UID=$GET_UID"
    #echo "LOGINNAME=$GET_LOGINNAME"
    #echo "NAME=$GET_NAME"    
    #echo "LAST VALID NAME=$LAST_LOGINNAME"    
    if [ "$GET_UID" -ge "1000" 2> /dev/null ] && [ "$GET_LOGINNAME" != "nobody" ]; then
      QTD_USUARIOS=$((QTD_USUARIOS+1))
      LAST_LOGINNAME=$GET_LOGINNAME
      menu_usuarios="$menu_usuarios $LAST_LOGINNAME"
    fi  
  done
  #  echo "*** LAST VALID NAME=$LAST_LOGINNAME"    
  if [ "$QTD_USUARIOS" -eq 1 ] ; then
    RETURN_VALUE="$LAST_LOGINNAME"
  else 
    # Criando um menu de seleção desses usuarios encontrados
    local_menu=""
    for nome in $menu_usuarios ; do
      add_string="false $nome"
      local_menu="$local_menu $add_string"
    done
    
    [ "$MODO_TAGARELA" = "S" ] && $SPEAK "Por favor, diga quem é você"&
    SELECTED_USERS=`zenity $ZEN_SIZE \
          --list --radiolist --title "[$QTD_USUARIOS]$menu_titulo" \
          --text "$menu_texto" \
          --column "#" --column "Você é qual desses usuários :" \
          $local_menu`;
    echo zenity $ZEN_SIZE \
          --list --radiolist --title "[$QTD_USUARIOS]$menu_titulo" \
          --text "$menu_texto" \
          --column "#" --column "Você é qual desses usuários :" \
          $local_menu
    RETURN_VALUE="$SELECTED_USERS"
  fi;
  echo $RETURN_VALUE  
  unset menu_titulo
  unset menu_texto
  unset linha_passwd
  unset GET_UID
  unset GET_LOGINNAME
  unset GET_NAME
  unset local_menu
  unset SELECTED_USERS
}

function do_menu_usuarios() {
  unset RETURN_VALUE
  menu_titulo=$1
  [ "$menu_titulo" = "" ] && menu_titulo="Selecione os usuários :"
  menu_texto=$2
  [ "$menu_texto" = "" ] && menu_texto="$TAREFA"
  menu_usuarios=""
  for linha_passwd in `cat /etc/passwd` ; do
    GET_UID=`echo "$linha_passwd"|cut -d":" -f3`
    GET_LOGINNAME=`echo "$linha_passwd"|cut -d":" -f1`
    GET_NAME=`echo "$linha_passwd"|cut -d":" -f5`
    if [ "$GET_UID" -ge "1000" 2> /dev/null ] && [ "$GET_LOGINNAME" != "nobody" ]; then
      menu_usuarios="$menu_usuarios $GET_LOGINNAME"
    fi  
  done
  # Criando um menu de seleção desses usuarios encontrados
  local_menu=""
  for nome in $menu_usuarios ; do
    add_string="false $nome"
    local_menu="$local_menu $add_string"
  done
  [ "$MODO_TAGARELA" = "S" ] && $SPEAK "Selecione os usuários para a tarefa $TAREFA"&
  if [ "$SE_AUTOMATICO" != "S" ]  ; then
    SELECTED_USERS=`zenity $ZEN_SIZE \
        --list --checklist --title "$menu_titulo" \
        --text "$menu_texto" \
        --column "#" --column "Usuarios :" \
        $local_menu`;
  else
    SELECTED_USERS="$menu_usuarios"
  fi
  RETURN_VALUE=`echo "$SELECTED_USERS"|tr "|" " "`
  unset menu_titulo
  unset menu_texto
  unset linha_passwd
  unset GET_UID
  unset GET_LOGINNAME
  unset GET_NAME
  unset local_menu
  unset SELECTED_USERS
}

function do_download() {
  BAIXAR_URL="$1"
  BAIXAR_ARQUIVO=`/usr/bin/basename "$BAIXAR_URL"`
  BAIXAR_EM="$PASTA_TMP/$BAIXAR_ARQUIVO"
  if [ -z "$BAIXAR_URL" ] || [ -z "$BAIXAR_ARQUIVO" ] || [ "$BAIXAR_ARQUIVO" = "" ]  ; then
      zenity --question --title="Erro fatal :"  --text "Foi solicitado um download de :\n$BAIXAR_URL\nMas o script formulou errado o local/nome de onde este arquivo seria salvo. Assim esta etapa do script ficou prejudicado, devo sair deste script (botão [Não]) ou prosseguir (botão [Sim]) ?"
      [ $? -ne 0 ] &&  exit 2;
  fi 

  if  [ "$INTERNET_OK" != "S" ] ; then
      zenity --question --title="Ops ! Cadê a Internet ?" \
            --text "Infelizmente este programa só pode ser executado quando houver acesso a internet.\nSem o acesso a internet, algumas tarefas nunca poderão ser completadas.\nSe estiver sob restrição dum proxy então, configure-o no menu principal.\nContinuar assim mesmo ?"
      if [ "$?" -ne 0 ] ; then
          echo "Abandonando o script porque falta o acesso a internet"
          exit 3;
      fi
  fi

  #[ "$http_proxy" != "" ] && do_notificar "Voce estará usando as seguintes definições de proxy :" "http_proxy=$PROXY_ENV_NOPASSWD ; ftp_proxy=$PROXY_ENV_NOPASSWD"   

  cmdlist=( "${cmdlist[@]}" "echo -e \"Download a realizar : \n\t$BAIXAR_URL\"" )
  cmdlist=( "${cmdlist[@]}" "echo -e \"Salvando em : \n\t$BAIXAR_EM\"" )
  cmdlist=( "${cmdlist[@]}" "wget -v -c --tries=3 --connect-timeout=30 \"$BAIXAR_URL\" -O \"$BAIXAR_EM\"" )
  do_cmd_exec

  # Se o download foi feito (e arquivo maior que zero bytes)
  if [ -s "$BAIXAR_EM" ] ; then
    # Verbose mais detalhado que irá parar no relatorio
    [ "$SE_DEBUG" = "S" ] && do_relatorio "Download realizado : $BAIXAR_URL"
    [ "$SE_DEBUG" = "S" ] && do_notificar "Download realizado : $BAIXAR_URL"    
  else
    # arquivo com zero bytes tem de ser eliminado, pois é lixo
    [ -f "$BAIXAR_EM" ] && rm -f "$BAIXAR_EM"
  fi
  # Limpando arquivo temporario utilizado
  [ -f $wgettempfile ] && rm -f $wgettempfile

  unset BAIXAR_URL
  unset BAIXAR_ARQUIVO
  unset BAIXAR_EM
  unset WGET
}

function do_cmd_start() {
  # nome do arquivo temporario a ser gerado que será executado pelo xterm
  cmdexecfile="$PASTA_TMP/ubuntuperfeito-main-task.sh"
  [ -f "$cmdexecfile" ] && rm -f "$cmdexecfile"
  [ -f "$PASTA_TMP/ubuntuperfeito-batch.err" ] && rm -f "$PASTA_TMP/ubuntuperfeito-batch.err"
  XTERM_PID=1000
  cat > "$cmdexecfile" <<END
#!/bin/bash
CONTINUAR_EXECUTANDO="S"
if ! [ -z "\$http_proxy" ] || [ "\$http_proxy" != "" ]  ; then
  echo "Atenção : Variaveis de ambiente estao ajustadas para usar proxy."
  if [ "$SE_DEBUG" = "S" ] ; then
     echo "HTTP_PROXY=\$http_proxy"
     echo "FTP_PROXY=\$ftp_proxy"
  fi
fi
while [ "\$CONTINUAR_EXECUTANDO" = "S" ] ; do
  PIDOF_UBUNTUPERFEITO=`ps $CURRENT_PID|grep $CURRENT_PID|wc -l`
  [ "\$PIDOF_UBUNTUPERFEITO" -lt 1 ] && CONTINUAR_EXECUTANDO="N"
  if [ -f "$PASTA_TMP/ubuntuperfeito-batch.sh" ] ; then
    echo "===================================================="
    bash "$PASTA_TMP/ubuntuperfeito-batch.sh"
    rm -f "$PASTA_TMP/ubuntuperfeito-batch.sh"
    echo "===================================================="
    echo "Aguardando novas execuções (PID=$CURRENT_PID)"
  fi
  sleep 1s
done
END
  chmod a+x "$cmdexecfile"
  gnome-terminal --window --hide-menubar --title="Não feche esta janela ! (PID=$CURRENT_PID)" -e "$cmdexecfile" &
  XTERM_PID=$!

  if [ -z "$XTERM_PID" ] ; then
     echo "Nao foi possivel encontrar o PID de nosso terminal aberto."
     exit 2;
  fi
}

function do_cmd_stop() {
  [ -f "$PASTA_TMP/ubuntuperfeito-main-task.sh" ] && rm -f "$PASTA_TMP/ubuntuperfeito-main-task.sh" 
  [ -f "$PASTA_TMP/ubuntuperfeito-batch.sh" ] && rm -f "$PASTA_TMP/ubuntuperfeito-batch.sh"
  [ -f "$PASTA_TMP/ubuntuperfeito-batch.err" ] && rm -f "$PASTA_TMP/ubuntuperfeito-batch.err"
  ! [ -z "$XTERM_PID" ] && kill -9 $XTERM_PID;
}

function do_test_if_fatal() {
  THIS_EXEC_IS_FATAL_RESULT_VALUE="SIM"
  #[[ "$1" =~ "dpkg --configure -a " ]] && THIS_EXEC_IS_FATAL_RESULT_VALUE="NAO"
  #[[ "$1" =~ "apt-get install -f" ]] && THIS_EXEC_IS_FATAL_RESULT_VALUE="NAO"  

  [[ "$1" =~ "apt-get --purge -y remove " ]] && THIS_EXEC_IS_FATAL_RESULT_VALUE="NAO"
  [[ "$1" =~ "read " ]] && THIS_EXEC_IS_FATAL_RESULT_VALUE="NAO"
  [ "$SE_AUTOMATICO" = "S" ] && THIS_EXEC_IS_FATAL_RESULT_VALUE="NAO"
  echo "$THIS_EXEC_IS_FATAL_RESULT_VALUE"
}

function do_cmd_exec() {
  [ -z "$TRY_CMD"  ] && TRY_CMD=0 
  if [ -z "$XTERM_PID" ] ; then
     do_cmd_start;
     TRY_CMD=$(TRY_CMD+1)
  fi
  if [ "$TRY_CMD" -gt 3 ] ; then
     do_cmd_stop
     exit 3;
  fi 
  CURRENT_TIME=`date +%d-%m-%Y_%H:%M:%S`
  STARTING=0
  FINISH=${#cmdlist[*]}
  echo $FINISH-$1
  if ! [ -z "$1" ] ; then
    if [ "$FINISH" -eq 0 ] ; then
       cmdlist=( "${cmdlist[@]}" "$1" )
       FINISH=${#cmdlist[*]}
    fi
  fi
  current_batch="$PASTA_TMP/ubuntuperfeito-batch.txt"
  echo "#!/bin/bash" >$current_batch
  echo "if ! [ -z \"\$http_proxy\" ] || [ \"\$http_proxy\" != \"\" ]  ; then">>$current_batch
  echo "  echo \"Atenção : Variaveis de ambientes estao ajustadas para usar proxy.\"">>$current_batch
  echo "  if [ \"$SE_DEBUG\" = \"S\" ] ; then">>$current_batch
  echo "    echo \"HTTP_PROXY=\$http_proxy\"">>$current_batch
  echo "    echo \"FTP_PROXY=\$ftp_proxy\"">>$current_batch
  echo "  fi">>$current_batch 
  echo "fi">>$current_batch 
  if [ "$TAREFA" != "" ] && [ "$TAREFA" != " " ] ; then
    echo "echo \"==== $TAREFA ====\"" >>$current_batch
  fi
  echo "[ -f \"$PASTA_TMP/ubuntuperfeito-batch.err\" ] && rm -f \"$PASTA_TMP/ubuntuperfeito-batch.err\"" >>$current_batch
  if [ "$FINISH" -gt 0 ] ; then
    # criando dinamicamente um script
    unset linha
    for linha in "${cmdlist[@]}" ; do   
      echo "if [ \"$SE_DEBUG\" = \"S\" ] ; then">>$current_batch
      echo "  echo '==================== Debug ========================'">>$current_batch
      echo "  echo \":$linha\"">>$current_batch
      echo "fi">>$current_batch 
      echo "$linha" >>$current_batch
      echo "if [ \"$SE_DEBUG\" = \"S\" ] ; then">>$current_batch
      echo "  echo 'Debug : Pressione [ENTER] para continuar'">>$current_batch
      echo "  read espera">>$current_batch
      echo "fi">>$current_batch 
      if [ `do_test_if_fatal "$linha"` = "SIM" ] ; then
        echo "if [ \$? -ne 0 ] ; then" >>$current_batch
        echo "   zenity --question --title=\"Sair?\" --text \"O botão de [cancelar] foi pressionado ou algum erro ocorreu na tarefa anterior($TAREFA), devo sair deste script (botão [Não]) ou prosseguir (botão [Sim]) ?\"" >>$current_batch
        echo "   if [ \$? -ne 0 ] ; then" >>$current_batch
        echo "     kill -9 $CURRENT_PID;" >>$current_batch
        echo "     kill -9 $XTERM_PID;" >>$current_batch
        echo "   else" >>$current_batch 
        echo "     touch \"$PASTA_TMP/ubuntuperfeito-batch.err\"" >>$current_batch 
        echo "   fi" >>$current_batch
        echo "fi" >>$current_batch
      fi
      do_relatorio "\$linha"
    done
  else
    # lista de execucoes vazias
    echo "echo \"$CURRENT_TIME : foi solicitado executar uma lista vazia de comandos\"">>$current_batch
  fi
  chmod a+x "$current_batch" 
  mv "$current_batch" "$PASTA_TMP/ubuntuperfeito-batch.sh"
  # aguarda ate o final da execucao do script
  CONTINUAR_EXECUTANDO="S"
  while [ "$CONTINUAR_EXECUTANDO" = "S" ] ; do
    PIDOF_UBUNTUPERFEITO=`ps $CURRENT_PID|grep $CURRENT_PID|wc -l`
    [ "$PIDOF_UBUNTUPERFEITO" -lt 1 ] && CONTINUAR_EXECUTANDO="N"
    ! [ -f "$PASTA_TMP/ubuntuperfeito-batch.sh" ] && CONTINUAR_EXECUTANDO="N"
    AINDA_LA=`ps p $XTERM_PID|grep $XTERM_PID|wc -l`
    if [ "$AINDA_LA" -lt 1 ] ; then
      do_cmd_start;
      TRY_CMD=$(TRY_CMD+1)
      if [ "$TRY_CMD" -gt 3 ] ; then
        do_cmd_stop
        exit 3;
      fi 
    fi
    sleep 1s
  done
  TRY_CMD=0
  unset cmdlist
}

function do_descompactar() {
  origem="$1"
  origem_ext=${origem##*.}  
  destino="$2"
  tar_opc=""
  tipo=""
  if [ "$origem_ext" == "gz" ] || \
     [ "$origem_ext" == "pdf" ] || \
     [ "$origem_ext" == "tar" ] || \
     [ "$origem_ext" == "bz2" ] ; then
       [ "$origem_ext" == "gz" ] && tar_opc="zxvf"
       [ "$origem_ext" == "tar" ] && tar_opc="xvf"
       [ "$origem_ext" == "bz2" ] && tar_opc="jxvf" 
       tipo="tar"
  fi
  [ "$origem_ext" = "zip" ] && tipo="zip"
  [ "$origem_ext" = "pdf" ] && tipo="pdf"
  cmdlist=( "${cmdlist[@]}" "echo \"Solicitou para descompactar  :\"" )
  cmdlist=( "${cmdlist[@]}" "echo \"Origem : $origem\"" )
  cmdlist=( "${cmdlist[@]}" "echo \"Destino : $destino\"" )
  cmdlist=( "${cmdlist[@]}" "echo \"Tipo : $origem_ext\"" ) 
  if [ "$tipo" = "" ] ; then
    zenity --error --title="Solicitou para descompactar um arquivo de tipo desconhecido :" \
           --text "Origem : $origem\nDestino : $destino\nTipo : $origem_ext"
    cmdlist=( "${cmdlist[@]}" "echo \"Porem o tipo de arquivo acima é desconhecido.\"" )
    do_cmd_exec
    return 
  fi  
  cmdlist=( "${cmdlist[@]}" "if ! [ -d \"$destino\" ] ; then" )
  cmdlist=( "${cmdlist[@]}" "  mkdir -p \"$destino\"" )
  cmdlist=( "${cmdlist[@]}" "fi" )
  [ "$tipo" = "tar" ] && cmdlist=( "${cmdlist[@]}" "tar $tar_opc \"$origem\" -C \"$destino\""  )
  [ "$tipo" = "zip" ] && cmdlist=( "${cmdlist[@]}" "unzip -o \"$origem\" -d \"$destino\"" )
  [ "$tipo" = "pdf" ] && cmdlist=( "${cmdlist[@]}" "cp -f \"$origem\" \"$destino\"" )
  do_cmd_exec 
 }

function do_apt_install() {
  APT_ERROR="S"
  if ! [ -z `pidof synaptic` ] ; then
      zenity --question --title="Synaptic esta aberto ?" --text "O sistema detectou que há um bloqueio no banco de dados de pacotes.\nIsso normalmente ocorre quando o synaptic ou outro tipo de programa relacionado a instalacao ou remoção de programas esta carregado.\nPara prosseguir preciso que o tal programa seja encerrado.\nDevo prosseguir este script (botão [OK]) ou sair (botão [Cancelar])?"
     if [ $? -ne 0 ] ; then
        do_cmd_stop
        exit 3;
     fi
  fi
  pacotes="$1"
  if [ -z "$pacotes" ] ; then
    RESPOSTA="N"
    [ "$SE_AUTOMATICO" = "S" ] && RESPOSTA="S"
    if [ "$RESPOSTA" != "S" ] ; then
       zenity --question --title="Sair?" --text "Foi solicitado a instalação de alguns programas, mas nao foi passado a lista do que deveria ser instalado, devo sair deste script (botão [Não]) ou prosseguir (botão [Sim]) ?"
       [ $? -eq 0 ] && RESPOSTA="S"
    fi
    if [ "$RESPOSTA" != "S" ] ; then
        do_cmd_stop
        exit 3;
    fi  
  fi

  do_notificar "Tarefa :" "$TAREFA"
  FINISH=`echo $pacotes|wc -w`
  APT_LIST=""
  cmdlist=( "${cmdlist[@]}" "dpkg --configure -a" )
  cmdlist=( "${cmdlist[@]}" "apt-get install -f" )
  for pak in $pacotes ; do
    cmdlist=( "${cmdlist[@]}" "apt-get --fix-missing -y --force-yes -o Acquire::http::Timeout=30 install $pak" )
  done
  if [ "$SE_DEBUG" = "S" ] ; then
    cmdlist=( "${cmdlist[@]}" "echo \"Debug : pressione [enter] para prosseguir...\"" )
    cmdlist=( "${cmdlist[@]}" "read espera" )
  fi
  
  # Executando a instalação
  do_cmd_exec
  if [ -f "$PASTA_TMP/ubuntuperfeito-batch.err" ] ; then
    APT_ERROR="S";
  else
    APT_ERROR="N";
  fi  
}

function do_apt_remove() {
  pacotes="$1"
  pacotes_existentes=""
  APT_ERROR="S"
  if ! [ -z `pidof synaptic` ] ; then
      zenity --question --title="Synaptic esta aberto ?" --text "O sistema detectou que há um bloqueio no banco de dados de pacotes.\nIsso normalmente ocorre quando o synaptic ou outro tipo de programa relacionado a instalacao ou remoção de programas esta carregado.\nPara prosseguir preciso que o tal programa seja encerrado.\nDevo sair deste script (botão [Não]) ou prosseguir (botão [Sim]) ?"
     if [ $? -ne 0 ] ; then
        do_cmd_stop
        exit 3;
     fi
  fi

  if [ -z "$pacotes" ] ; then
    RESPOSTA="N"
    [ "$SE_AUTOMATICO" = "S" ] && RESPOSTA="S"
    if [ "$RESPOSTA" != "S" ] ; then
       zenity --question --title="Sair?" --text "Foi solicitado a remoção de alguns programas, mas nao foi passado a lista do que deveria ser removido, devo sair deste script (botão [Não]) ou prosseguir (botão [Sim]) ?"
       [ $? -eq 0 ] && RESPOSTA="S"
    fi
    if [ "$RESPOSTA" != "S" ] ; then
        do_cmd_stop
        exit 3;
    fi  
  fi 

  do_notificar "Importante :" "Compilando lista de pacotes a serem removidos : $pacotes"

  # verificando quais pacotes foram removidos
  for pak in $pacotes ; do
    MATCH=`apt-cache policy  $pak|grep "Instalado"|wc -l 2>/dev/null`
    if [ "$MATCH" -gt 0 2>/dev/null ] ; then
       pacotes_existentes="$pacotes_existentes $pak" 
    fi
  done

  # se todos os pacotes solicitados para serem instalados nao existirem
  # entao nem prossegue com a instalacao
  if [ -z "$pacotes_existentes" ] || [ "$pacotes_existentes" = "" ] ; then
     do_notificar "Remoção de pacotes ignorada :" "Pacotes solicitados para remoção não estão instalados : $pacotes"
     return
  fi
  unset cmdlist
  cmdlist=( "${cmdlist[@]}" "dpkg --configure -a" )
  for pak in $pacotes_existentes ; do
     cmdlist=( "${cmdlist[@]}" "apt-get --purge -y remove $pak" )
  done

  if [ "$SE_DEBUG" = "S" ] ; then
    cmdlist=( "${cmdlist[@]}" "echo \"Debug : pressione [enter] para prosseguir...\"" )
    cmdlist=( "${cmdlist[@]}" "read espera" )
  fi
   
  # Executando a remocação de pacotes
  do_cmd_exec
  if [ -f "$PASTA_TMP/ubuntuperfeito-batch.err" ] ; then
    APT_ERROR="S";
  else
    APT_ERROR="N";
  fi
}

function do_gerar_novo_wallpapers_xml() {
DATA_ATUAL=`date +%d-%m-%Y+%H:%M`

# Pasta onde estao armazenados os papeis de parede
GNOME_PASTA_ORIGEM="$1"
if [ -z "$GNOME_PASTA_ORIGEM" ] ; then
  RESPOSTA="N"
  [ "$SE_AUTOMATICO" = "S" ] && RESPOSTA="S"
  if [ "$RESPOSTA" != "S" ] ; then
    zenity --question --title="Sair?"  --text "Foi solicitado a execução de um procedimento, mas nao foi passado a lista do que deveria ser executado, devo sair deste script (botão [Não]) ou prosseguir (botão [Sim]) ?"
    [ $? -eq 0 ] && RESPOSTA="S"
  fi
  if [ "$RESPOSTA" != "S" ] ; then
     do_cmd_stop
     exit 2;
  fi
fi 
# Pasta onde os papeis de parede serao copiados
GNOME_PASTA_DESTINO="/usr/share/backgrounds"

# Arquivo de indice XML de papeis de parede do GNOME
GNOME_XML="/usr/share/gnome-background-properties/ubuntu-wallpapers.xml"
touch  "$GNOME_XML"
chmod 777 "$GNOME_XML"

# Opcoes para o papel de parede : zoom, stretched
OPTIONS="stretched"

# cores de background/gradiente
PCOLOR="#000000"
SCOLOR="#000000"

# aplicacao da cor (solid/gradient)
SHADE_TYPE="solid"

# formato padrao para qual outros formatos serao
# convertidos para o local onde os papeis de
# parede devem ficar
DEST_FORMAT="png"

# backup do arquivo original
cp -f "$GNOME_XML" /tmp
rm -f "$GNOME_XML"

# copiando os formatos que sao iguais ao DEST_FORMAT
# e que portanto nao necessitam de nenhuma conversao
#cp "$GNOME_PASTA_ORIGEM/*.$DEST_FORMAT" "$GNOME_PASTA_DESTINO"

# Preparando o cabecalho do arquivo XML
echo "<?xml version=\"1.0\" encoding=\"UTF-8\"?>">$GNOME_XML
echo "<!DOCTYPE wallpapers SYSTEM \"gnome-wp-list.dtd\">">>$GNOME_XML
echo "<wallpapers>">>$GNOME_XML

# Formatos a serem trabalhados
LISTA_FORMATOS=( "${LISTA_FORMATOS[@]}" "png" )
LISTA_FORMATOS=( "${LISTA_FORMATOS[@]}" "jpg" )
LISTA_FORMATOS=( "${LISTA_FORMATOS[@]}" "bmp" )
LISTA_FORMATOS=( "${LISTA_FORMATOS[@]}" "tif" )
LISTA_FORMATOS=( "${LISTA_FORMATOS[@]}" "svg" )
LISTA_FORMATOS=( "${LISTA_FORMATOS[@]}" "xpm" )
# Cria Lista XML com os formatos graficos alistados
LISTFILE="/tmp/lista_arqs_background_$DATA_ATUAL.txt"
STARTING=0
FINISH=${#LISTA_FORMATOS[*]} 
for EXT in "${LISTA_FORMATOS[@]}"; do
  STARTING=$((STARTING+1))
  [ -f "$LISTFILE" ] && rm -f "$LISTFILE" 
  find "$GNOME_PASTA_DESTINO" -name "*.$EXT" -type f -fprint $LISTFILE
  #for ARQ in `ls -1 $GNOME_PASTA_DESTINO/*.$EXT 2>/dev/null` ; do
  while read ARQ ; do
    NAME=`basename $ARQ`
    echo "$GNOME_PASTA_DESTINO/$NAME"
    if [ -f "$GNOME_PASTA_DESTINO/$NAME" ] ; then
      echo "  <wallpaper>">>$GNOME_XML
      echo "    <name>$NAME</name>">>$GNOME_XML
      echo "    <filename>$ARQ</filename>">>$GNOME_XML
      echo "    <options>$OPTIONS</options>">>$GNOME_XML
      echo "    <pcolor>$PCOLOR</pcolor>">>$GNOME_XML
      echo "    <scolor>$SCOLOR</scolor>">>$GNOME_XML
      echo "    <shade_type>$SHADE_TYPE</shade_type>">>$GNOME_XML
      echo "  </wallpaper>">>$GNOME_XML
    fi
  done < $LISTFILE
  echo $((STARTING*100/$FINISH))
done|zenity --progress --auto-close --auto-kill --title="Aguarde..." --text "Gerando lista de papeis de parede disponiveis..."
#
[ "$MODO_TAGARELA" = "S" ] && $SPEAK "Gerando nova lista de papeis de parede"& 
# Rodape do arquivo XML
echo "</wallpapers>">>$GNOME_XML
chmod 666 $GNOME_XML
echo "Arquivo $GNOME_XML produzido com sucesso a partir do conteúdo de $GNOME_PASTA_DESTINO."
}

function do_admin_rede() {
  # ferramentas para administradores de rede
  # nmap - "The Network Mapper" - (O Mapeador de Rede)
  PROCEDIMENTO_EXECUTADO="FALHOU"
  TAREFA="Instalando programas de administração e segurança de rede" 
  instalar=""
  instalar="$instalar nmap dnsmasq tsclient rdesktop pyrenamer"
  #instalar="$instalar lanmap"
  instalar="$instalar nautilus-open-terminal nautilus-filename-repairer nautilus-image-converter nautilus-gksu"
  instalar="$instalar meld diff-ext"
  do_apt_install "$instalar"

  if [ "$APT_ERROR" != "S" ] ; then
    do_relatorio "$TAREFA [OK]"
    PROCEDIMENTO_EXECUTADO="OK"
  fi
}

function do_programacao_gnome() {
  # ferramentas de programação python e gnome
  # util apenas para programadores nessa linguagem
  # As vezes o melhor caminho é usar o proprio repositorio ao compilar seus proprios programas
  # especialmente para saber quais as dependencias necessarias de um programa, faca assim :
  # Para fazer uma compilacao a partir do repositorio ou backport :
  # apt-get build-dep <pacote>
  # apt-get -b source <pacote>
  PROCEDIMENTO_EXECUTADO="FALHOU"
  TAREFA="Instalando programas de administração e segurança de rede"  
  EXISTE_POSTFIX="N"
  [ -e "/etc/init.d/postfix" ] && EXISTE_POSTFIX="S"

  do_apt_install "devscripts subversion python-gtk2-dev cdbs libgconf2-dev libgtk2.0-dev"

  # sempre que é instalado ferramentas de programacao é instalado tambem o postfix
  # raras vezes o postfix é requerido nesse tipo de ambiente, assim
  # se ele não estava anteriormente instalado é melhor remove-lo :
  if [ "$EXISTE_POSTFIX" = "N" ]  ; then
    do_apt_remove "postfix"
  fi

  if [ "$APT_ERROR" != "S" ] ; then
    do_relatorio "$TAREFA [OK]"
    PROCEDIMENTO_EXECUTADO="OK"
  fi
}

function do_handbrake() {
  PROCEDIMENTO_EXECUTADO="FALHOU"
  TAREFA="Instalando o programa HandBrake, ripador de DVD"

  # Removendo versão anterior
  do_apt_remove "handbrake-gtk handbrake-cli handbrake-common"


  # Common
  DOWNLOAD_URL1="http://ppa.launchpad.net/handbrake-ubuntu/ppa/ubuntu/pool/main/h/handbrake/handbrake-common_0.9.4+repack3-0ubuntu0~10.04jdong1_all.deb"
  DOWNLOAD_AS1=`basename $DOWNLOAD_URL1`
  do_download "$DOWNLOAD_URL1"
  
  # Cli
  if [ "$amd64" = "S" ] ;then
    DOWNLOAD_URL2="http://ppa.launchpad.net/handbrake-ubuntu/ppa/ubuntu/pool/main/h/handbrake/handbrake-cli_0.9.4+repack3-0ubuntu0~10.04jdong1_amd64.deb"
  else
    DOWNLOAD_URL2="http://ppa.launchpad.net/handbrake-ubuntu/ppa/ubuntu/pool/main/h/handbrake/handbrake-cli_0.9.4+repack3-0ubuntu0~10.04jdong1_i386.deb"
  fi
  DOWNLOAD_AS2=`basename $DOWNLOAD_URL2`
  do_download "$DOWNLOAD_URL2"

  # Gui 
  if [ "$amd64" = "S" ] ;then
    DOWNLOAD_URL3="http://ppa.launchpad.net/handbrake-ubuntu/ppa/ubuntu/pool/main/h/handbrake/handbrake-gtk_0.9.4+repack3-0ubuntu0~10.04jdong1_amd64.deb"
  else
    DOWNLOAD_URL3="http://ppa.launchpad.net/handbrake-ubuntu/ppa/ubuntu/pool/main/h/handbrake/handbrake-gtk_0.9.4+repack3-0ubuntu0~10.04jdong1_i386.deb"
  fi
  DOWNLOAD_AS3=`basename $DOWNLOAD_URL3`
  do_download "$DOWNLOAD_URL3"
  
  if [ -f "$PASTA_TMP/$DOWNLOAD_AS1" ] && [ -f "$PASTA_TMP/$DOWNLOAD_AS2" ] && [ -f "$PASTA_TMP/$DOWNLOAD_AS3" ] ; then
     do_cmd_exec "$DPKG_INSTALL $PASTA_TMP/$DOWNLOAD_AS1 $PASTA_TMP/$DOWNLOAD_AS2 $PASTA_TMP/$DOWNLOAD_AS3 "
  fi

  # Confirmando ambas instalacoes
  if  [ -f "/usr/share/doc/handbrake-common/copyright" ] && \
      [ -f "/usr/share/doc/handbrake-cli/copyright" ] && \
      [ -f "/usr/share/doc/handbrake-gtk/copyright" ] ; then
    PROCEDIMENTO_EXECUTADO="OK"
    do_relatorio "$TAREFA [OK]"
  fi
}

function do_repositorio() {
  PROCEDIMENTO_EXECUTADO="INDIFERENTE"
  param1="$1"

  # removendo os repositorios do ubuntu perfeito para acrescenta-los (se for esse o desejo do usuario)
  # com novas chaves
  TAREFA="Processando repositórios gerenciados pelo Ubuntu Perfeito"

  if [ "$param1" = "remove" ] ; then
 	  if [ -f "/etc/apt/sources.list.d/deluge-team-ppa-$ppa_repos.list" ] ; then
      rm -f "/etc/apt/sources.list.d/deluge-team-ppa-$ppa_repos.list"*
    fi
 	  if [ -f "/etc/apt/sources.list.d/ubuntu-wine-ppa-$ppa_repos.list" ] ; then
       rm -f "/etc/apt/sources.list.d/ubuntu-wine-ppa-$ppa_repos.list"*
    fi
 	  if [ -f "/etc/apt/sources.list.d/ubuntu-clamav-ppa-$ppa_repos.list" ] ; then
       rm -f "/etc/apt/sources.list.d/ubuntu-clamav-ppa-$ppa_repos.list"*
    fi
 	  if [ -f "/etc/apt/sources.list.d/dreibh-ppa-$ppa_repos.list" ] ; then
       rm -f "/etc/apt/sources.list.d/dreibh-ppa-$ppa_repos.list"*
    fi
    if [ -f "/etc/apt/sources.list.d/openoffice-pkgs-ppa-$ppa_repos.list" ]  ; then
       rm -f "/etc/apt/sources.list.d/openoffice-pkgs-ppa-$ppa_repos.list"*
    fi
    if [ -f "/etc/apt/sources.list.d/xorg-edgers-ppa-$ppa_repos.list" ] ; then
       rm -f "/etc/apt/sources.list.d/xorg-edgers-ppa-$ppa_repos.list"*
    fi
    if [ -f "/etc/apt/sources.list.d/inkscape-nightly-ppa-$ppa_repos.list" ] ; then
       rm -f "/etc/apt/sources.list.d/inkscape-nightly-ppa-$ppa_repos.list"* 	  
    fi
	  if [ -f "/etc/apt/sources.list.d/jonoomph-openshot-edge-$ppa_repos.list" ] ; then
       rm -f "/etc/apt/sources.list.d/jonoomph-openshot-edge-$ppa_repos.list"*
    fi
	  if [ -f "/etc/apt/sources.list.d/amsn-daily-ppa-$ppa_repos.list" ] ; then
       rm -f "/etc/apt/sources.list.d/amsn-daily-ppa-$ppa_repos.list"*
    fi
	  if [ -f "/etc/apt/sources.list.d/sevenmachines-flash-$ppa_repos.list" ] ; then
       rm -f "/etc/apt/sources.list.d/sevenmachines-flash-$ppa_repos.list"*
    fi
	  if [ -f "/etc/apt/sources.list.d/bisigi-ppa-$ppa_repos.list" ] ; then
       rm -f "/etc/apt/sources.list.d/bisigi-ppa-$ppa_repos.list"*
    fi
	  if [ -f "/etc/apt/sources.list.d/deja-dup-team-ppa-$ppa_repos.list" ] ; then
       rm -f "/etc/apt/sources.list.d/deja-dup-team-ppa-$ppa_repos.list"*
    fi
	  if [ -f "/etc/apt/sources.list.d/paul-climbing-ppa-$ppa_repos.list" ] ; then
       rm -f "/etc/apt/sources.list.d/paul-climbing-ppa-$ppa_repos.list"*
    fi
	  if [ -f "/etc/apt/sources.list.d/ubuntuperfeito_mediabuntu.list" ] ; then
       rm -f "/etc/apt/sources.list.d/ubuntuperfeito_mediabuntu.list"*
    fi
	  if [ -f "/etc/apt/sources.list.d/ubuntuperfeito_virtualbox.list" ] ; then
       rm -f "/etc/apt/sources.list.d/ubuntuperfeito_virtualbox.list"*
    fi


    # Comentado porque estes abaixo so tem suporte ate o karmic
	  #[ -f "/etc/apt/sources.list.d/szymonw-ppa-$ppa_repos.list" ] && rm -f "/etc/apt/sources.list.d/szymonw-ppa-$ppa_repos.list"
	  #
	  # Repositorios Non-PPA
	  #
	  [ -f "/etc/apt/sources.list.d/ubuntuperfeito_mediabuntu.list" ] && rm -f "/etc/apt/sources.list.d/ubuntuperfeito_mediabuntu.*"
	  [ -f "/etc/apt/sources.list.d/ubuntuperfeito_virtualbox.list" ] && rm -f "/etc/apt/sources.list.d/ubuntuperfeito_virtualbox.*"
    # Restabelece a opção "Atualizar_lista_de_repositorios_e_o_sistema_operacional"
    sed -i "/^${atualizar_repositorios}.*/d" "$PASTA_TMP/menu_$ppa_repos.cat"
  fi

  #
  unset cmdlist

  if [ "$param1" != "remove" ] ; then
    #
    # adicionando alguns repositorios novos ao /etc/apt/sources.list.d/
    #

    # Acrescentando repositorios PPA individualmente
    cmdlist=( "${cmdlist[@]}" "echo 'Acrescentando repositorios PPA individualmente'")
    [ "$param1" = "xorg-edgers" ]  && cmdlist=( "${cmdlist[@]}" "add-apt-repository ppa:xorg-edgers/ppa" )
    
    # Acrescentando repositorios PPA individual ou todos
    [ "$param1" = "deluge-team" ] || [ "$param1" = "add-all" ] && cmdlist=( "${cmdlist[@]}" "add-apt-repository ppa:deluge-team/ppa" ) 
    [ "$param1" = "deja-dup-team" ] || [ "$param1" = "add-all" ] && cmdlist=( "${cmdlist[@]}" "add-apt-repository ppa:deja-dup-team/ppa" )
    [ "$param1" = "ubuntu-wine" ] || [ "$param1" = "add-all" ] && cmdlist=( "${cmdlist[@]}" "add-apt-repository ppa:ubuntu-wine/ppa" ) 
    [ "$param1" = "ubuntu-clamav" ] || [ "$param1" = "add-all" ] && cmdlist=( "${cmdlist[@]}" "add-apt-repository ppa:ubuntu-clamav/ppa" )  
    [ "$param1" = "dreibh" ] || [ "$param1" = "add-all" ] && cmdlist=( "${cmdlist[@]}" "add-apt-repository ppa:dreibh/ppa" ) 
    [ "$param1" = "inkscape" ] || [ "$param1" = "add-all" ] && cmdlist=( "${cmdlist[@]}" "add-apt-repository ppa:inkscape-nightly/ppa" )
    [ "$param1" = "jonoomph" ] || [ "$param1" = "add-all" ] && cmdlist=( "${cmdlist[@]}" "add-apt-repository ppa:jonoomph/openshot-edge" )
    [ "$param1" = "paul-climbing" ] || [ "$param1" = "add-all" ] && cmdlist=( "${cmdlist[@]}" "add-apt-repository ppa:paul-climbing/ppa" )
    [ "$param1" = "amsn-daily" ] || [ "$param1" = "add-all" ] && cmdlist=( "${cmdlist[@]}" "add-apt-repository ppa:amsn-daily" ) 
    [ "$param1" = "sevenmachines" ] || [ "$param1" = "add-all" ] && cmdlist=( "${cmdlist[@]}" "add-apt-repository ppa:sevenmachines/flash" ) 
    [ "$param1" = "bisigi" ] || [ "$param1" = "add-all" ] && cmdlist=( "${cmdlist[@]}" "add-apt-repository ppa:bisigi/ppa" )     
    # Sem suporte a LUCID ainda, nao esquecer de alterar do_repositorio_keys
    #[ "$param1" = "szymonw" ] || [ "$param1" = "add-all" ] && cmdlist=( "${cmdlist[@]}" "add-apt-repository ppa:szymonw/ppa" ) 

    do_cmd_exec
            
    # Remastersys
    #if [ "$param1" = "remastersys" ] || [ "$param1" = "add-all" ] ; then 
	  #   echo "#">/etc/apt/sources.list.d/ubuntuperfeito_remastersys.list
 	  #   echo "# $TAREFA">>/etc/apt/sources.list.d/ubuntuperfeito_remastersys.list
	  #   echo "#">>/etc/apt/sources.list.d/ubuntuperfeito_remastersys.list
	  #   echo "deb http://www.geekconnection.org/remastersys/repository $ppa_repos/">>/etc/apt/sources.list.d/ubuntuperfeito_remastersys.list
    #   chmod 644 "/etc/apt/sources.list.d/ubuntuperfeito_remastersys.list"
    #fi
    
    if [ "$param1" = "virtualbox" ] || [ "$param1" = "add-all" ] ; then 
      echo "# " >/etc/apt/sources.list.d/ubuntuperfeito_virtualbox.list
      echo "# wget -c http://download.virtualbox.org/virtualbox/debian/sun_vbox.asc -O $PASTA_TMP/sun_vbox.asc" >>/etc/apt/sources.list.d/ubuntuperfeito_virtualbox.list  
      echo "#  apt-key add $PASTA_TMP/sun_vbox.asc" >>/etc/apt/sources.list.d/ubuntuperfeito_virtualbox.list
      echo "deb http://download.virtualbox.org/virtualbox/debian $ppa_repos non-free" >>/etc/apt/sources.list.d/ubuntuperfeito_virtualbox.list   
      chmod 644 "/etc/apt/sources.list.d/ubuntuperfeito_virtualbox.list"
    fi

    # Acrescentando o repositorio multimedia Medibuntu
    if [ "$param1" = "medibuntu" ] || [ "$param1" = "add-all" ] ; then  
		   echo "#">/etc/apt/sources.list.d/ubuntuperfeito_mediabuntu.list
		   echo "# MediaBuntu - repositório de codecs e afins para multimedia">>/etc/apt/sources.list.d/ubuntuperfeito_mediabuntu.list
		   echo "# wget -c http://packages.medibuntu.org/medibuntu-key.gpg">>/etc/apt/sources.list.d/ubuntuperfeito_mediabuntu.list
		   echo "#  apt-key add medibuntu-key.gpg">>/etc/apt/sources.list.d/ubuntuperfeito_mediabuntu.list
		   echo "# offline temporario : acrenscente ao /etc/hosts :">>/etc/apt/sources.list.d/ubuntuperfeito_mediabuntu.list
		   echo "# 88.191.101.8 packages.medibuntu.org">>/etc/apt/sources.list.d/ubuntuperfeito_mediabuntu.list
		   echo "deb http://packages.medibuntu.org/ $ppa_repos free non-free">>/etc/apt/sources.list.d/ubuntuperfeito_mediabuntu.list
       #do_cmd_exec "echo 88.191.101.8 packages.medibuntu.org | tee -a /etc/hosts" 
       # do_cmd_exec "grep -v packages.medibuntu.org /etc/hosts | tee /etc/hosts"
		   chmod 644 "/etc/apt/sources.list.d/ubuntuperfeito_mediabuntu.list"		   
    fi

    # Winff - ainda um programa conversor multimedia experimental
    #if [ "$param1" = "winff" ] || [ "$param1" = "add-all" ] ; then 
		#   echo "# WinFF" >/etc/apt/sources.list.d/ubuntuperfeito_winff.list
		#   echo "# http://winff.org" >>/etc/apt/sources.list.d/ubuntuperfeito_winff.list  
		#   echo "deb http://winff.org/ubuntu $ppa_repos universe" >>/etc/apt/sources.list.d/ubuntuperfeito_winff.list
    #   chmod 644 /etc/apt/sources.list.d/ubuntuperfeito_winff.list
    #fi

    # Atualizando a lista de repositorios
    do_cmd_exec "apt-get -y --force-yes update"
    [ "$MODO_TAGARELA" = "S" ] && $SPEAK "Lista de repositórios foi alterada"& 
  else
    do_cmd_exec "apt-get -y --force-yes update"
    [ "$MODO_TAGARELA" = "S" ] && $SPEAK "Lista de repositórios foi removida"&
  fi
}  

function do_repositorio_keys() {
  # As assinaturas sem os repositorios nao servem para nada, no entanto,
  # acrescenta-las ao sistema resolve o problema para quando o repositorio for
  # adicionado entao a assinatura para tal já esteja presente
  PROCEDIMENTO_EXECUTADO="INDIFERENTE"
  # Conferir se as assinaturas ja nao foram importadas anteriormente
  if [ "$1" = "--force" ] ; then
     [ -f "$PASTA_TMP/assinaturas.txt" ] && rm -f "$PASTA_TMP/assinaturas.txt"
  fi

  if [ -f "$PASTA_TMP/assinaturas.txt" ] ; then
    return
  fi
  unset cmdlist
  [ -f "/etc/apt/sources.list.d/xorg-edgers-ppa-$ppa_repos.list" ] && do_cmd_exec "apt-key adv --recv-keys --keyserver keyserver.ubuntu.com 8844C542"  # ppa:xorg-edgers/ppa
  [ -f "/etc/apt/sources.list.d/deluge-team-ppa-$ppa_repos.list" ] && do_cmd_exec "apt-key adv --recv-keys --keyserver keyserver.ubuntu.com 249AD24C"  # ppa:deluge-team/ppa
  [ -f "/etc/apt/sources.list.d/deja-dup-team-ppa-$ppa_repos.list" ] && do_cmd_exec "apt-key adv --recv-keys --keyserver keyserver.ubuntu.com 41556EEA"  # ppa:deja-dup-team/ppa
  [ -f "/etc/apt/sources.list.d/ubuntu-wine-ppa-$ppa_repos.list" ] && do_cmd_exec "apt-key adv --recv-keys --keyserver keyserver.ubuntu.com F9CB8DB0"  # ppa:ubuntu-wine/ppa
  [ -f "/etc/apt/sources.list.d/ubuntu-clamav-ppa-$ppa_repos.list" ] && do_cmd_exec "apt-key adv --recv-keys --keyserver keyserver.ubuntu.com 5ADC2037"  # ppa:ubuntu-clamav/ppa
  [ -f "/etc/apt/sources.list.d/dreibh-ppa-$ppa_repos.list" ] && do_cmd_exec "apt-key adv --recv-keys --keyserver keyserver.ubuntu.com 916C56E0"  # ppa:dreibh/ppa
  [ -f "/etc/apt/sources.list.d/inkscape-nightly-ppa-$ppa_repos.list" ] && do_cmd_exec "apt-key adv --recv-keys --keyserver keyserver.ubuntu.com EC6B3CAD"  # ppa:inkscape-nightly/ppa
  [ -f "/etc/apt/sources.list.d/jonoomph-openshot-edge-$ppa_repos.list" ] && do_cmd_exec "apt-key adv --recv-keys --keyserver keyserver.ubuntu.com EDFBD1F9"  # ppa:jonoomph/openshot-edge
  [ -f "/etc/apt/sources.list.d/paul-climbing-ppa-$ppa_repos.list" ] && do_cmd_exec "apt-key adv --recv-keys --keyserver keyserver.ubuntu.com F96FD737"  # ppa:paul-climbing/ppa
  [ -f "/etc/apt/sources.list.d/amsn-daily-ppa-$ppa_repos.list" ] && do_cmd_exec "apt-key adv --recv-keys --keyserver keyserver.ubuntu.com 28CBC482"  # ppa:amsn-daily
  [ -f "/etc/apt/sources.list.d/bisigi-ppa-$ppa_repos.list" ] && do_cmd_exec "apt-key adv --recv-keys --keyserver keyserver.ubuntu.com 881574DE"  # ppa:bisigi/ppa
  [ -f "/etc/apt/sources.list.d/sevenmachines-flash-$ppa_repos.list" ] && do_cmd_exec "apt-key adv --recv-keys --keyserver keyserver.ubuntu.com 61E46227"  # ppa:sevenmachines/flash

  # ppa:c-korn/ppa - nem é usado mais, mas muito ficaram com ele por ocasiao do upgrade e
  # para nao quebrar a assinatura apenas importo-o mesma sem utiliza-la em meu script
  [ -f "/etc/apt/sources.list.d/c-korn-ppa-$ppa_repos.list" ] && do_cmd_exec "apt-key adv --recv-keys --keyserver keyserver.ubuntu.com 40130828"  # ppa:c-korn/ppa
  #do_cmd_exec "apt-key adv --recv-keys --keyserver keyserver.ubuntu.com XXXXXXXX"  #

  # Acrescentando o repositorio multimedia Medibuntu
	[ -f "$PASTA_TMP/medibuntu-key.gpg" ] && rm -f "$PASTA_TMP/medibuntu-key.gpg" 
	do_download "http://packages.medibuntu.org/medibuntu-key.gpg"
  [ -f "$PASTA_TMP/medibuntu-key.gpg" ] && do_cmd_exec "apt-key add \"$PASTA_TMP/medibuntu-key.gpg\"" 

  # VirtualBox
  [ -f "$PASTA_TMP/oracle_vbox.asc" ] && rm -f "$PASTA_TMP/oracle_vbox.asc"
  do_download "http://download.virtualbox.org/virtualbox/debian/oracle_vbox.asc"
  if [ -f "$PASTA_TMP/oracle_vbox.asc" ] ; then
      apt-key add "$PASTA_TMP/oracle_vbox.asc"
      rm -f "$PASTA_TMP/oracle_vbox.asc"
  fi

  # Google
  [ -f "$PASTA_TMP/linux_signing_key.pub" ] && rm -f "$PASTA_TMP/linux_signing_key.pub"
  do_download "https://dl-ssl.google.com/linux/linux_signing_key.pub"
  if [ -f "$PASTA_TMP/linux_signing_key.pub" ] ; then
    apt-key add "$PASTA_TMP/linux_signing_key.pub"
    rm -f "$PASTA_TMP/linux_signing_key.pub"
  fi

  # Um arquivo de flag é gerado para que a instalacao de chaves nao se repita
  # toda vez que essa funcao for executada.
  if [ "$1" = "--force" ] ; then
    do_cmd_exec "apt-get -y --force-yes update"
  fi
  echo "# Assinaturas/Chaves de repositórios foram importadas." > $PASTA_TMP/assinaturas.txt
  echo "# Apagando este arquivo onde esta lendo esta mensagem, as assinaturas/chaves serao importadas novamente.">>$PASTA_TMP/assinaturas.txt
}

function do_horario_verao() {
  PROCEDIMENTO_EXECUTADO="FALHOU"
  TAREFA="Instalação do horário de verão" 
  do_apt_install "tz-brasil"
  if [ "$APT_ERROR" != "S" ] ; then
    do_relatorio "$TAREFA [OK]"
    PROCEDIMENTO_EXECUTADO="OK"
  fi
}

function do_atualiza_ids() {
  PROCEDIMENTO_EXECUTADO="FALHOU"
  # Atualizando tabela de hardwares detectaveis
  TAREFA="Atualizando tabela de hardwares detectaveis"
  do_cmd_exec "update-pciids"
  do_cmd_exec "update-usbids"
  if [ "$APT_ERROR" != "S" ] ; then
    do_relatorio "$TAREFA [OK]"
    PROCEDIMENTO_EXECUTADO="OK"
  fi
}

function do_compilacao_basicos() {
  # dependencias basicas que precisam ser instaladas
  TAREFA="Instalando dependencias de compilação de módulos e programação"
  PROCEDIMENTO_EXECUTADO="FALHOU"
  instalar=""
  instalar="$instalar dh-make ctags build-essential dpkg-dev debhelper fakeroot"
  instalar="$instalar exuberant-ctags module-assistant gedit-plugins" 
  #instalar="$instalar git-core bzip2 kernel-package linux-headers-`uname -r`"
  #instalar="$instalar bin86 libqt3-headers libqt3-mt-dev libncurses5-dev subversion"
  do_apt_install "$instalar"

  if [ "$APT_ERROR" != "S" ] ; then
    do_relatorio "$TAREFA [OK]"
    PROCEDIMENTO_EXECUTADO="OK"
  fi
}

function do_instalar_ps3_multimedia_server() {
  TAREFA="Instalando PS3 Multimedia server"
  PROCEDIMENTO_EXECUTADO="FALHOU"
  RESPOSTA="N"
  [ "$SE_AUTOMATICO" = "S" ] && RESPOSTA="S"
  if [ "$RESPOSTA" != "S" ] ; then
    zenity --question --title="Gostaria de Instalar Servidor de Multimedia para PlayStation 3 ?" \
       --text "Servidor de Multimedia para PlayStation 3 só é util para usuários de PlayStation 3 que queiram compartilhar conteúdo multimedia entre um computador em casa que tenha uma coneção em rede (com ou sem fio) e um playstation 3.\nGostaria de Instalar Servidor de Multimedia para PlayStation 3?"
    [ $? -eq 0 ] && RESPOSTA="S"
  fi
  if [ "$RESPOSTA" != "S" ] ; then
     return
  fi

	if ! [ -f "/usr/lib/jvm/java-6-sun/jre/bin/java" ] &&
	   ! [ -f "/usr/lib/jvm/java-6-openjdk/jre/bin/java" ]  ; then
     zenity --error --title="Não posso instalar Servidor de Multimedia para PlayStation 3 :" --text "O Servidor de Multimedia para PlayStation 3 requer o Java instalado e este não foi encontrado em seu sistema."     
     return	   
	fi

	if ! [ -f "/usr/bin/ffmpeg" ] ||
	   ! [ -f "/usr/bin/mplayer" ]  ; then
     zenity --error --title="Não posso instalar Servidor de Multimedia para PlayStation 3 :" --text "O Servidor de Multimedia para PlayStation 3 requer os pacotes ffmpeg e mplayer instados e estes não foram encontrados em seu sistema."     
     return	   
	fi

  DOWNLOAD_URL="http://ps3mediaserver.googlecode.com/files/pms-linux-1.10.5.tgz"
  DOWNLOAD_AS=`basename $DOWNLOAD_URL`
  PMS_INSTALL_TO=""
  do_download "$DOWNLOAD_URL"
  
  if [ -f "$PASTA_TMP/$DOWNLOAD_AS" ] ; then
    do_descompactar "$PASTA_TMP/$DOWNLOAD_AS" "/usr/share"
    if [ `ls -1 /usr/share/|grep pms-linux|wc -l` -gt 0 ] ; then
      PMS_INSTALL_TO="/usr/share/`basename $DOWNLOAD_AS .tgz`"
    else
      return
    fi
    [ -f "$PMS_INSTALL_TO/PMS.sh" ] && chmod a+x "$PMS_INSTALL_TO/PMS.sh"

    # O pms só pode ser executado de dentro do seu próprio diretorio, assim
    # um pequeno script fará essa correção
    echo "#!/bin/bash">/usr/bin/pms-linux.sh
    echo "cd $PMS_INSTALL_TO/">>/usr/bin/pms-linux.sh
    echo "$PMS_INSTALL_TO/PMS.sh">>/usr/bin/pms-linux.sh
    chmod a+x /usr/bin/pms-linux.sh   
        
    # criando o atalho
    echo "[Desktop Entry]">/usr/share/applications/pms-linux.desktop
    echo "Name=Servidor Multimedia para Playstation 3">>/usr/share/applications/pms-linux.desktop
    echo "GenericName=Servidor Multimedia para Playstation 3">>/usr/share/applications/pms-linux.desktop
    echo "Comment=Transforma este Linux num servidor de multimedia para Playstation 3">>/usr/share/applications/pms-linux.desktop
    echo "Exec=gksu /usr/bin/pms-linux.sh">>/usr/share/applications/pms-linux.desktop
    echo "Icon=gtk-multimedia">>/usr/share/applications/pms-linux.desktop
    echo "Terminal=false">>/usr/share/applications/pms-linux.desktop
    echo "MultipleArgs=false">>/usr/share/applications/pms-linux.desktop
    echo "Type=Application">>/usr/share/applications/pms-linux.desktop
    echo "Encoding=UTF-8">>/usr/share/applications/pms-linux.desktop
    echo "Categories=System;Settings;">>/usr/share/applications/pms-linux.desktop
    chmod a+x /usr/share/applications/pms-linux.desktop  
  fi
  if [ -f "$PMS_INSTALL_TO/PMS.sh" ] ; then
      PROCEDIMENTO_EXECUTADO="OK"
      do_relatorio "$TAREFA [OK]"
  fi  
}

function do_flash() {
  TAREFA="Instalação do plugin flash 10"
  PROCEDIMENTO_EXECUTADO="FALHOU"

  do_apt_remove "flashplugin-installer libflashsupport flashplugin-nonfree gnash mozilla-plugin-gnash gnash-common gnash-cygnal gnash-tools"
  #do_apt_remove "swfdec-mozilla  flashplugin-nonfreebeta libflash-mozplugin"    
  if [ "$amd64" != "S" ] ; then
    do_apt_install "flashplugin-installer"
  else
    # Instalando o plugin 64bits
    do_repositorio "sevenmachines"
    do_apt_install "flashplugin64-installer" 
  fi

  # Verificando se o plugin 64bits ja esta instalado
  if [ "$APT_ERROR" != "S" ] ; then
    do_relatorio "$TAREFA [OK]"
    PROCEDIMENTO_EXECUTADO="OK"
  fi
}

function do_compiz() {
  # compiz e auxiliares
  TAREFA="Instalando compiz e seus componentes auxiliares"
  PROCEDIMENTO_EXECUTADO="FALHOU"
  do_apt_install "compizconfig-settings-manager  simple-ccsm gnome-art startupmanager emerald"

  if [ "$APT_ERROR" != "S" ] ; then
    do_relatorio "$TAREFA [OK]"
    PROCEDIMENTO_EXECUTADO="OK"
  fi   
}

function do_mandvd() {
  # ManDVD - programa de autoria de DVDs
  TAREFA="Instalando o ManDVD"
  PROCEDIMENTO_EXECUTADO="FALHOU"
  do_apt_install "mandvd"
  if [ -f "/usr/bin/mandvd" ] ; then
     PROCEDIMENTO_EXECUTADO="OK"
     do_relatorio "$TAREFA [OK]"    
  fi  
}

function do_parcellite() {
  # gerenciador de clipboard parcellite
  TAREFA="Instalando o parcellite"
  PROCEDIMENTO_EXECUTADO="FALHOU"
  do_apt_install "parcellite"
  if [ "$APT_ERROR" != "S" ] ; then
     PROCEDIMENTO_EXECUTADO="OK"
     do_relatorio "$TAREFA [OK]"    
  fi  
}

function do_amsn() {
  TAREFA="Instalar o aMSN"
  PROCEDIMENTO_EXECUTADO="FALHOU"
  do_repositorio "amsn-daily"
  do_apt_install "amsn docker libsnack2-doc tclreadline"

  if [ "$APT_ERROR" != "S" ] ; then
    zenity --notification --title="$TAREFA"  --text "O aMSN esta instalado, mas se voce quiser que ele seja carregado automaticamente no inicio da sessão, use o menu de serviços do Ubuntu Perfeito."&
    do_relatorio "$TAREFA [OK]"
    PROCEDIMENTO_EXECUTADO="OK"
    REQUER_MENU_SERVICOS="S"   
  fi
}

function do_biscoito_da_sorte() {
  # Biscoito da sorte
  PROCEDIMENTO_EXECUTADO="FALHOU"
  TAREFA="Instalando biscoito da sorte"
  if ! [ -f "/usr/games/fortune" ] ; then
      do_apt_install "fortune-mod fortunes fortunes-br"
  fi
  if [ -f "/usr/games/fortune" ] ; then
    EXISTE=`cat /etc/bash.bashrc |grep "/usr/games/fortune /usr/share/games/fortunes/brasil"|wc -l`
    if [ "$EXISTE" -eq "0" ] && [ -f "/usr/games/fortune" ] ; then
       RESPOSTA="N"
       [ "$SE_AUTOMATICO" = "S" ] && RESPOSTA="S"
       if [ "$RESPOSTA" != "S" ] ; then
          zenity --question --title="Instalar o biscoito da sorte?" \
             --text "Biscoito da sorte fornece frases engraçadas e pensamentos de diversas personalidades famosas para você refletir.\nToda vez que você logar-se no sistema, uma frase aleatória será exibida.\nGostaria de instalar o biscoito da sorte no inicio do sistema ?"
          [ $? -eq 0 ] && RESPOSTA="S"
       fi
       if [ "$RESPOSTA" = "S" ] ; then
        # verifica se a linha
        # /usr/games/fortune /usr/share/games/fortunes/brasil
        # ja foi incluida em /etc/bash.bashrc
        EXISTE=`cat /etc/bash.bashrc |grep "/usr/games/fortune /usr/share/games/fortunes/brasil"|wc -l`
        if [ "$EXISTE" -eq "0" ] && [ -f "/usr/games/fortune" ] ; then
          echo "#!/bin/bash" >/usr/bin/texto_do_dia.sh 
          echo "# Biscoito da sorte" >>/usr/bin/texto_do_dia.sh      
          echo "zenity --info --title \"Texto do dia :\" --text \"\$(/usr/games/fortune /usr/share/games/fortunes/brasil)\"&" >>/usr/bin/texto_do_dia.sh 
          chmod a+x /usr/bin/texto_do_dia.sh
          # atalho para autostart
          echo "[Desktop Entry]">/etc/xdg/autostart/texto_do_dia.desktop
          echo "Type=Application">>/etc/xdg/autostart/texto_do_dia.desktop
          echo "Name=Pensamento do dia">>/etc/xdg/autostart/texto_do_dia.desktop
          echo "Exec=/usr/bin/texto_do_dia.sh">>/etc/xdg/autostart/texto_do_dia.desktop
          echo "Icon=system-run">>/etc/xdg/autostart/texto_do_dia.desktop
          echo "Comment=Pensamento do dia">>/etc/xdg/autostart/texto_do_dia.desktop
          echo "X-GNOME-Autostart-enabled=true">>/etc/xdg/autostart/texto_do_dia.desktop
        fi
      fi
    fi
  fi
  
  # conferindo se foi instalado corretamente  
  if [ -f "/usr/games/fortune" ] && [ -f "/usr/bin/texto_do_dia.sh" ] ; then  
     PROCEDIMENTO_EXECUTADO="OK"
     do_relatorio "$TAREFA [OK]"
  fi
}

function do_descompactadores() {
  # descompactadores
  PROCEDIMENTO_EXECUTADO="FALHOU"
  TAREFA="Instalando compactadores/descompactadores de formatos populares"

  do_apt_install "unace rar unrar zip unzip p7zip-full p7zip-rar sharutils uudeview mpack lha arj cabextract file-roller zoo"
  if [ "$APT_ERROR" != "S" ] ; then
    do_relatorio "$TAREFA [OK]"
    PROCEDIMENTO_EXECUTADO="OK"
  fi
}

function do_google_picasa() {
  # descompactadores
  PROCEDIMENTO_EXECUTADO="FALHOU"
  TAREFA="Instalando gerenciador de albuns de fotos Picasa"

  if ! [ -f "/usr/bin/picasa" ] ; then
    if [ "$amd64" = "N" ] ; then
      DOWNLOAD_URL="http://dl.google.com/linux/deb/pool/non-free/p/picasa/picasa_3.0-current_i386.deb"
    else
      DOWNLOAD_URL="http://dl.google.com/linux/deb/pool/non-free/p/picasa/picasa_3.0-current_amd64.deb"
    fi
    DOWNLOAD_AS=`basename $DOWNLOAD_URL`
    do_download "$DOWNLOAD_URL"
    if [ -f "$PASTA_TMP/$DOWNLOAD_AS" ] ; then
      do_cmd_exec "$DPKG_INSTALL $PASTA_TMP/$DOWNLOAD_AS "
    fi
	fi

  if [ -f "/usr/bin/picasa" ] ; then
    do_relatorio "$TAREFA [OK]"
    PROCEDIMENTO_EXECUTADO="OK"
  fi
}

function do_descarregar_oo3_vero() {
	#
	# Extensão Vero (corretor ortografico) para [Br]OpenOffice-3
	# sudo /opt/broffice.org3/program/unopkg add -f --shared /local/do/pacote
	#
  PROCEDIMENTO_EXECUTADO="FALHOU"
	TAREFA="Extensão Vero, verificador ortográfico contemplando os ajustes do Acordo Ortográfico para BR/OpenOffice-3"
	OOO_PATH=""
	[ -d "/usr/lib/openoffice" ] && OOO_PATH="/usr/lib/openoffice"
	[ -d "/opt/broffice.org3" ] && OOO_PATH="/opt/broffice.org3"

	if [ "$OOO_PATH" = "" ] ; then
	  zenity --error --title="Atenção :" --text "O openoffice.org não foi encontrado em seu sistema"
    return
	fi

	#
	# Corretor Ortografico Vero
	# http://www.deso-se.com.br/downloads/broffice.org/Vero_pt_BR_V200AOC.oxt
	#
	TAREFA="Extensão Vero (Verificador Ortográfico contemplando os ajustes do Acordo Ortográfico) para [Br]OpenOffice-3"
  DOWNLOAD_URL="http://www.broffice.org/files/Vero_pt_BR_V207AOC.oxt"
  DOWNLOAD_AS=`basename $DOWNLOAD_URL`
  do_download "$DOWNLOAD_URL"
	if [ -s "$PASTA_TMP/$DOWNLOAD_AS" ] ; then
	   UNOPKG="$OOO_PATH/program/unopkg"
	   [ -f "$PASTA_TMP/$DOWNLOAD_AS" ] && do_cmd_exec "$UNOPKG add -f --shared $PASTA_TMP/$DOWNLOAD_AS"
  else 
     return
	fi
  # confere se tudo foi instalado
	SE_INSTALADO_VERO=`find $OOO_PATH/share/uno_packages/cache/uno_packages -name $DOWNLOAD_AS|wc -l`
	if [ "$SE_INSTALADO_VERO" -gt 0 ] ; then	
    PROCEDIMENTO_EXECUTADO="OK"
    do_relatorio "$TAREFA [OK]"	
  fi
}

function do_descarregar_oo3_cogroo() {
	#
	# Extensão Cogroo (corretor gramatical) para [Br]OpenOffice-3
	# sudo /opt/broffice.org3/program/unopkg add -f --shared /local/do/pacote
	#
  PROCEDIMENTO_EXECUTADO="FALHOU"
	TAREFA="Extensão Cogroo, corretor gramatical para BR/OpenOffice-3"
	OOO_PATH=""
	[ -d "/usr/lib/openoffice" ] && OOO_PATH="/usr/lib/openoffice"
	[ -d "/opt/broffice.org3" ] && OOO_PATH="/opt/broffice.org3"

	if [ "$OOO_PATH" = "" ] ; then
	  zenity --error --title="Atenção :" --text "O openoffice.org não foi encontrado em seu sistema"
    return
	fi

  do_apt_install "openoffice.org-java-common"
  if  ! [ -e "/usr/share/doc/openoffice.org-java-common" ] ; then
	  zenity --error --title="Atenção :" --text "O pacote [openoffice.org-java-common] nao pode ser instalado e ele é obrigatório para o funcionamento da extensão Cogroo. Faça a instalação manualmente."
    return
  fi
  DOWNLOAD_URL="http://downloads.sourceforge.net/cogroo/CoGrOO-AddOn-3.0.5-bin.oxt"
  DOWNLOAD_AS=`basename $DOWNLOAD_URL`
  do_download "$DOWNLOAD_URL"
	if [ -s "$PASTA_TMP/$DOWNLOAD_AS" ] ; then
	   UNOPKG="$OOO_PATH/program/unopkg"
	   [ -f "$PASTA_TMP/$DOWNLOAD_AS" ] && do_cmd_exec "$UNOPKG add -f --shared $PASTA_TMP/$DOWNLOAD_AS"
  else 
     return
	fi

  # confere se tudo foi instalado
	SE_INSTALADO_COGROO=`find $OOO_PATH/share/uno_packages/cache/uno_packages -name $DOWNLOAD_AS|wc -l`
	if [ "$SE_INSTALADO_COGROO" -gt 0 ] ; then	
    PROCEDIMENTO_EXECUTADO="OK"
    do_relatorio "$TAREFA [OK]"	
  fi
}

function do_descarregar_oo3_pdf() {
	#
	# Extensão ImportPDF para [Br]OpenOffice-3
	# sudo /opt/broffice.org3/program/unopkg add -f --shared /local/do/pacote
	#
  PROCEDIMENTO_EXECUTADO="FALHOU"
	TAREFA="Extensão import_pdf, editor de PDFs para BR/OpenOffice-3"
	OOO_PATH=""
	[ -d "/usr/lib/openoffice" ] && OOO_PATH="/usr/lib/openoffice"
	[ -d "/opt/broffice.org3" ] && OOO_PATH="/opt/broffice.org3"

	if [ "$OOO_PATH" = "" ] ; then
	  zenity --error --title="Atenção :" --text "O openoffice.org não foi encontrado em seu sistema"
    return
	fi

	zenity --title="Atenção :" --info --text "Vou instalar extensão ImportPDF (editor de PDFs) para o [Br]OpenOffice-3.\nAlgumas dessas extensões requerem a leitura de algum tipo de contrato que aparecerá na janela, quando isso ocorrer apenas leia o texto e no final digite sim(ou yes, se estiver em inglês) e pressione [ENTER].\nEm outras oportunidades é requerido apenas que se pressione [ENTER] para avançar de linha até o final.\nMuitos acharam que o script travou quando na realidade estava esperando por uma assistência na instalação dessa extensão."


	TAREFA="Extensão ImportPDF (Editor de PDF) para [Br]OpenOffice-3"
  DOWNLOAD_URL="http://extensions.services.openoffice.org/e-files/874/27/sun-pdfimport.oxt"
  [ "$amd64" = "S" ] && DOWNLOAD_URL="http://extensions.services.openoffice.org/e-files/874/28/sun-pdfimport.oxt"
  DOWNLOAD_AS=`basename $DOWNLOAD_URL`
  do_download "$DOWNLOAD_URL"
	if [ -s "$PASTA_TMP/$DOWNLOAD_AS" ] ; then
	   UNOPKG="$OOO_PATH/program/unopkg"
	   [ -f "$PASTA_TMP/$DOWNLOAD_AS" ] && do_cmd_exec "$UNOPKG add -f --shared $PASTA_TMP/$DOWNLOAD_AS"
  else 
     return
	fi

  # confere se tudo foi instalado
	SE_INSTALADO_PDF=`find $OOO_PATH/share/uno_packages/cache/uno_packages -name $DOWNLOAD_AS|wc -l`
	if [ "$SE_INSTALADO_PDF" -gt 0 ] ; then	
    PROCEDIMENTO_EXECUTADO="OK"
    do_relatorio "$TAREFA [OK]"	
  fi
}

function do_descarregar_oo3_dicsin() {
	#
	# Extensão Solver (calculos lineares) para [Br]OpenOffice-3
	# sudo /opt/broffice.org3/program/unopkg add -f --shared /local/do/pacote
	#
  PROCEDIMENTO_EXECUTADO="FALHOU"
	TAREFA="Extensão DicSin (dicionário de sinonimos) para BR/OpenOffice-3"
	OOO_PATH=""
	[ -d "/usr/lib/openoffice" ] && OOO_PATH="/usr/lib/openoffice"
	[ -d "/opt/broffice.org3" ] && OOO_PATH="/opt/broffice.org3"

	if [ "$OOO_PATH" = "" ] ; then
	  zenity --error --title="Atenção :" --text "O openoffice.org não foi encontrado em seu sistema"
    return
	fi

	#
	# Extensão DicSin (dicionário de sinonimos) para BR/OpenOffice-3
	#
	TAREFA="Extensão Dicsin (dicionário de sinonimos) para BR/OpenOffice-3"
  DOWNLOAD_URL="http://www.dicsin.com.br/content/DicSin-BR.oxt"
  DOWNLOAD_AS=`basename $DOWNLOAD_URL`
  do_download "$DOWNLOAD_URL"
	if [ -s "$PASTA_TMP/$DOWNLOAD_AS" ] ; then
	   UNOPKG="$OOO_PATH/program/unopkg"
	   [ -f "$PASTA_TMP/$DOWNLOAD_AS" ] && do_cmd_exec "$UNOPKG add -f --shared $PASTA_TMP/$DOWNLOAD_AS"
  else 
     return
	fi

  # confere se tudo foi instalado
	SE_INSTALADO_DICSIN=`find $OOO_PATH/share/uno_packages/cache/uno_packages -name $DOWNLOAD_AS|wc -l`
	if [ "$SE_INSTALADO_DICSIN" -gt 0 ] ; then	
    PROCEDIMENTO_EXECUTADO="OK"
    do_relatorio "$TAREFA [OK]"	
  fi
}

function do_backup() {
	#
	# Frontend grafico para configurar firewall
	#
  PROCEDIMENTO_EXECUTADO="FALHOU"
	TAREFA="Instalando frontend para Backup"
  instalar=""
  # programas para edição, backup e acesso a varios tipos de particoes de disco
  instalar="ntfsprogs ntfs-config"
  [ "$amd64" != "S" ] && instalar="$instalar partimage"
  instalar="$instalar gparted"
  # Programa para backup e/ou sincronizar pastas
  instalar="$instalar grsync"
  # Recuperar arquivos ou particoes excluidas
  instalar="$instalar testdisk"
  # formatador de pendrive
  instalar="$instalar gnome-format"
  # ferramentas para comparar arquivos/diretorios
  instalar="$instalar meld diff-ext"
  # Todo : criar atalhos para o testdisk e photorec
  instalar="$instalar testdisk"
  do_apt_install "$instalar"

  if [ "$APT_ERROR" != "S" ] ; then
    do_relatorio "$TAREFA [OK]"
    PROCEDIMENTO_EXECUTADO="OK"
  fi
}

function do_seguranca() {
	#
	# Frontend grafico para configurar firewall
	#
  PROCEDIMENTO_EXECUTADO="FALHOU"
	TAREFA="Instalando programas de seguranca avancada"
  instalar=""
  do_repositorio "ubuntu-clamav"

  # Firewall com frontend grafico
  instalar="$instalar gufw"
  zenity --notification --title="$TAREFA [OK]" --text "Para aprender como configurar um firewall visualmente, visite estas páginas :http://andregondim.eti.br/?p=504 (portugues) e http://www.ubuntugeek.com/gufw-simple-gui-for-ufw-uncomplicated-firewall.html (ingles)" &
  # programas para edição, backup e acesso a varios tipos de particoes de disco
  instalar="$instalar ntfsprogs ntfs-config"
  instalar="$instalar gparted"
  # Edicao visual do /etc/fstab
  instalar="$instalar pysdm"
  
	#
	# Antivirus
	#
  instalar="$instalar clamav clamav-daemon clamtk nautilus-clamscan"

  do_apt_install "$instalar"

  if [ "$APT_ERROR" != "S" ] ; then
    do_relatorio "$TAREFA [OK]"
    PROCEDIMENTO_EXECUTADO="OK"
  fi
}

function do_escritorio_estendido() {
  # descompactadores
  PROCEDIMENTO_EXECUTADO="FALHOU"
  TAREFA="Instalando mais programas de escritório"
  do_repositorio "dreibh"
  do_apt_install "inkscape dia-gnome tesseract-ocr tesseract-ocr-por gscan2pdf " 
	DOWNLOAD_URL="http://ufpr.dl.sourceforge.net/project/tesseract-gui/tesseract-gui/deb%20packages/tesseract-gui_2.7-2_all.deb"
	DOWNLOAD_AS=`basename $DOWNLOAD_URL`
	do_download "$DOWNLOAD_URL"
	if [ -f "$PASTA_TMP/$DOWNLOAD_AS" ] ; then
	   do_cmd_exec "$DPKG_INSTALL $PASTA_TMP/$DOWNLOAD_AS "
	fi
  if [ "$APT_ERROR" != "S" ] ; then
    do_notificar "Importante :" "Foram instalados programas para criação de fluxogramas e vetoriais e tambem um OCR acopanhado de front-ends, inclusive um OCR para arquivos PDF."
    do_relatorio "$TAREFA [OK]"
    PROCEDIMENTO_EXECUTADO="OK"
  fi
}

function do_remaster_ubuntu() {
  # Instalando o RemasterSYS
  TAREFA="Instalando ferramentas de remasterização do Ubuntu"
  PROCEDIMENTO_EXECUTADO="FALHOU"
f
  # O repositório RemasterSYS insistentemente não ofereceu chave/assinatura de seus pacotes
  # Assim, é considerado um risco manter o repositório, pois um cracker que invadisse o site
  # e colocasse um pseudo-pacote 'apache' com versão considerada atualização susbstituiria 
  # todos os apaches de distros com esse repositório, além disso, o próprio pacote do 
  # remastersys pode ser crackeado, assim até a própria instalação do remastersys é
  # um risco calculado. Diante desses motivos, após ter instalado o remastersys vou remover
  # o seu repositório para nunca mais ser usado novamente, a menos que peça para instala-lo
  # novamente de forma explicita pelo Ubuntu Perfeito.
  # Sem o repositório é ruim porque novas atualizacoes do remastersys nao estarao disponiveis, 
  # mas é bom  porque diminui a chance de ver nosso desktop crackeado. 
  # 
  unset files
  files=( "${files[@]}" "/usr/bin/unetbootin" )
  files=( "${files[@]}" "/usr/bin/remastersys-gui" )
  files=( "${files[@]}" "/usr/share/doc/unetbootin-translations" )

  DOWNLOAD_URL="http://ufpr.dl.sourceforge.net/project/remastersys/remastersys-ubuntu-karmic-lucid/remastersys_2.0.17-1_all.deb"
	DOWNLOAD_AS=`basename $DOWNLOAD_URL`
	do_download "$DOWNLOAD_URL"
	if [ -f "$PASTA_TMP/$DOWNLOAD_AS" ] ; then
	  do_cmd_exec "$DPKG_INSTALL $PASTA_TMP/$DOWNLOAD_AS "
	fi
  do_apt_install "unetbootin unetbootin-translations"

  # conferindo se todos os pacotes requeridos foram instalados
  ERRO="N"
  for test_file in "${files[@]}" ; do    
    if ! [ -e "$test_file" ] ; then
      ERRO="S"
      zenity --error --title="Problema :" \
              --text "Parece que o arquivo :\n\t$test_file\nnão foi instalado.\nEle pertence a algum pacote que é instalado neste procedimento, procure saber a que pacote ele pertence e instale-o manualmente e notifique o autor do script perfeito. Por causa deste erro, infelizmente essa tarefa não poderá ser concluída."
    fi
  done

  if [ "$ERRO" = "N" ] ; then
    do_relatorio "$TAREFA [OK]"
    PROCEDIMENTO_EXECUTADO="OK"
  fi
}

function do_adobe_reader() {
  # Apesar de haver outros leitores de PDF, o Adobe Reader é o unico a ler
  # PDFs protegidos por DRM
  PROCEDIMENTO_EXECUTADO="FALHOU" 
  TAREFA="Instalando o Adobe Reader"
  RESPOSTA="N"
  [ "$SE_AUTOMATICO" = "S" ] && RESPOSTA="S"
  if [ "$amd64" = "S" ] && [ "$RESPOSTA" != "S" ]; then
    zenity --question --title="Instalação do Adobe Reader :" --text "Infelizmente por este script só é possivel instalar o Adobe Reader 32bits.\nSeu sistema é 64bits, mas rodaria o Acrobat Reader 32bits, mas seria impossivel desinstala-lo depois usando o Synaptic.\nGostaria de instalar o Adobe Reader 32bits assim mesmo?"
    [ $? -eq 0 ] && RESPOSTA="S"
    [ "$RESPOSTA" != "S" ] && return
  fi

  files=( "${files[@]}" "/usr/bin/acroread" )
  DOWNLOAD_URL="http://ardownload.adobe.com/pub/adobe/reader/unix/8.x/8.1.7/ptb/AdobeReader_ptb-8.1.7-1.i386.deb"

  DOWNLOAD_AS=`basename $DOWNLOAD_URL`
  do_download "$DOWNLOAD_URL"
  if [ -f "$PASTA_TMP/$DOWNLOAD_AS" ] ; then
      # O adobe reader nao aparece no synaptic depois de instalado por se tratar duma versão 32bits num sistema 64 bits
      # Assim, precisamos fazer a remoção manualmente com os comandos :
      # dpkg -S [pacote] para procurar o pacote, e:
      # dpkg -r [pacote] para remove-lo
      do_cmd_exec "/usr/bin/dpkg -r adobereader-ptb"
      do_cmd_exec "/usr/bin/dpkg -r adobereader-enu"
      do_cmd_exec "/usr/bin/dpkg -i --force-architecture $PASTA_TMP/$DOWNLOAD_AS"
  fi

  # conferindo se todos os pacotes requeridos foram instalados
  ERRO="N"
  for test_file in "${files[@]}" ; do    
    if ! [ -e "$test_file" ] ; then
      ERRO="S"
      zenity --error --title="Problema :" \
              --text "Parece que o arquivo :\n\t$test_file\nnão foi instalado.\nEle pertence a algum pacote que é instalado neste procedimento, procure saber a que pacote ele pertence e instale-o manualmente e notifique o autor do script perfeito. Por causa deste erro, infelizmente essa tarefa não poderá ser concluída."
    fi
  done

  if [ "$ERRO" = "N" ] ; then
   do_fileopenpdf
   [ "$PROCEDIMENTO_EXECUTADO" = "FALHOU" ] && ERRO = "S"
  fi

  if [ "$ERRO" = "N" ] ; then
    do_relatorio "$TAREFA [OK]"
    PROCEDIMENTO_EXECUTADO="OK"
    [ "$MODO_TAGARELA" = "S" ] && $SPEAK "Adobe Reader instalado"& 
  fi
}

function do_fileopenpdf() {
  # FileOpenPDF Plugin para visualizar PDF protegidos por DRM que são comprados em forma de e-books pela internet
  # Requer como dependencia o Acrobat Reader 8
  PROCEDIMENTO_EXECUTADO="FALHOU"
  TAREFA="Instalando o plugin para Adobe Reader chamado FileOpenPDF responsavel por visualizar PDFs protegidos por DRM"
  ACROREAD8_DEST_FOLDER=""
  ACROREAD9_DEST_FOLDER=""
  # procurando pelo Reader 8
  if [ -f "/opt/Adobe/Reader8/bin/acroread" ] && [ "$ACROREAD8_DEST_FOLDER" = "" ] ; then
     ACROREAD8_DEST_FOLDER="/opt/Adobe/Reader8"
  fi
  if [ -f "/usr/lib/Adobe/Reader8/bin/acroread" ] && [ "$ACROREAD8_DEST_FOLDER" = "" ] ; then
     ACROREAD8_DEST_FOLDER="/usr/lib/Adobe/Reader8"
  fi
  if [ -f "/usr/lib32/Adobe/Reader8/bin/acroread" ] && [ "$ACROREAD8_DEST_FOLDER" = "" ] ; then
     ACROREAD8_DEST_FOLDER="/usr/lib32/Adobe/Reader8"
  fi

  # procurando pelo Reader 9
  if [ -f "/opt/Adobe/Reader9/bin/acroread" ] && [ "$ACROREAD9_DEST_FOLDER" = "" ] ; then
     ACROREAD9_DEST_FOLDER="/opt/Adobe/Reader9"
  fi

  if [ -f "/usr/lib/Adobe/Reader9/bin/acroread" ] && [ "$ACROREAD9_DEST_FOLDER" = "" ] ; then
     ACROREAD9_DEST_FOLDER="/usr/lib/Adobe/Reader8"
  fi

  if [ -f "/usr/lib32/Adobe/Reader9/bin/acroread" ] && [ "$ACROREAD9_DEST_FOLDER" = "" ] ; then
     ACROREAD9_DEST_FOLDER="/usr/lib32/Adobe/Reader8"
  fi

  PLUGIN_FILE8="$ACROREAD8_DEST_FOLDER/Reader/intellinux/plug_ins/FileOpen.api"
  PLUGIN_FILE9="$ACROREAD9_DEST_FOLDER/Reader/intellinux/plug_ins/FileOpen.api"
  if [ -f "$PLUGIN_FILE8" ] && [ -f "$PLUGIN_FILE9" ]; then
     PROCEDIMENTO_EXECUTADO="OK"
     do_relatorio "$TAREFA [OK]"  
     return
  fi

  # instalando o plugin
  DOWNLOAD_URL="http://plugin.fileopen.com/current/FileOpenInstaller.tar.gz"
  DOWNLOAD_AS=`basename $DOWNLOAD_URL`
  do_download "$DOWNLOAD_URL"
  if [ -f "$PASTA_TMP/$DOWNLOAD_AS" ] ; then
     do_descompactar "$PASTA_TMP/FileOpenInstaller.tar.gz" "$PASTA_TMP"
     if ! [ -f "$PASTA_TMP/FileOpenInstaller/FileOpen.AR8.api" ] ; then
          zenity --error --title="Problema :" --text "Não encontrei o arquivo descompactado $PASTA_TMP/FileOpenInstaller/FileOpen.AR8.api.\nSem ele, é impossivel prosseguir a instalação do plugin FileOpenPDF."
          return 2
     else
        if [ "$PLUGIN_FILE8" != "" ] ; then
          cp -vf "$PASTA_TMP/FileOpenInstaller/FileOpen.AR8.api" "$PLUGIN_FILE8"
        fi
        if [ "$PLUGIN_FILE9" != "" ] ; then
          cp -vf "$PASTA_TMP/FileOpenInstaller/FileOpen.AR8.api" "$PLUGIN_FILE9"
        fi
     fi

     # removendo a pasta descomprimida :
     [ -d "$PASTA_TMP/FileOpenInstaller" ] && rm -fR "$PASTA_TMP/FileOpenInstaller"
  fi   

  # conferindo se todos os pacotes requeridos foram instalados
  if [ -f "$PLUGIN_FILE8" ] || [ -f "$PLUGIN_FILE9" ]  ; then
     PROCEDIMENTO_EXECUTADO="OK"
     do_relatorio "$TAREFA [OK]"  
  else
     zenity --error --title="Problema :" --text "Parece que o arquivo :\n\t$PLUGIN_FILE8\n$PLUGIN_FILE9\nnão foi instalado.\nEle é obtido da URL :\n$DOWNLOAD_URL\nque é instalado neste procedimento, instale-o manualmente e notifique o autor do script perfeito. Por causa deste erro, infelizmente essa tarefa não poderá ser concluída."
  fi
}

function do_google_chrome() {
  # Google Chrome esta disponivel em forma de pre-alfa
  # ainda ha muitos bugs e portanto desaconselhavel em
  # ambientes de producao
  PROCEDIMENTO_EXECUTADO="FALHOU"
  TAREFA="Instalando o Google Chrome"
  if ! [ -f "/usr/bin/google-chrome" ] ; then
    if [ "$amd64" = "S" ] ; then
      DOWNLOAD_URL="http://dl.google.com/linux/direct/google-chrome-stable_current_amd64.deb"
    else
      DOWNLOAD_URL="http://dl.google.com/linux/direct/google-chrome-stable_current_i386.deb"
    fi
    DOWNLOAD_AS=`basename $DOWNLOAD_URL`
    do_download "$DOWNLOAD_URL"
    if [ -f "$PASTA_TMP/$DOWNLOAD_AS" ] ; then
       do_cmd_exec "$DPKG_INSTALL $PASTA_TMP/$DOWNLOAD_AS ;"
    fi
    [ "$MODO_TAGARELA" = "S" ] && $SPEAK "Google Chrome instalado"& 
  fi

  if [ -f "/usr/bin/google-chrome" ] ; then
    PROCEDIMENTO_EXECUTADO="OK"
    do_relatorio "$TAREFA [OK]"
  fi
}

function do_wine() {
  # WINE é vital para aqueles que desejam instalar programas do mswindows
  # no linux, mas, antes de instalar um programa do mswindwos é aconselhavel
  # verificar a página : http://appdb.winehq.org/
  # e conferir se o programa pretendido rodará realmente no linux
  PROCEDIMENTO_EXECUTADO="FALHOU"
  TAREFA="Instalando o WINE ultima versão"
  do_repositorio "ubuntu-wine"
  [ "$MODO_TAGARELA" = "S" ] && $SPEAK "$TAREFA"& 

  if ! [ -f /usr/bin/wine ] ; then
    #do_apt_install "wine"
    do_apt_install "wine1.2"
  fi
  if [ -f /usr/bin/wine ] ; then
    PROCEDIMENTO_EXECUTADO="OK"
    do_relatorio "$TAREFA [OK]"
  fi  
}

function do_mscorefonts() {
  # Fontes : msttcorefonts
  TAREFA="Instalando fontes msttcorefonts"
  PROCEDIMENTO_EXECUTADO="FALHOU"
  if ! [ -d "/usr/share/fonts/truetype/msttcorefonts" ] ; then
     RESPOSTA="N"
     [ "$SE_AUTOMATICO" = "S" ] && RESPOSTA="S"
     if [ "$RESPOSTA" != "S" ] ; then
        zenity --question --title="Instalação de fontes"  --text "As fontes microsoftianas não é um requisito básico de sistema,\nmas se voce espera ver trabalhos exatamente iguais no Windows e no Linux então é recomendada a sua instalação.\nGostaria de instalar a mscore-fonts?"
        [ $? -eq 0 ] && RESPOSTA="S"
     fi
     if [ "$RESPOSTA" = "S" ] ; then
        do_apt_install "ttf-mscorefonts-installer"
		    if [ "$APT_ERROR" != "S" ] ; then
		       do_relatorio "$TAREFA [OK]"
		       PROCEDIMENTO_EXECUTADO="OK"
		    fi
     fi
  else
	  do_relatorio "$TAREFA [OK]"
	  PROCEDIMENTO_EXECUTADO="OK"  
  fi
}

function do_fontes() {
  PROCEDIMENTO_EXECUTADO="FALHOU"

  # Fontes : outras
  TAREFA="Instalando muitas outras fontes"
  instalar=""
  instalar="$instalar ttf-larabie-straight ttf-larabie-deco mplayer-fonts xfonts-terminus-dos"
  instalar="$instalar xfonts-terminus xfonts-terminus-oblique xfonts-mona tv-fonts ttf-tuffy"
  instalar="$instalar ttf-sjfonts ttf-sil-padauk ttf-sil-ezra ttf-paktype ttf-georgewilliams"
  instalar="$instalar ttf-fifthhorseman-dkg-handwriting ttf-farsiweb ttf-essays1743 ttf-opensymbol"
  instalar="$instalar ttf-nafees ttf-mgopen ttf-freefont ttf-dustin ttf-devanagari-fonts"
  instalar="$instalar ttf-dejavu-extra ttf-dejavu-core ttf-dejavu ttf-bpg-georgian-fonts ttf-alee"
  do_apt_install "$instalar"

  if [ "$APT_ERROR" != "S" ] ; then
     do_relatorio "$TAREFA [OK]"
     PROCEDIMENTO_EXECUTADO="OK"
  fi

}

function do_gnomesubtitles() {
  TAREFA="Instalando o editor de legendas gnome-subtitles"
  PROCEDIMENTO_EXECUTADO="FALHOU"
  do_apt_install "gnome-subtitles libmono-i18n2.0-cil"
  if [ "$APT_ERROR" != "S" ] ; then
    do_relatorio "$TAREFA [OK]"
    PROCEDIMENTO_EXECUTADO="OK"
  fi
}

function do_codecs() {
  PROCEDIMENTO_EXECUTADO="FALHOU"
	TAREFA="Instalando bibliotecas comuns para multimedia"
	DVD_COPY="N"

  # atualiza o repositorio medibuntu
  do_repositorio "medibuntu" 
  
  # removidos : libsnack2 libmpcdec3 libquicktime1 libmpeg2-4 uudeview
  instalar="" 
  instalar="$instalar ubuntu-restricted-extras" 
  instalar="$instalar gstreamer-tools gstreamer0.10-sdl"
  instalar="$instalar mpeg2dec vorbis-tools id3v2 mpg321 mpg123 ffmpeg libmp4v2-0"
  instalar="$instalar id3tool lame libjpeg-progs  flac faac faad sox"
  instalar="$instalar ffmpeg2theora libmpeg3-1  mpegdemux x264"

  # Moonlight
  # desabilitado porque traz problemas com o firefox 3.6
  #instalar="$instalar moonlight-plugin-core moonlight-plugin-mozilla"

  do_apt_install "$instalar"
  if [ "$APT_ERROR" = "S" ] ; then
    do_relatorio "$TAREFA [FALHOU]"
    PROCEDIMENTO_EXECUTADO="FALHOU"
    return
  fi
	
	# W32codecs ou W64codecs deve ser instalado, pacotes exclusivos do medibuntu
  instalar="w32codecs" 
	[ "$amd64" = "S" ] && instalar="w64codecs"
  [ "$DVD_COPY" = "S" ]  instalar="$instalar libdvdcss2" 
  do_apt_install "$instalar"
  if [ "$APT_ERROR" != "S" ] ; then
     [ -f "/usr/share/doc/libdvdread4/install-css.sh" ] && do_cmd_exec "/usr/share/doc/libdvdread4/install-css.sh" 
     do_relatorio "$TAREFA [OK]"
     PROCEDIMENTO_EXECUTADO="OK"
  fi    
}

function do_realplayer(){
  PROCEDIMENTO_EXECUTADO="FALHOU"
	TAREFA="Instalando o tocador Realplayer"
  RESPOSTA="N"
  [ "$SE_AUTOMATICO" = "S" ] && RESPOSTA="S"
  if [ "$RESPOSTA" != "S" ] ; then
     zenity --question --title="$TAREFA"  --text "Há muitos outros tocadores que exibem o formato RMVB de forma melhor que o Realplayer, por exemplo, o VLC e o MPLayer.\nO RealPlayer funciona de forma assustadoramente instável a ponto de recomendar que você use outro tocador.\nGostaria de instalar mesmo o RealPlayer ?"
    [ $? -eq 0 ] && RESPOSTA="S"
  fi
  if [ "$RESPOSTA" != "S" ] ; then
    return
  fi

  # atualiza o repositorio medibuntu
  do_repositorio "medibuntu" 
  do_apt_install "gecko-mediaplayer realplayer"

  if [ "$APT_ERROR" != "S" ] ; then
    do_relatorio "$TAREFA [OK]"
    PROCEDIMENTO_EXECUTADO="OK"
  fi	
}

function do_vlc(){
	TAREFA="Instalando o tocador multiformatos VLC e plugins relacionados"
	PROCEDIMENTO_EXECUTADO="FALHOU"
  do_apt_install "vlc vlc-nox vlc-plugin-sdl"

  if [ "$APT_ERROR" != "S" ] ; then
    do_relatorio "$TAREFA [OK]"
    PROCEDIMENTO_EXECUTADO="OK"
  fi

}

function do_mono_remove(){
	TAREFA="Removendo Mono do Sistema"
	PROCEDIMENTO_EXECUTADO="FALHOU"
	do_apt_remove "mono-runtime tomboy f-spot"
  if [ "$APT_ERROR" = "S" ] ; then
    do_notificar "Falha:" "Não foi possivel remover o Mono do seu sistema."
    return
  fi

  do_apt_install "gnote shotwell"

  if [ "$APT_ERROR" != "S" ] ; then
    do_notificar "Sucesso :" "O mono foi removido. O gnote substitui o tomboy e o shotwell substitui o f-spot, ambos estao instalados no seu sistema."
    do_relatorio "$TAREFA [OK]"
    PROCEDIMENTO_EXECUTADO="OK"
  fi

}

function do_winff() {
	PROCEDIMENTO_EXECUTADO="FALHOU"
  TAREFA="Acrescentando repositorio WinFF"

  RESPOSTA="N"
  [ "$SE_AUTOMATICO" = "S" ] && RESPOSTA="S"

  if [ -f "/usr/lib64/firefox-addons/plugins/libflashplayer.so" ] ; then
     [ "$RESPOSTA" != "S" ] && zenity --error --title="Problema :" \
              --text "Parece que o plugin flash (64bits) :\n\t/usr/lib64/firefox-addons/plugins/libflashplayer.so\nestá instalado.\nA instalacao do WinFF vai fazer com que o sistema reinstale o flash 32bits.\nE isso é muito ruim para o seu sistema.\nAssim, é melhor não instalar o WinFF no seu sistema."&
     return
  fi

  do_repositorio "paul-climbing"

	TAREFA="Instalando o conversor de formatos WinFF"
	
	if ! [ -f "/usr/bin/winff" ] ; then
    if [ "$SE_AUTOMATICO" != "S" ] ; then
	     zenity --question --title="$TAREFA"  --text "O WinFF é um frontend para conversão de formatos, mas ele ainda é experimental e descarrega um rol enorme de outras bibliotecas.\nVoce quer realmente instala-lo ?"
       [ $? -eq 0 ] && RESPOSTA="S"
    fi
	  [ "$RESPOSTA" = "S" ] && do_apt_install "winff"
	fi

	if [ -f "/usr/bin/winff" ] ; then
	  do_relatorio "$TAREFA [OK]"
	  PROCEDIMENTO_EXECUTADO="OK"
	fi
}

function do_mplayer() {
	TAREFA="Instalando o tocador multiformatos MPlayer"
	PROCEDIMENTO_EXECUTADO="FALHOU"

  do_apt_install "mplayer mplayer-fonts mplayer-skins mencoder"
  if [ "$APT_ERROR" != "S" ] ; then
    do_relatorio "$TAREFA [OK]"
    PROCEDIMENTO_EXECUTADO="OK"
  fi
}

function do_multimedia() {
	# Multimidia
	TAREFA="Instalando tocadores e utilitarios multimedia"
  PROCEDIMENTO_EXECUTADO="FALHOU"
  instalar="rhythmbox-plugins"
  instalar="$instalar xine-plugin gxineplugin xine-ui gxine totem-xine"
  instalar="$instalar totem-plugins totem-plugins-extra"
  instalar="$instalar vlc vlc-nox vlc-plugin-sdl"
  instalar="$instalar cdrdao vcdimager mjpegtools transcode movixmaker-2 normalize-audio"
  instalar="$instalar mp3gain avidemux nautilus-script-audio-convert tagtool easytag assogiate subdownloader"
  instalar="$instalar gecko-mediaplayer"

  do_apt_install "$instalar"
	#################################################
	# criando um atalho para o gstreamer-properties #
	#################################################
	cat > "/usr/share/applications/gstreamer-properties.desktop" <<END
[Desktop Entry]
Name=Seletor multimedia do sistema
Comment=Configure o padrão para as aplicações que usam o gstreamer
Exec=gstreamer-properties
Icon=gstreamer-properties
StartupNotify=true
Terminal=false
NoDisplay=false
Type=Application
Categories=GNOME;GTK;Settings;HardwareSettings;
X-GNOME-Bugzilla-Bugzilla=GNOME
X-GNOME-Bugzilla-Product=gnome-media
X-GNOME-Bugzilla-Component=gstreamer-properties
X-GNOME-Bugzilla-Version=2.28.1
X-Ubuntu-Gettext-Domain=gnome-media-2.0
END
	chmod 0755 "/usr/share/applications/gstreamer-properties.desktop"

  if [ "$APT_ERROR" != "S" ] ; then
    do_relatorio "$TAREFA [OK]"
    PROCEDIMENTO_EXECUTADO="OK"
  fi
}

function do_openshot() {
	# Multimidia
	TAREFA="Instalando programa para criacao de slideshow OpenShot"
	PROCEDIMENTO_EXECUTADO="FALHOU"
	do_repositorio "jonoomph"
  do_apt_install "openshot openshot-doc"
  if [ "$APT_ERROR" != "S" ] ; then
    do_relatorio "$TAREFA [OK]"
    PROCEDIMENTO_EXECUTADO="OK"
  fi
}

function do_cairo_dock() {
  #
	# Cairo-Dock
  # 
  PROCEDIMENTO_EXECUTADO="FALHOU"
  TAREFA="Instalando o cairo-dock e cairo-dock-plugins"
  do_repositorio "cairo-dock"
  instalar=""
  instalar="$instalar libglitz-glx1 libglitz1"
  instalar="$instalar cairo-dock cairo-dock-plug-ins cairo-dock-plug-ins-integration"
  do_apt_install "$instalar"
  if [ "$APT_ERROR" != "S" ] ; then
     do_relatorio "$TAREFA [OK]"
     PROCEDIMENTO_EXECUTADO="OK"
     zenity --notification --title="$TAREFA [OK]"  --text "Para testar o cairo-dock é necessário que o recurso chamado [compositing] esteja habilitado.\nVoce poderá utilizar o cairo-dock a partir do Menu Aplicações->Acessórios->Cairo Dock.\nTambém poderá usar o menu de serviços do Ubuntu Perfeito para ativa-lo diretamente na inicialização do sistema."&
  fi  
}

function do_inkscape() {
  #
	# Inkscape Night Build
  # 
  PROCEDIMENTO_EXECUTADO="FALHOU"
	TAREFA="Instalando o inkscape night build"
  do_repositorio "inkscape"
  instalar=""
  instalar="$instalar inkscape"
  do_apt_install "$instalar"
  if [ "$APT_ERROR" != "S" ] ; then
     do_relatorio "$TAREFA [OK]"
     PROCEDIMENTO_EXECUTADO="OK"
     do_relatorio "$TAREFA [OK]"    
  fi  
}

function do_impressoras() {
	TAREFA="Instalando suporte melhorado a impressoras(inclui PDF)"
  PROCEDIMENTO_EXECUTADO="FALHOU"
  ERRO="N"
  EXISTE_GIMP="N"
  [ -e "/usr/bin/gimp" ] && EXISTE_GIMP="S"

  # pacote mtink foi removido porque sua instalacao nao pode ser automatica
  instalar=""
  instalar="$instalar foo2zjs hpijs-ppds hplip-gui openprinting-ppds-extra inkblot escputil cups-pdf"
  do_apt_install "$instalar"
  if [ "$APT_ERROR" != "S" ] ; then
    do_relatorio "$TAREFA [OK]"
    PROCEDIMENTO_EXECUTADO="OK"
  fi
  if [ "$EXISTE_GIMP" = "N" ] ; then
    do_apt_remove "gimp gimp-data gimp-help-en gimp-help libgimp-perl gimp-data-extras"
  fi
  # adicionando usuarios ao grupo lp
  do_menu_usuarios "$TAREFA" "$MSG"
  APPLY_USERS="$RETURN_VALUE"
  if ! [ -z "$APPLY_USERS" ] ; then
    for USER in $APPLY_USERS ; do
      adduser "$USER" lp
      do_relatorio "$TAREFA [$USER] [OK]"
    done
  fi

  if [ "$APT_ERROR" != "S" ] ; then
    do_relatorio "$TAREFA [OK]"
    PROCEDIMENTO_EXECUTADO="OK"
  fi
}

function do_java() {
	#
	# Java
	# 
  PROCEDIMENTO_EXECUTADO="FALHOU"
	TAREFA="Instalando Java"
  instalar=""
  EXISTE_POSTFIX="N"
  [ -e "/etc/init.d/postfix" ] && EXISTE_POSTFIX="S"

  unset files
  ERRO="N"
  # script para executar a instalacao do java
  java_temp=`mktemp`
  echo "#!/bin/bash" >>$java_temp
	if ! [ -f "/usr/lib/jvm/java-6-sun/jre/bin/java" ] ||
	   ! [ -f "/usr/lib/jvm/ia32-java-6-sun/jre/bin/java" ] ||
	   ! [ -f "/usr/lib/jvm/java-6-openjdk/jre/bin/java" ]  ; then
	  OPC_JAVA=`zenity --height=280 \
	        --list --radiolist \
	        --title "Qual java gostaria de instalar?" \
	        --text "Voce tem duas opcoes a seu dispor : sun-java e openjdk.\nO mais compátivel de todos é o sun-java, no entanto, ele não possui plugin para ambientes 64bits,\n enquanto o OpenJDK é totalmente opensource e acompanha o plugin requisitado.\nSe sua opção for usar sun-java, mas está preocupado com a falta do plugin para o navegador\n então não se preocupe, pois este script lhe instalará um navegador 32bits juntamente com o plugin para lhe suprir esta falta.\nAinda assim voce terá de fazer sua escolha." \
	        --column "#" \
	        --column "Escolha o java a ser instalado :" \
	        false "sun-java->Java da SunMicrosystem (o mais compátivel)" \
	        true "openjdk->Java da comunidade" \
	        false "ambos->Instalar a ambos"`;
        
    if [[ "$OPC_JAVA" =~ "sun-java->" ]] ; then
    	TAREFA="Instalando Java [sun-java]"
	    echo "apt-get -y remove  openjdk-6-dbg openjdk-6-demo openjdk-6-doc openjdk-6-jre" >>$java_temp
      instalar="$instalar sun-java6-bin sun-java6-fonts sun-java6-jre  sun-java6-plugin equivs ttf-sazanami-gothic ttf-sazanami-mincho"
      echo "sudo apt-get -y install $instalar">>$java_temp
      echo "update-alternatives --set java /usr/lib/jvm/java-6-sun/jre/bin/java" >>$java_temp
      echo "update-alternatives --set javac /usr/lib/jvm/java-6-sun/bin/javac">>$java_temp
	  fi
	  
    if [[ "$OPC_JAVA" =~ "openjdk->" ]] ; then
    	TAREFA="Instalando Java [openjdk]"
	    echo "apt-get -y remove  sun-java6-bin sun-java6-fonts sun-java6-jre sun-java6-jdk">>$java_temp
      instalar="$instalar openjdk-6-jre openjdk-6-jre-headless openjdk-6-jre-lib icedtea6-plugin"
      echo "sudo apt-get -y install $instalar">>$java_temp
      echo "update-alternatives --set java /usr/lib/jvm/java-6-openjdk/jre/bin/java" >>$java_temp
      echo "update-alternatives --set javac /usr/lib/jvm/java-6-openjdk/bin/javac" >>$java_temp
	  fi

    if [[ "$OPC_JAVA" =~ "ambos->" ]] ; then
    	TAREFA="Instalando Java [sun-java e openjdk]"
      instalar="$instalar sun-java6-bin sun-java6-fonts sun-java6-jre sun-java6-jdk sun-java6-plugin equivs ttf-sazanami-gothic ttf-sazanami-mincho"
      instalar="$instalar openjdk-6-demo openjdk-6-jdk openjdk-6-jre openjdk-6-jre-headless openjdk-6-jre-lib icedtea6-plugin">>$java_temp
      echo "sudo apt-get -y install $instalar">>$java_temp
	  fi

    if [[ "$OPC_JAVA" =~ "ambos->" ]] ; then
      echo "update-alternatives --set java /usr/lib/jvm/java-6-sun/jre/bin/java" >>$java_temp
      echo "update-alternatives --set javac /usr/lib/jvm/java-6-sun/bin/javac" >>$java_temp
#      echo "update-alternatives --config java">>$java_temp 
#      echo "update-alternatives --config javac">>$java_temp   
#      echo "update-alternatives --config firefox-javaplugin.so">>$java_temp   
    fi
    # java plugin para o firefox
    if [ -f "/usr/lib/jvm/java-6-sun/jre/lib/amd64/libnpjp2.so" ] ; then
      echo "update-alternatives --set firefox-javaplugin.so /usr/lib/jvm/java-6-sun/jre/lib/amd64/libnpjp2.so"  >>$java_temp
    fi
    if [ -f "/usr/lib/jvm/java-6-sun/jre/lib/i386/libnpjp2.so" ] ; then
      echo "update-alternatives --set firefox-javaplugin.so /usr/lib/jvm/java-6-sun/jre/lib/i386/libnpjp2.so"  >>$java_temp
    fi
	fi

  # sempre que é instalado ferramentas de programacao é instalado tambem o postfix
  # raras vezes o postfix é requerido nesse tipo de ambiente, assim
  # se ele não estava anteriormente instalado é melhor remove-lo :
  if [ "$EXISTE_POSTFIX" = "N" ]  ; then
    echo "apt-get -y remove postfix" >>$java_temp
  fi

  # instalando o que foi selecionado
  chmod a+x "$java_temp"
  do_cmd_exec "$java_temp"
  do_apt_install "$instalar"
  [ -f "$java_temp" ] && rm -f "$java_temp"

  if [ "$APT_ERROR" != "S" ] ; then
    do_relatorio "$TAREFA [OK]"
    PROCEDIMENTO_EXECUTADO="OK"
    do_notificar "$TAREFA [OK]" "Para testar o java visite a página : http://www.javatester.org/version.html" "S"
    firefox "http://www.javatester.org/version.html"&
  fi
}

function do_fuse() {
	TAREFA="Instalando backends para uso de mapeamento de unidades de rede"
  PROCEDIMENTO_EXECUTADO="FALHOU"
  instalar=""
  instalar="$instalar smbfs sshfs"
  do_apt_install "$instalar"

	# Verifica se a linha
	# user_allow_other
	# ja foi incluida em /etc/fuse.conf
	EXISTE=`cat /etc/fuse.conf |grep -x "user_allow_other"|wc -l`
	if [ "$EXISTE" -eq "0" ] ; then
	  echo "# Permite usuarios comuns mapearem unidades de rede" >>/etc/fuse.conf     
	  echo "user_allow_other" >>/etc/fuse.conf
	fi

	MSG="Apenas usuários que estejam no grupo [fuse] podem mapear unidades de rede diretamente.\nVou lhe apresentar uma lista desses usuários e voce marcará\nos que devem pertencer a tal grupo."
	do_menu_usuarios "$TAREFA" "$MSG"
	APPLY_USERS="$RETURN_VALUE"
	if ! [ -z "$APPLY_USERS" ] ; then
	  for USER in $APPLY_USERS ; do
	    adduser "$USER" fuse
	    do_relatorio "$TAREFA [$USER] [OK]"
	  done
	fi

  if [ "$APT_ERROR" != "S" ] ; then
    do_relatorio "$TAREFA [OK]"
    PROCEDIMENTO_EXECUTADO="OK"
  fi
}

function do_klavaro() {
	TAREFA="Instalando Curso de digitação usando o programa Klavaro"
  PROCEDIMENTO_EXECUTADO="FALHOU"

  do_apt_install "ftp-upload wget klavaro"
  if [ "$APT_ERROR" != "S" ] ; then
     [ -s "/home/$WHOAMI/$NOME_PASTA_DOCUMENTOS/manuais/klavaro-manual-pt-1.0.8.pdf" ] && gnome-open "/home/$WHOAMI/$NOME_PASTA_DOCUMENTOS/manuais/klavaro-manual-pt-1.0.8.pdf"
     do_relatorio "$TAREFA [OK]"
     PROCEDIMENTO_EXECUTADO="OK"
  fi
}

function do_filezilla(){
	# Frontend gráfico para cliente de FTP
	TAREFA="Instalando frontend gráfico para cliente de FTP"
  PROCEDIMENTO_EXECUTADO="FALHOU"
  do_apt_install "filezilla filezilla-common" 
  if [ "$APT_ERROR" != "S" ] ; then
    do_relatorio "$TAREFA [OK]"
    PROCEDIMENTO_EXECUTADO="OK"
  fi
}

function do_deluge(){
	# Cliente de BitTorrent
	TAREFA="Instalando cliente de bittorrent Deluge"
	PROCEDIMENTO_EXECUTADO="FALHOU"
	if [ -f "/usr/bin/transmission" ] ; then
    RESPOSTA="N"
    [ "$SE_AUTOMATICO" = "S" ] && RESPOSTA="S"
    if [ "$RESPOSTA" != "S" ] ; then
	  zenity --question --title="Remover o transmission" --text "Voce está instalando o cliente de torrents Deluge, mas o padrão do Ubuntu é usar o Transmission para esse tipo de download, assim recomendo remover o transmission para não ter dois clientes para a mesma finalidade.\nPosso remover o Transmission e instalar o Deluge ?"
      [ $? -eq 0 ] && RESPOSTA="S"
    fi
    if [ "$RESPOSTA" = "S" ] ; then
  	  do_apt_remove "transmission transmission-common transmission-gtk"
  	fi
	fi
  # remove deluge de versoes antigas antes de instalar o novo
  do_apt_remove "deluge deluge-common deluge-core deluge-torrent deluge-torrent-common"
  # instala o novo deluge
  do_repositorio "deluge-team"
  do_apt_install "deluge"
  
  if [ "$APT_ERROR" != "S" ] ; then
     do_relatorio "$TAREFA [OK]"
     PROCEDIMENTO_EXECUTADO="OK"
  fi
}

function do_frostwire() {
	# Instalando o frostwire
	TAREFA="Instalando o clente de rede P2P Frostwire"
	PROCEDIMENTO_EXECUTADO="FALHOU"

  # removendo a versao corrente que poderá esta desatualizada
  do_apt_remove "frostwire"
  DOWNLOAD_URL="http://main3.frostwire.com/frostwire/4.20.3/frostwire-4.20.3.i586.deb"
  DOWNLOAD_AS=`basename $DOWNLOAD_URL`
  do_download "$DOWNLOAD_URL"
  if [ -f "$PASTA_TMP/$DOWNLOAD_AS" ] ; then
     do_cmd_exec "$DPKG_INSTALL $PASTA_TMP/$DOWNLOAD_AS "
  fi
 
	if  [ -f "/usr/bin/frostwire" ] ; then
	  do_relatorio "$TAREFA [OK]"
    PROCEDIMENTO_EXECUTADO="OK"	
  fi
}

function do_temas_bisigi() {
  PROCEDIMENTO_EXECUTADO="FALHOU"
  TAREFA="Instalando os temas bisigi"

  RESPOSTA="N"
  [ "$SE_AUTOMATICO" = "S" ] && RESPOSTA="S"
  if [ "$RESPOSTA" != "S" ] ; then
     zenity --question --title="Instalação da coleção de temas [bisigi-themes]" --text "[bisigi-themes] é uma coleção de temas.\nSão 180M de variados temas para o GNOME e GDM.\nEles não são essenciais ao seu sistema e o download é bem grande, por isso é necessário a confirmação de instalação.\nVocê quer realmente prosseguir e instalar a coleção de temas [bisigi-themes] ?"  
     [ $? -eq 0 ] && RESPOSTA="S"
  fi
  if [ "$RESPOSTA" != "S" ] ; then
    return
  fi

  do_repositorio "bisigi"
  do_apt_install "bisigi-themes"
  if [ "$APT_ERROR" != "S" ] ; then
    do_cmd_exec "apt-get -y --force-yes update"
    do_relatorio "$TAREFA [OK]"
    PROCEDIMENTO_EXECUTADO="OK"
  fi
}

function do_temas() {
  PROCEDIMENTO_EXECUTADO="FALHOU"
  TAREFA="Instalando alguns temas do Ubuntu Perfeito"
  
  unset files
  ERRO="N"
  files=( "${files[@]}" "/usr/share/doc/gtk2-engines-nimbus" )
  files=( "${files[@]}" "/usr/share/doc/gtk2-engines-blueprint" )
  files=( "${files[@]}" "/usr/share/themes/New Wave" )
  files=( "${files[@]}" "/usr/share/themes/Dust" )
  files=( "${files[@]}" "/usr/share/icons/nimbus" )
  files=( "${files[@]}" "/usr/share/icons/Discovery" )
  files=( "${files[@]}" "/usr/share/icons/OxygenRefit2" )
  files=( "${files[@]}" "/usr/share/icons/hydroxygen" )
  files=( "${files[@]}" "/usr/share/sounds/dream" )
  files=( "${files[@]}" "/usr/share/doc/ubuntu-perfeito-wallpapers" )
  files=( "${files[@]}" "/usr/share/themes/LiNsta-GTK2" )
  files=( "${files[@]}" "/usr/share/themes/Equinox" )
  files=( "${files[@]}" "/usr/share/doc/gtk2-engines-equinox" )
  files=( "${files[@]}" "/usr/share/icons/elementary/index.theme" )
  files=( "${files[@]}" "/usr/share/icons/Faenza/index.theme" )
  files=( "${files[@]}" "/usr/share/icons/Faenza-Dark/index.theme" )  
  #files=( "${files[@]}" "/teste/teste/teste/teste" )

  for test_file in "${files[@]}" ; do    
    ! [ -e "$test_file" ] && ERRO="S"
  done

  if [ "$ERRO" = "S" ] ; then
    #
    # Descarrega e aplica temas : Dust, Dust Sand, New Wave
    #
    do_notificar "$TEMA" "Instalando os temas : gnome-themes-ubuntu community-themes"
    do_apt_install "gnome-themes-ubuntu community-themes"

    #
    # Novos papeis de parede
    #
  	do_notificar "$TEMA" "Descarregando novos papeis de parede"
  	if ! [ -d "/usr/share/doc/ubuntu-perfeito-wallpapers" ] ; then
  	  DOWNLOAD_URL="http://ufpr.dl.sourceforge.net/sourceforge/ubuntu-perfeito/ubuntu-perfeito-wallpapers-2010.04.12_all.deb"
  	  DOWNLOAD_AS=`basename $DOWNLOAD_URL`
  	  do_download "$DOWNLOAD_URL"
  	  if [ -f "$PASTA_TMP/$DOWNLOAD_AS" ] ; then
  	     do_cmd_exec "$DPKG_INSTALL $PASTA_TMP/$DOWNLOAD_AS "
         if [ -d "/usr/share/doc/ubuntu-perfeito-wallpapers" ] ; then
            # gerando nova lista de papeis de parede para o gnome
            # com o que encontrar em /usr/share/backgrounds
            do_gerar_novo_wallpapers_xml "/usr/share/backgrounds"
         fi
      fi
  	fi    

  	#
  	# Tema : Equinox 
  	#
  	do_notificar "$TEMA" "Descarregando o tema Equinox"
  	if ! [ -d "/usr/share/themes/Equinox" ] || ! [ -d "/usr/share/doc/gtk2-engines-equinox" ] ; then
    	DOWNLOAD_URL="http://gnome-look.org/CONTENT/content-files/121882-equinox-packages-1.1_i386.tar.gz"
    	[ "$amd64" = "S" ] && DOWNLOAD_URL="http://gnome-look.org/CONTENT/content-files/122054-equinox-packages-1.1_amd64.tar.gz"
  	  DOWNLOAD_AS=`basename $DOWNLOAD_URL`
  	  do_download "$DOWNLOAD_URL"
  	  if [ -f "$PASTA_TMP/$DOWNLOAD_AS" ] ; then
         do_descompactar "$PASTA_TMP/$DOWNLOAD_AS" "/tmp/equinox"
         do_cmd_exec "find  /tmp/equinox/ -iname gtk2-engines*.deb -exec $DPKG_INSTALL {} \;"
         do_cmd_exec "find  /tmp/equinox/ -iname equinox*.deb -exec $DPKG_INSTALL {} \;"
      fi
    fi

    #
    # Tema icone Faenza
    #
  	do_notificar "$TEMA" "Descarregando o tema-icone Faenza (complementar ao Equinox)"
  	if ! [ -f "/usr/share/icons/Faenza/index.theme" ] || ! [ -f "/usr/share/icons/Faenza-Dark/index.theme" ]; then
      DOWNLOAD_URL="http://fc01.deviantart.net/fs71/f/2010/211/b/e/Faenza_Icons_by_tiheum.zip"
     	DOWNLOAD_AS=`basename $DOWNLOAD_URL`
  	  do_download "$DOWNLOAD_URL"
  	  if [ -f "$PASTA_TMP/$DOWNLOAD_AS" ] ; then
         do_descompactar "$PASTA_TMP/$DOWNLOAD_AS" "/tmp/Faenza"
         do_descompactar "/tmp/Faenza/Faenza.tar.gz" "/usr/share/icons"
         #[ -f "/usr/share/icons/Faenza/places/scalable/distributor-logo-ubuntu.svg"] && \
         #  ln -sf "/usr/share/icons/Faenza/places/scalable/distributor-logo-ubuntu.svg" "/usr/share/icons/Faenza/places/scalable/distributor-logo.svg"
         #[ -f "/usr/share/icons/Faenza/places/48/distributor-logo-ubuntu.png" ] && \
         #  ln -sf "/usr/share/icons/Faenza/places/48/distributor-logo-ubuntu.png" "/usr/share/icons/Faenza/places/48/distributor-logo.png"
         #[ -f "/usr/share/icons/Faenza/places/32/distributor-logo-ubuntu.png" ] && \
         #  ln -sf "/usr/share/icons/Faenza/places/32/distributor-logo-ubuntu.png" "/usr/share/icons/Faenza/places/32/distributor-logo.png"
         #[ -f "/usr/share/icons/Faenza/places/24/distributor-logo-ubuntu.png" ] && \
         #  ln -sf "/usr/share/icons/Faenza/places/24/distributor-logo-ubuntu.png" "/usr/share/icons/Faenza/places/24/distributor-logo.png"
         #[ -f "/usr/share/icons/Faenza/places/22/distributor-logo-ubuntu.png" ] && \
         #  ln -sf "/usr/share/icons/Faenza/places/22/distributor-logo-ubuntu.png" "/usr/share/icons/Faenza/places/22/distributor-logo.png"
         #[ -f "/usr/share/icons/Faenza/places/16/distributor-logo-ubuntu.png" ]\
         #  ln -sf "/usr/share/icons/Faenza/places/16/distributor-logo-ubuntu.png" "/usr/share/icons/Faenza/places/16/distributor-logo.png"
         do_descompactar "/tmp/Faenza/Faenza-Dark.tar.gz" "/usr/share/icons"
  	  fi
  	fi


    #
    # Tema icone Elementary
    #
  	do_notificar "$TEMA" "Descarregando o tema-icone Elementary"
  	if ! [ -f "/usr/share/icons/elementary/index.theme" ] ; then
      DOWNLOAD_URL="http://fc03.deviantart.net/fs71/f/2010/099/a/2/elementary_Icons_by_DanRabbit.zip"
     	DOWNLOAD_AS=`basename $DOWNLOAD_URL`
  	  do_download "$DOWNLOAD_URL"
  	  if [ -f "$PASTA_TMP/$DOWNLOAD_AS" ] ; then
         do_descompactar "$PASTA_TMP/$DOWNLOAD_AS" "/tmp/elementary"
         do_descompactar "/tmp/elementary/elementary-monochrome.tar.gz" "/usr/share/icons"
         do_descompactar "/tmp/elementary/elementary.tar.gz" "/usr/share/icons"
  	  fi
  	fi
  	
  	#
  	# Novo engine : Nimbus
  	#    http://gnome-look.org/content/show.php?content=70212&forumpage=0
  	do_notificar "$TEMA" "Instalando novo icone-tematico Nimbus"
    if ! [ -d "/usr/share/icons/nimbus" ] || ! [ -d "/usr/share/doc/gtk2-engines-nimbus" ] ; then
  	  DOWNLOAD_URL="http://ftp5.gwdg.de/pub/opensuse/repositories/home:/philip_petev/xUbuntu_10.04/all/nimbus-icon-theme_0.1.4-2_all.deb"
  	  DOWNLOAD_AS=`basename $DOWNLOAD_URL`
  	  do_download "$DOWNLOAD_URL"
  	  if [ -f "$PASTA_TMP/$DOWNLOAD_AS" ] ; then
  	     do_cmd_exec "$DPKG_INSTALL $PASTA_TMP/$DOWNLOAD_AS "      
      fi

      if [ "$amd64" = "S" ] ; then
         DOWNLOAD_URL="http://ftp5.gwdg.de/pub/opensuse/repositories/home:/philip_petev/xUbuntu_10.04/amd64/gtk2-engines-nimbus_0.1.4-2_amd64.deb"
      else
         DOWNLOAD_URL="http://ftp5.gwdg.de/pub/opensuse/repositories/home:/philip_petev/xUbuntu_10.04/i386/gtk2-engines-nimbus_0.1.4-2_i386.deb"
      fi
  	  DOWNLOAD_AS=`basename $DOWNLOAD_URL`
      do_download "$DOWNLOAD_URL"
  	  if [ -f "$PASTA_TMP/$DOWNLOAD_AS" ] ; then
  	     do_cmd_exec "$DPKG_INSTALL $PASTA_TMP/$DOWNLOAD_AS "      
      fi
      if [ -d "/usr/share/icons/nimbus" ] && [ -d "/usr/share/doc/gtk2-engines-nimbus" ] ; then
        do_relatorio "$TAREFA [OK]"
      fi
  	fi

  	#
  	# Novo engine : BluePrint
  	#  
  	do_notificar "$TEMA" "Instalando novo icone-tematico BluePrint"
    if ! [ -d "/usr/share/icons/blueprint" ] || ! [ -d "/usr/share/doc/gtk2-engines-blueprint" ] ; then
  	  DOWNLOAD_URL="http://ftp5.gwdg.de/pub/opensuse/repositories/home:/philip_petev/xUbuntu_10.04/all/blueprint-icon-theme_0.9.20-1_all.deb"
  	  DOWNLOAD_AS=`basename $DOWNLOAD_URL`
  	  do_download "$DOWNLOAD_URL"
  	  if [ -f "$PASTA_TMP/$DOWNLOAD_AS" ] ; then
  	     do_cmd_exec "$DPKG_INSTALL $PASTA_TMP/$DOWNLOAD_AS "      
      fi

      if [ "$amd64" = "S" ] ; then
         DOWNLOAD_URL="http://ftp5.gwdg.de/pub/opensuse/repositories/home:/philip_petev/xUbuntu_10.04/amd64/gtk2-engines-blueprint_0.9.20-1_amd64.deb"
      else
         DOWNLOAD_URL="http://ftp5.gwdg.de/pub/opensuse/repositories/home:/philip_petev/xUbuntu_10.04/i386/gtk2-engines-blueprint_0.9.20-1_i386.deb"
      fi
  	  DOWNLOAD_AS=`basename $DOWNLOAD_URL`
      do_download "$DOWNLOAD_URL"
  	  if [ -f "$PASTA_TMP/$DOWNLOAD_AS" ] ; then
  	     do_cmd_exec "$DPKG_INSTALL $PASTA_TMP/$DOWNLOAD_AS "      
      fi
      if [ -d "/usr/share/icons/blueprint" ] && [ -d "/usr/share/doc/gtk2-engines-blueprint" ] ; then
        do_relatorio "$TAREFA [OK]"
      fi
  	fi

    #
    # Aqueles que tem saudade do tema do Vista
    # 
  	do_notificar "$TEMA" "Descarregando o tema LiNsta"
    if ! [ -d "/usr/share/themes/LiNsta-GTK2" ] ; then
   	  DOWNLOAD_URL="http://www.gnome-look.org/CONTENT/content-files/42697-LiNsta-GTK2.tar.gz"
 	    DOWNLOAD_AS=`basename $DOWNLOAD_URL`
 	    do_download "$DOWNLOAD_URL"
 	    if [ -f "$PASTA_TMP/$DOWNLOAD_AS" ] ; then
 	       do_descompactar "$PASTA_TMP/$DOWNLOAD_AS" "/usr/share/themes/"
      fi
    fi

  	#
  	# Conjunto de Icones tematicos : Discovery 
  	#
  	do_notificar "$TEMA" "Instalando icones tematicos : Discovery"
  	if ! [ -d "/usr/share/icons/Discovery" ] ; then
  	    DOWNLOAD_URL="http://ufpr.dl.sourceforge.net/sourceforge/ubuntu-perfeito/ubuntu-perfeito-icon-theme-discovery-0.1_all.deb"
  	    DOWNLOAD_AS=`basename $DOWNLOAD_URL`
  	    do_download "$DOWNLOAD_URL"
    	  if [ -f "$PASTA_TMP/$DOWNLOAD_AS" ] ; then
  	       do_cmd_exec "$DPKG_INSTALL $PASTA_TMP/$DOWNLOAD_AS "
           [ -d "/usr/share/icons/Discovery" ] && do_relatorio "$TAREFA [OK]"
        fi
    fi
    
  	#
  	# Icones tematicos : Oxigen Refit 2
  	# http://download.tuxfamily.org/gnome4sid/OxygenRefit2-2.3.0.tar.bz2
  	#
  	do_notificar "$TEMA" "Instalando icones tematicos : OxigenRefit2"
  	if ! [ -d "/usr/share/icons/OxygenRefit2" ] ; then
  	    DOWNLOAD_URL="http://ufpr.dl.sourceforge.net/sourceforge/ubuntu-perfeito/ubuntu-perfeito-icon-theme-oxygenrefit2-0.1_all.deb"
  	    DOWNLOAD_AS=`basename $DOWNLOAD_URL`
  	    do_download "$DOWNLOAD_URL"
    	  if [ -f "$PASTA_TMP/$DOWNLOAD_AS" ] ; then
  	       do_cmd_exec "$DPKG_INSTALL $PASTA_TMP/$DOWNLOAD_AS "
           [ -d "/usr/share/icons/OxygenRefit2" ] && do_relatorio "$TAREFA [OK]"
        fi
    fi

  	#
  	# Icones tematicos : Hydrogen
  	# http://deviantdark.deviantart.com/art/hydroxygen-iconset-100826865
  	#
  	do_notificar "$TEMA" "Instalando icones tematicos : Hydrogen"
  	if ! [ -d "/usr/share/icons/hydroxygen" ] ; then
  	    DOWNLOAD_URL="http://ufpr.dl.sourceforge.net/sourceforge/ubuntu-perfeito/ubuntu-perfeito-icon-theme-hydroxygen-0.1_all.deb"
  	    DOWNLOAD_AS=`basename $DOWNLOAD_URL`
  	    do_download "$DOWNLOAD_URL"
    	  if [ -f "$PASTA_TMP/$DOWNLOAD_AS" ] ; then
  	       do_cmd_exec "$DPKG_INSTALL $PASTA_TMP/$DOWNLOAD_AS "
        fi
    fi  
    
    #
    # Novos efeitos sonoros
    #
  	do_notificar "$TEMA" "Instalando sons tematicos : Dream"
  	if ! [ -d "/usr/share/sounds/dream" ] ; then
  	    DOWNLOAD_URL="http://ufpr.dl.sourceforge.net/sourceforge/ubuntu-perfeito/ubuntu-perfeito-sound-theme-dream-0.1_all.deb"
  	    DOWNLOAD_AS=`basename $DOWNLOAD_URL`
  	    do_download "$DOWNLOAD_URL"
  	    if [ -f "$PASTA_TMP/$DOWNLOAD_AS" ] ; then
  	      do_cmd_exec "$DPKG_INSTALL $PASTA_TMP/$DOWNLOAD_AS "
          [ -d "/usr/share/sounds/dream" ] && do_relatorio "$TAREFA [OK]"
        fi
    fi

  	# Instalando sons tematicos : sound-theme-freedesktop
    do_apt_install "sound-theme-freedesktop"


  	# Instalando sons tematicos : ubuntustudio-sounds
    do_apt_install "ubuntustudio-sounds"

  fi  

  # Estabelecendo um tema padrao
  SCRIPT_FILE="/etc/skel/.config/autostart/unica_vez-aplicar_tema_padrao.sh"
  DESKTOP_FILE="/etc/skel/.config/autostart/unica_vez-aplicar_tema_padrao.desktop"
  BASEDIR=`dirname "$SCRIPT_FILE"`
  mkdir -p "$BASEDIR"
  PAPEL_PAREDE="/usr/share/backgrounds/ubuntu_big_1440x900.jpg"
  TEMA_VISUAL="Equinox Glass"
  TEMA_ICONE="Faenza"
  TEMA_METACITY="Equinox Glass"
  TEMA_FONTE="Sans 10"
  TEMA_FONTE_MONO="Monospace 10"
  TEMA_FONTE_TITLEBAR="Sans Bold 10"
  if [ -f "$PAPEL_PAREDE" ] &&
     [ -d "/usr/share/icons/$TEMA_ICONE" ] &&
     [ -d "/usr/share/themes/$TEMA_VISUAL" ] &&
     [ -d "/usr/share/doc/gtk2-engines-equinox" ] ; then
	    cat > "$SCRIPT_FILE" <<END
#!/bin/bash
[ -f "$PAPEL_PAREDE" ] && gconftool-2 --type string --set "/desktop/gnome/background/picture_filename" "$PAPEL_PAREDE"
gconftool-2 --type string --set "/desktop/gnome/interface/gtk_theme" "$TEMA_VISUAL"
gconftool-2 --type string --set "/desktop/gnome/interface/icon_theme" "$TEMA_ICONE"
gconftool-2 --type bool --set "/apps/metacity/general/titlebar_uses_system_font" "true"
gconftool-2 --type string --set "/apps/metacity/general/theme" "$TEMA_METACITY"
gconftool-2 --type string --set "/desktop/gnome/background/picture_options" "stretched" 
gconftool-2 --type string --set "/apps/metacity/general/button_layout" "menu:minimize,maximize,close"
# Fontes liberation Sans
gconftool-2 --type string --set "/desktop/gnome/interface/document_font_name" "$TEMA_FONTE"
gconftool-2 --type string --set "/desktop/gnome/interface/font_name" "$TEMA_FONTE"
gconftool-2 --type string --set "/desktop/gnome/interface/monospace_font_name" "$TEMA_FONTE_MONO"
gconftool-2 --type string --set "/apps/metacity/general/titlebar_font" "$TEMA_FONTE_TITLEBAR"
gconftool-2 --type string --set "/apps/nautilus/preferences/desktop_font" "$TEMA_FONTE"
[ -f "/home/\$USERNAME/.config/autostart/unica_vez-aplicar_tema_padrao.desktop" ] && rm -f "/home/\$USERNAME/.config/autostart/unica_vez-aplicar_tema_padrao.desktop"  
[ -f "/home/\$USERNAME/.config/autostart/unica_vez-aplicar_tema_padrao.sh" ] && rm -f "/home/\$USERNAME/.config/autostart/unica_vez-aplicar_tema_padrao.sh"  
# mensagem na tela
/usr/bin/notify-send "Novo tema :" "Instalei alguns temas novos para você e tomei a liberdade de ativar um deles, se nao gostar use o menu de preferencias para trocar."  
END
	    chmod 0755 "$SCRIPT_FILE"
      chown $WHOAMI.$WHOAMI "$SCRIPT_FILE"
	    cat > "$DESKTOP_FILE" <<END
[Desktop Entry]
Type=Application
Exec=/usr/bin/xterm -e "~/.config/autostart/unica_vez-aplicar_tema_padrao.sh"
Hidden=false
NoDisplay=false
X-GNOME-Autostart-enabled=true
Name=Habilitar tema Padrao
Comment=Habilitar tema Padrao do Ubuntu Perfeito
END
	    chmod 0755 "$DESKTOP_FILE"
      chown $WHOAMI.$WHOAMI "$DESKTOP_FILE"
     	do_notificar "$TEMA" "Um novo tema será apresendado quando você reiniciar sua sessão."
  fi

  # copiando tema padrão para usuários ja criados
  MSG="Marque os usuários que desde já usufruirão do tema padrão do Ubuntu Perfeito :"
  do_menu_usuarios "$TAREFA" "$MSG"
  APPLY_USERS="$RETURN_VALUE"
  if ! [ -z "$APPLY_USERS" ] ; then
    for USER in $APPLY_USERS ; do
      mkdir -p "/home/$USER/.config/autostart"
      chown $USER.$USER "/home/$USER/.config/autostart"
      ln -s /etc/skel/.config/autostart/unica_vez-aplicar_tema_padrao.sh "/home/$USER/.config/autostart/unica_vez-aplicar_tema_padrao.sh"
      ln -s /etc/skel/.config/autostart/unica_vez-aplicar_tema_padrao.desktop "/home/$USER/.config/autostart/unica_vez-aplicar_tema_padrao.desktop"
    done
  fi

  ERRO="N"
  for test_file in "${files[@]}" ; do    
    if ! [ -e "$test_file" ] ; then
      ERRO="S"
      zenity --error --title="Problema :" \
              --text "Parece que o arquivo/pasta :\n\t$test_file\nnão foi instalada.\nCertamente pertence a algum pacote que não foi completamente instalado.\nPor essa  razão, infelizmente essa tarefa não poderá ser concluída com sucesso e precisará ser executada novamente."
    fi
  done
  
  ! [ -f "$PAPEL_PAREDE" ] && ERRO="S"
  ! [ -d "/usr/share/icons/$TEMA_ICONE" ] && ERRO="S"
  ! [ -d "/usr/share/themes/$TEMA_VISUAL" ] && ERRO="S"
  ! [ -d "/usr/share/doc/gtk2-engines-equinox" ] && ERRO="S"
  
  if [ "$ERRO" = "N" ] ; then
    do_relatorio "$TAREFA [OK]"
    PROCEDIMENTO_EXECUTADO="OK"
    #
    # Aviso importante
    #
    do_notificar "$TEMA" "Use o menu de serviços para aplicar o novo tema em [Sistema->Preferencias->Ubuntu Perfeito-Menu de serviços]."&
    REQUER_MENU_SERVICOS="S"  
  fi
}


function do_virtualbox() {
	# Instalação do VirtualBox
  PROCEDIMENTO_EXECUTADO="FALHOU"
	TAREFA="Instalando o VirtualBox"
  instalar=""

  do_repositorio "virtualbox"

  VER_INSTALADA_MAJOR="0"
  VER_INSTALADA_MINOR="0"
	VER_INSTALADA="0"
	INSTALAR_VBOX="Nenhum"
	if [ -f "/usr/bin/VBoxManage" ] ; then	  
	  VER_INSTALADA_MAJOR=`/usr/bin/VBoxManage -version 2>/dev/null|cut -d "." -f1`
	  VER_INSTALADA_MINOR=`/usr/bin/VBoxManage -version 2>/dev/null|cut -d "." -f2`
	  VER_INSTALADA="$VER_INSTALADA_MAJOR.$VER_INSTALADA_MINOR"	
	fi
  if [ "$VER_INSTALADA_MAJOR" -ge "3" ] && [ "$VER_INSTALADA_MINOR" -ge "2" ]; then
    PROCEDIMENTO_EXECUTADO="OK"
    do_relatorio "$TAREFA [OK]"
    do_notificar "Sucesso :"  "A versão 3.2 do VirtualBox já estava instalado, mantive a instalação anterior."
    return
  fi
	
	! [ -f "/usr/bin/VirtualBox" ] && VER_INSTALADA="0"
	  	
  INSTALAR_VBOX=`zenity $ZEN_SIZE \
      --list --radiolist \
      --title "Instalar o VirtualBox?" \
      --text "Qual a versão desejada?" \
      --column " " \
      --column "Versão :" \
      true "Comercial-gratuita para uso pessoal, porem paga outros tipos de usos" \
      false "OpenSource-conhecida como OSE que é livre para qualquer tipo de uso" \
      false "Nenhum"`  
  [ $? -ne 0 ] && INSTALAR_VBOX="Nenhum"


  if [ "$INSTALAR_VBOX" != "Comercial-gratuita para uso pessoal, porem paga outros tipos de usos" ] && \
     [ "$INSTALAR_VBOX" != "OpenSource-conhecida como OSE que é livre para qualquer tipo de uso" ]; then 
      zenity --error --title="Problema :" \
              --text "Voce escolheu a opção Nenhum por isso estou abandonando a instalação do VirtualBox !"
	  return
	fi

  if [ "$INSTALAR_VBOX" = "OpenSource-conhecida como OSE que é livre para qualquer tipo de uso" ] ; then 
    EXISTE_REPOS=`apt-cache policy virtualbox-ose|grep "archive.ubuntu.com" |wc -l`
    if [ "$EXISTE_REPOS" -gt 0 ] ; then
      do_apt_remove "virtualbox virtualbox-ose virtualbox-ose virtualbox-ose-guest-source virtualbox-ose-guest-utils virtualbox-ose-source virtualbox-2.0 virtualbox-2.1 virtualbox-2.2 virtualbox-3.0 virtualbox-3.1"
      instalar="$instalar virtualbox-ose virtualbox-ose-guest-source virtualbox-ose-guest-utils virtualbox-ose-source virtualbox-ose-dkms"
    else
      zenity --notification --title="Problema :" \
              --text "Não foi encontrada a versão VirtualBox-OSE nos repositorios !"&
    fi
  fi
	    
  if [ "$INSTALAR_VBOX" = "Comercial-gratuita para uso pessoal, porem paga outros tipos de usos" ] ; then 
    # VirtualBox - Comercial
    EXISTE_REPOS=`apt-cache policy virtualbox-3.2|grep "http://download.virtualbox.org" |wc -l`
    if [ "$EXISTE_REPOS" -gt 0 ] ; then
      do_apt_remove "virtualbox virtualbox-ose virtualbox-ose-guest-source virtualbox-ose-guest-utils virtualbox-ose-source virtualbox-2.0 virtualbox-2.1 virtualbox-2.2 virtualbox-3.0 virtualbox-3.1"
      instalar="$instalar virtualbox-3.2"
    else
      zenity --error --title="Problema :" \
              --text "Não foi encontrada a versão VirtualBox Comercial nos repositorios !"
      return
    fi 
  fi

  [ "$instalar" != "" ] && do_apt_install "$instalar"

  # Em algumas oportunidades a USB só funcionará se adicionar algumas linhas
  # ao /etc/fstab
  #echo "# USB disponivel para maquinas virtuais" >>/etc/fstab
  #echo "none /proc/bus/usb usbfs devgid=46,devmode=664 0 0">>/etc/fstab
  #
  # verificando a versão pós-instalação  
  VER_INSTALADA_MAJOR=`/usr/bin/VBoxManage -version 2>/dev/null|cut -d "." -f1`
  VER_INSTALADA_MINOR=`/usr/bin/VBoxManage -version 2>/dev/null|cut -d "." -f2`
  VER_INSTALADA="$VER_INSTALADA_MAJOR.$VER_INSTALADA_MINOR"	
	    
  if [ "$VER_INSTALADA_MAJOR" -ge "3" ] && [ "$VER_INSTALADA_MINOR" -ge "0" ]; then
    PROCEDIMENTO_EXECUTADO="OK"
    do_relatorio "$TAREFA [OK]"
  fi

	TAREFA="Usuarios autorizados a executar o VirtualBox"
	if [ -f "/usr/bin/VirtualBox" ] ; then
	  # virtualbox foi instalado?
	  if [ -f "/usr/bin/VirtualBox" ] ; then
	    # conferindo se os usuarios estao no grupo vboxusers
	    MSG="Apenas usuários que estejam no grupo [vboxusers] podem acessar \nmáquinas virtuais criadas com o VirtualBox.\nNa lista abaixo, voce deverá marcar os que forem aptos :"
		  do_menu_usuarios "$TAREFA" "$MSG"
		  APPLY_USERS="$RETURN_VALUE"
		  if ! [ -z "$APPLY_USERS" ] ; then
		    for USER in $APPLY_USERS ; do
		      adduser "$USER" vboxusers
		      do_relatorio "$TAREFA [$USER] [OK]"
		    done
		  fi
	  fi
    if [ "$INSTALAR_VBOX" = "Comercial-gratuita para uso pessoal, porem paga outros tipos de usos" ] ; then
       do_notificar "Importante :" "Toda mudança de kernel trazida por atualizações automáticas requeirerá a atualização do módulo que manualmente poderá ser executada com o comando : sudo /etc/init.d/vboxdrv setup"
    else
       do_notificar "Importante :" "Toda mudança de kernel trazida por atualizações automáticas requeirerá a atualização do módulo que manualmente poderá ser executada com o comando : sudo m-a a-i virtualbox-ose-source"
    fi
	fi
}

function do_google_earth() {
	# Google Earth
	TAREFA="Instalando o GoogleEarth"
  PROCEDIMENTO_EXECUTADO="FALHOU"

  RESPOSTA="N"
  [ "$SE_AUTOMATICO" = "S" ] && RESPOSTA="S"

	if [ -f "/usr/bin/googleearth" ] ; then
	  PROCEDIMENTO_EXECUTADO="OK"
    do_relatorio "$TAREFA [OK]"
    return
  fi

  if [ `glxinfo |grep "direct rendering:"|cut -d ":" -f2|tr -d " "` != "Yes" ] ; then
    if [ "$RESPOSTA" != "S" ] ; then
	     zenity --question --title="Gostaria de instalar o Google Earth :"  --question --text "O script detectou que você não possui uma placa de aceleração gráfica ativada.\nEsse requisito é obrigatório para rodar o Google Earth.\nVoce pode até possuir uma placa dessas, mas se ela não estiver ativada, não insista pois o Google Earth não funcionará.\nProsseguir assim mesmo?"
       [ $? -eq 0 ] && RESPOSTA="S"
    fi
	  if [ "$RESPOSTA" != "S" ] ; then
	    return
	  fi
  fi

  DOWNLOAD_URL="http://dl.google.com/earth/client/current/GoogleEarthLinux.bin"
  do_download "$DOWNLOAD_URL"
  if [ -f "$PASTA_TMP/GoogleEarthLinux.bin" ] ; then
     chmod a+x "$PASTA_TMP/GoogleEarthLinux.bin"
     cmdlist=( "${cmdlist[@]}" "mkdir -p /usr/share/google-earth" )
     cmdlist=( "${cmdlist[@]}" "chmod 2777 /usr/share/google-earth" )
     cmdlist=( "${cmdlist[@]}" "$PASTA_TMP/GoogleEarthLinux.bin --noexec --target $PASTA_TMP/google-earth-setup" )
     cmdlist=( "${cmdlist[@]}" "mv $PASTA_TMP/google-earth-setup/setup.data/bin/Linux/x86/setup.gtk $PASTA_TMP/google-earth-setup/setup.data/bin/Linux/x86/setup.gtk2" )
     cmdlist=( "${cmdlist[@]}" "$PASTA_TMP/google-earth-setup/setup.sh -b \"/usr/bin/\" -i \"/usr/share/google-earth/\"" )
     #cmdlist=( "${cmdlist[@]}" "xxxxxx" )  
     do_cmd_exec
     [ -d "$PASTA_TMP/google-earth-setup" ] && rm -fR "$PASTA_TMP/google-earth-setup"
  else
     zenity --error --title="Arquivo não existe :" --text "$PASTA_TMP/GoogleEarthLinux.bin"      
  fi

  if [ -f "/usr/bin/googleearth" ] ; then
	  PROCEDIMENTO_EXECUTADO="OK"
    do_relatorio "$TAREFA [OK]"
  fi
}

function do_gimp() {
  PROCEDIMENTO_EXECUTADO="FALHOU"
  TAREFA="Instalando o Gimp"
  do_apt_install "gimp gimp-texturize gegl gimp-data-extras gimp-gap gimp-normalmap gimp-plugin-registry gimp-resynthesizer gimp-ufraw gnome-xcf-thumbnailer gtkam-gimp"
  if [ -f "/usr/bin/gimp" ] ; then
     [ -s "/home/$WHOAMI/$NOME_PASTA_DOCUMENTOS/manuais/gimp 2210.pdf" ] && gnome-open "/home/$WHOAMI/$NOME_PASTA_DOCUMENTOS/manuais/gimp 2210.pdf"
 	   PROCEDIMENTO_EXECUTADO="OK"
     do_relatorio "$TAREFA [OK]"
     do_notificar "Sucesso :" "O Gimp foi instalado com alguns extras como o [texturize] que completa uma textura a partir duma seleção."
  fi
}

function do_gnucash() {
  PROCEDIMENTO_EXECUTADO="FALHOU"
  TAREFA="Instalando o GNU Cash"
  do_apt_install "gnucash"
  if [ -f "/usr/bin/gnucash" ] ; then
     [ -s "/home/$WHOAMI/$NOME_PASTA_DOCUMENTOS/manuais/tutorial_gnucash_basico_2010.pdf" ] && gnome-open "/home/$WHOAMI/$NOME_PASTA_DOCUMENTOS/manuais/tutorial_gnucash_basico_2010.pdf"
 	   PROCEDIMENTO_EXECUTADO="OK"
     do_relatorio "$TAREFA [OK]"
     do_notificar "Sucesso :" "O GNUCash foi instalado, um manual também foi instalado para facilitar o aprendizado. Bancos como o Bradesco exportam extratos que podem ser importados por este programa."
  fi
}
function do_descarregar_modelos() {
	# modelos de documentos para openoffice
	# verificando se voce possui modelos instalados, se não houver nenhum, 
	# então sugere instalar alguns
  PROCEDIMENTO_EXECUTADO="FALHOU"
  TAREFA="Instalando Modelos de Documentos"
	if ! [ -d "/usr/share/ubuntuperfeito-modelos" ] ; then
       DOWNLOAD_URL="http://downloads.sourceforge.net/project/ubuntu-perfeito/ubuntu-perfeito-misc/all/ubuntuperfeito-modelos-0.1_all.deb"
       DOWNLOAD_AS=`basename $DOWNLOAD_URL`
       do_download "$DOWNLOAD_URL"
       if [ -f "$PASTA_TMP/$DOWNLOAD_AS" ] ; then
         do_cmd_exec "$DPKG_INSTALL $PASTA_TMP/$DOWNLOAD_AS"
      fi
      if ! [ -d /etc/skel/$NOME_PASTA_MODELOS ] ; then
        mkdir -p /etc/skel/$NOME_PASTA_MODELOS
        chmod 2775 /etc/skel/$NOME_PASTA_MODELOS
        cd /etc/skel/$NOME_PASTA_MODELOS
        find  /usr/share/ubuntuperfeito-modelos/* -maxdepth  1 -type d -exec ln -s {} \;
      fi
 	fi

	if  [ -d "/usr/share/ubuntuperfeito-modelos" ]  ; then
	    MSG="Selecione os usuários que receberão os novos modelos de documentos :"
		  do_menu_usuarios "$TAREFA" "$MSG"
		  APPLY_USERS="$RETURN_VALUE"
		  if ! [ -z "$APPLY_USERS" ] ; then
		    for USER in $APPLY_USERS ; do
		      cd /home/$USER/$NOME_PASTA_MODELOS
          find  /usr/share/ubuntuperfeito-modelos/* -maxdepth  1 -type d -exec ln -s {} \;
          chown -vR $USER /home/$USER/$NOME_PASTA_MODELOS
		    done
		  fi
      PROCEDIMENTO_EXECUTADO="OK"
      do_relatorio "$TAREFA [OK]"
      do_notificar "$TAREFA"  "Mais modelos de documentos foram instalados no ambiente geral, no entanto para usuários que não foram selecionados será necessário que use o menu de serviços do Ubuntu Perfeito."
  fi
}

function do_descarregar_manuais() {
	#
	# Descarregando da internet, alguns manuais de autoajuda como :
	# Cinelerra, Gimp, OpenOffice, Ubuntu,...
	#
	TAREFA="Descarregando manuais e apostilas interessantes"
  PROCEDIMENTO_EXECUTADO="FALHOU"
  RESPOSTA="N"
  [ "$SE_AUTOMATICO" = "S" ] && RESPOSTA="S"
  if [ "$RESPOSTA" != "S" ] ; then
    zenity --question --title="Gostaria de descarregar manuais e apostilas?"  --text "Gostaria de que eu descarregasse manuais e apostilas de autoajuda de programas populares, atenção que o download é enorme (103M) ?"
    [ $? -eq 0 ] && RESPOSTA="S"
  fi
  if [ "$RESPOSTA" = "S" ] ; then
    if ! [ -d /etc/skel/$NOME_PASTA_DOCUMENTOS/manuais ] ; then
      mkdir -p /etc/skel/$NOME_PASTA_DOCUMENTOS/manuais
      chmod 2775 /etc/skel/$NOME_PASTA_DOCUMENTOS/manuais
    fi
    do_relatorio "$TAREFA [OK]"

    #
    # lista de manuais com licenças livres
    #

    # Manual Guia do Iniciante
    DOWNLOAD_URL="http://opiratadigital.files.wordpress.com/2010/04/ubuntu_guia_do_iniciante.pdf"
    DOWNLOAD_AS=`basename $DOWNLOAD_URL`
    do_download "$DOWNLOAD_URL"
    [ -f "$PASTA_TMP/$DOWNLOAD_AS" ] && do_descompactar "$PASTA_TMP/$DOWNLOAD_AS"  "/etc/skel/$NOME_PASTA_DOCUMENTOS/manuais"

    # Manual do Cinelerra
    DOWNLOAD_URL="http://szaszak.files.wordpress.com/2008/06/cinelerra_cv_manual_pt_br.pdf"
    DOWNLOAD_AS=`basename $DOWNLOAD_URL`
    do_download "$DOWNLOAD_URL"
    [ -f "$PASTA_TMP/$DOWNLOAD_AS" ] && do_descompactar "$PASTA_TMP/$DOWNLOAD_AS"  "/etc/skel/$NOME_PASTA_DOCUMENTOS/manuais/"

    # Manual do GNUCash
    DOWNLOAD_URL="http://ufpr.dl.sourceforge.net/project/ubuntu-perfeito/ubuntu-perfeito-misc/all/tutorial_gnucash_basico_2010.pdf"
    DOWNLOAD_AS=`basename $DOWNLOAD_URL`
    do_download "$DOWNLOAD_URL"
    [ -f "$PASTA_TMP/$DOWNLOAD_AS" ] && do_descompactar "$PASTA_TMP/$DOWNLOAD_AS"  "/etc/skel/$NOME_PASTA_DOCUMENTOS/manuais/"

    # Manual do Gimp #1
    DOWNLOAD_URL="http://www.metro.sp.gov.br/diversos/download/apostilas/gimp.zip"
    DOWNLOAD_AS=`basename $DOWNLOAD_URL`
    do_download "$DOWNLOAD_URL"
    [ -f "$PASTA_TMP/$DOWNLOAD_AS" ] && do_descompactar "$PASTA_TMP/$DOWNLOAD_AS"  "/etc/skel/$NOME_PASTA_DOCUMENTOS/manuais/"

    # Manual do Blender
    DOWNLOAD_URL="http://www.inf.ufsc.br/~lkraider/share/Apostila_Blender_Cogitas3d.pdf.zip"
    DOWNLOAD_AS=`basename $DOWNLOAD_URL`
    do_download "$DOWNLOAD_URL"
    [ -f "$PASTA_TMP/$DOWNLOAD_AS" ] && do_descompactar "$PASTA_TMP/$DOWNLOAD_AS"  "/etc/skel/$NOME_PASTA_DOCUMENTOS/manuais"

    # Manual do Curso de Digitação Klavaro
    DOWNLOAD_URL="http://ufpr.dl.sourceforge.net/sourceforge/klavaro/klavaro-manual-pt-1.0.8.pdf"
    DOWNLOAD_AS=`basename $DOWNLOAD_URL`
    do_download "$DOWNLOAD_URL"
    [ -f "$PASTA_TMP/$DOWNLOAD_AS" ] && do_descompactar "$PASTA_TMP/$DOWNLOAD_AS"  "/etc/skel/$NOME_PASTA_DOCUMENTOS/manuais"

    #
    # so sobre openoffice
    #
    DOWNLOAD_URL="http://www.metro.sp.gov.br/diversos/download/broffice/3_2/BrOffice_3_2_Apresentacao.pdf"
    DOWNLOAD_AS=`basename $DOWNLOAD_URL`
    do_download "$DOWNLOAD_URL"
    [ -f "$PASTA_TMP/$DOWNLOAD_AS" ] && do_descompactar "$PASTA_TMP/$DOWNLOAD_AS"  "/etc/skel/$NOME_PASTA_DOCUMENTOS/manuais"

    DOWNLOAD_URL="http://www.metro.sp.gov.br/diversos/download/broffice/3_2/BrOffice_3_2_Planilha.pdf"
    DOWNLOAD_AS=`basename $DOWNLOAD_URL`
    do_download "$DOWNLOAD_URL"
    [ -f "$PASTA_TMP/$DOWNLOAD_AS" ] && do_descompactar "$PASTA_TMP/$DOWNLOAD_AS"  "/etc/skel/$NOME_PASTA_DOCUMENTOS/manuais"

    DOWNLOAD_URL="http://www.metro.sp.gov.br/diversos/download/broffice/3_2/BrOffice_3_2_Desenho.pdf"
    DOWNLOAD_AS=`basename $DOWNLOAD_URL`
    do_download "$DOWNLOAD_URL"
    [ -f "$PASTA_TMP/$DOWNLOAD_AS" ] && do_descompactar "$PASTA_TMP/$DOWNLOAD_AS"  "/etc/skel/$NOME_PASTA_DOCUMENTOS/manuais"

    DOWNLOAD_URL="http://www.metro.sp.gov.br/diversos/download/broffice/3_2/BrOffice_3_2_%20Imagens.pdf"
    DOWNLOAD_AS=`basename $DOWNLOAD_URL`
    do_download "$DOWNLOAD_URL"
    [ -f "$PASTA_TMP/$DOWNLOAD_AS" ] && do_descompactar "$PASTA_TMP/$DOWNLOAD_AS"  "/etc/skel/$NOME_PASTA_DOCUMENTOS/manuais"

    DOWNLOAD_URL="http://www.metro.sp.gov.br/diversos/download/broffice/3_2/BrOffice_3_2_Texto.pdf"
    DOWNLOAD_AS=`basename $DOWNLOAD_URL`
    do_download "$DOWNLOAD_URL"
    [ -f "$PASTA_TMP/$DOWNLOAD_AS" ] && do_descompactar "$PASTA_TMP/$DOWNLOAD_AS"  "/etc/skel/$NOME_PASTA_DOCUMENTOS/manuais"

    DOWNLOAD_URL="http://www.metro.sp.gov.br/diversos/download/broffice/3_2/BrOffice_3_2_Formula.pdf"
    DOWNLOAD_AS=`basename $DOWNLOAD_URL`
    do_download "$DOWNLOAD_URL"
    [ -f "$PASTA_TMP/$DOWNLOAD_AS" ] && do_descompactar "$PASTA_TMP/$DOWNLOAD_AS"  "/etc/skel/$NOME_PASTA_DOCUMENTOS/manuais"
  fi

  NRO_DOCUMENTOS=`ls -1 "/etc/skel/$NOME_PASTA_DOCUMENTOS/manuais"|wc -l`
  NRO_CERTO_DOCUMENTOS=12
  if [ "$NRO_DOCUMENTOS" -ge "$NRO_CERTO_DOCUMENTOS" ] ; then
     PROCEDIMENTO_EXECUTADO="OK"
     MSG="Os manuais foram descarregados da internet, mas para copia-los na sua conta use o menu de serviços do Ubuntu Perfeito."
     zenity --notification --title="$TAREFA [OK]" --text "$MSG" &
     do_notificar "Sucesso :" "$MSG"
     do_relatorio "$TAREFA [OK]"   
  else
     MSG="Eram esperados $NRO_CERTO_DOCUMENTOS, porém só foram descarregados $NRO_DOCUMENTOS manuais. Por essa razão, esta tarefa permanecerá incompleta."
     zenity --error --title="$TAREFA [FALHOU]" --text "$MSG" &
     do_notificar "Problema :" "$MSG"
  fi

  if [ -d "/etc/skel/$NOME_PASTA_DOCUMENTOS/manuais" ] ; then
	    # conferindo se os usuarios estao no grupo vboxusers
	    MSG="Selecione os usuários que receberão os manuais descarregados :"
		  do_menu_usuarios "$TAREFA" "$MSG"
		  APPLY_USERS="$RETURN_VALUE"
		  if ! [ -z "$APPLY_USERS" ] ; then
		    for USER in $APPLY_USERS ; do
          ! [ -d "/home/$USER/$NOME_PASTA_DOCUMENTOS" ] && do_cmd_exec "mkdir -p \"/home/$USER/$NOME_PASTA_DOCUMENTOS\""
          do_cmd_exec "! [ -f \"/home/$USER/$NOME_PASTA_DOCUMENTOS/manuais\" ] && ln -s \"/etc/skel/$NOME_PASTA_DOCUMENTOS/manuais\" \"/home/$USER/$NOME_PASTA_DOCUMENTOS/manuais\""
          do_cmd_exec "chown -vR $USER \"/home/$USER/$NOME_PASTA_DOCUMENTOS/manuais\""
		    done
		  fi
  fi
  [ -d "/home/$WHOAMI/$NOME_PASTA_DOCUMENTOS/manuais" ] && gnome-open "/home/$WHOAMI/$NOME_PASTA_DOCUMENTOS/manuais"
  [ -s "/home/$WHOAMI/$NOME_PASTA_DOCUMENTOS/manuais/ubuntu_guia_do_iniciante.pdf" ] && gnome-open "/home/$WHOAMI/$NOME_PASTA_DOCUMENTOS/manuais/ubuntu_guia_do_iniciante.pdf"
}

function do_skype() {
	#
	# Skype 
	#
  PROCEDIMENTO_EXECUTADO="FALHOU"
  TAREFA="Instalando do programa Skype"
  RESPOSTA="N"
  [ "$SE_AUTOMATICO" = "S" ] && RESPOSTA="S"
  if [ "$RESPOSTA" != "S" ] ; then
     zenity --question --title="Instalar o Skype?"  --question --text "O Skype é um programa de VoIP muito popular.\nMas ele deixa seu sistema lento, e não são todas as pessoas que utilizam-no. Eu não recomendo a instalação do Skype, embora entenda que em muitos lugares ele é um programa obrigatório.\nInstalo o Skype ?"
     [ $? -eq 0 ] && RESPOSTA="S"
  fi
  if [ "$RESPOSTA" != "S" ] ; then
     return
  fi 
  if [ "$amd64" = "S" ] && [ "$RESPOSTA" != "S" ] ; then
    zenity --question --title="Instalação do Skype :" --text "Skype é um programa que só roda nativamente em ambiente 32bits.\nSeu sistema é 64bits, mas rodaria o Skype se algumas bibliotecas de compatibilidade 32bits fossem instalados.\nGostaria de instalar o Skype mesmo assim ?"
    [ $? -eq 0 ] && RESPOSTA="S"
    [ "$RESPOSTA" != "S" ] && return
  fi

	if  [ -f "/usr/bin/skype" ] ; then
    PROCEDIMENTO_EXECUTADO="OK"
    do_relatorio "$TAREFA [OK]"
    return
  fi
  #DOWNLOAD_URL="http://download.skype.com/linux/skype-ubuntu-intrepid_2.1.0.81-1_i386.deb"
  #[ "$amd64" = "S" ] && DOWNLOAD_URL="http://download.skype.com/linux/skype-ubuntu-intrepid_2.1.0.81-1_amd64.deb"
  #DOWNLOAD_AS=`basename $DOWNLOAD_URL`
  #do_download "$DOWNLOAD_URL"
  #if [ -f "$PASTA_TMP/$DOWNLOAD_AS" ] ; then
  #   do_cmd_exec "$DPKG_INSTALL $PASTA_TMP/$DOWNLOAD_AS "
  #fi
	
  # Skype foi incluido no repositorio partner
  do_apt_install "skype skysentials"

	if  [ -f "/usr/bin/skype" ] ; then
    PROCEDIMENTO_EXECUTADO="OK"
    REQUER_MENU_SERVICOS="S"
    do_relatorio "$TAREFA [OK]"
    zenity --notification --title="$TAREFA"  --text "O Skype esta instalado, mas se voce quiser que ele seja carregado automaticamente no inicio da sessão, use o menu de serviços do Ubuntu Perfeito."&
  fi
}


function do_jogos() {
  PROCEDIMENTO_EXECUTADO="FALHOU"
  TAREFA="Jogos para Linux"
  ERRO="S"
  JOGOS_INSTALADOS=""

  # dependencias minimas
  do_apt_install "libsdl-sound1.2 libsdl-mixer1.2 libsdl-image1.2 libsdl-pango1 libsdl-net1.2 "

  ROADFIGHTER=`do_jogo_roadfighter`
  #F1SPIRIT=`do_jogo_f1spirit`
  F1SPIRIT="OK"
  #DESCENT=`do_jogo_descent`
  DESCENT="OK"
  GOONIES=`do_jogo_goonies`
  GOODY=`do_jogo_goody`
  SONIC=`do_jogo_opensonic`

  [ "$ROADFIGHTER" = "OK" ] && JOGOS_INSTALADOS="Roadfighter"
  #[ "$F1SPIRIT" = "OK" ] && JOGOS_INSTALADOS="$JOGOS_INSTALADOS, F1Spirit"
  #[ "$DESCENT" = "OK" ] && JOGOS_INSTALADOS="$JOGOS_INSTALADOS, Descent 2" 
  [ "$GOONIES" = "OK" ] && JOGOS_INSTALADOS="$JOGOS_INSTALADOS, Goonies"
  [ "$GOODY" = "OK" ] && JOGOS_INSTALADOS="$JOGOS_INSTALADOS, Goody"
  [ "$SONIC" = "OK" ] && JOGOS_INSTALADOS="$JOGOS_INSTALADOS, Sonic"

  firefox "http://www.braingames.getput.com" "http://www.coptronstudios.com" "http://www.descent2.de" &
  do_notificar "Jogos instalados :" "Os jogos : $JOGOS_INSTALADOS - Road Fighter,F1-Spirit e Goonies são cortesia da Brain Games(http://www.braingames.getput.com). O jogo Goody é cortesia de Coptron Studios :(http://www.coptronstudios.com). O jogo Descent2 é cortesia de http://www.descent2.de. Não deixe de parabenizar seus autores enviando-lhes agradecimentos e apoio financeiro, especialmente se você possui conta no PayPal."
  
  if [ "$ROADFIGHTER" = "OK" ] || \
     [ "$F1SPIRIT" = "OK" ] || \
     [ "$DESCENT" = "OK" ] || \ 
     [ "$GOONIES" = "OK" ] || \ 
     [ "$SONIC" = "OK" ] || \ 
     [ "$GOODY" = "OK" ] ; then
    ERRO="N"  
  fi
  
  if [ "$ERRO" = "N" ] ; then
    do_notificar "Jogos instalados :" "Todos os jogos foram instalados : $JOGOS_INSTALADOS"
    PROCEDIMENTO_EXECUTADO="OK"
  else
    do_notificar "Jogos instalados parcialmente :" "Nem todos os jogos foram instalados, foram instalados os jogos : $JOGOS_INSTALADOS"
  fi
}

function do_jogo_goonies() {
 	if ! [ -f "/usr/games/goonies" ] ; then
     DOWNLOAD_URL="http://braingames.jorito.net/goonies/downloads/goonies.904_1.4-1528_i386.deb"
     [ "$amd64" = "S" ] && DOWNLOAD_URL="http://braingames.jorito.net/goonies/downloads/goonies.904_1.4-1528_amd64.deb"
     DOWNLOAD_AS=`basename $DOWNLOAD_URL`
     do_download "$DOWNLOAD_URL"
     if [ -f "$PASTA_TMP/$DOWNLOAD_AS" ] ; then
        do_cmd_exec "$DPKG_INSTALL $PASTA_TMP/$DOWNLOAD_AS "
    fi
  fi
  if [ -f "/usr/games/goonies" ] ; then
    do_notificar "Novo jogo instalado :" "Roadfighter - tente vencer seus adversários numa corrida de rua."
    echo "OK"
  fi
}

function do_jogo_goody() {
  if [ "$amd64" = "S" ] ; then
    do_notificar "Erro :" "Jogo Goody só é funcional em sistemas 32bits"
    echo "FALHOU"
    return
  fi
 	if ! [ -f "/usr/games/goody" ] ; then
     DOWNLOAD_URL="http://www.coptronstudios.com/Web/descargas/goody_Linux.zip"
     [ "$amd64" = "S" ] && DOWNLOAD_URL="http://www.coptronstudios.com/Web/descargas/goody_Linux.zip"
     DOWNLOAD_AS=`basename $DOWNLOAD_URL`
     do_download "$DOWNLOAD_URL"
     if [ -f "$PASTA_TMP/$DOWNLOAD_AS" ] ; then
        do_descompactar "$PASTA_TMP/$DOWNLOAD_AS" "$PASTA_TMP/"
        do_cmd_exec "$DPKG_INSTALL $PASTA_TMP/goody_Linux/goody.deb"
        # criando atalho
        [ -f "/usr/share/applications/goody.desktop" ] && rm -f "/usr/share/applications/goody.desktop"
        echo "[Desktop Entry]">/usr/share/applications/goody.desktop
        echo "Name=Goody - The Remake">>/usr/share/applications/goody.desktop
        echo "Comment=Goody é um jogo de plataforma, onde o objetivo é apanhar todos os sacos de dinheiro que tiverem pelo caminho">>/usr/share/applications/goody.desktop
        echo "Exec=/usr/games/goody">>/usr/share/applications/goody.desktop
        echo "Icon=goody.png">>/usr/share/applications/goody.desktop
        echo "Terminal=false">>/usr/share/applications/goody.desktop
        echo "Type=Application">>/usr/share/applications/goody.desktop
        echo "Categories=Application;Game;">>/usr/share/applications/goody.desktop   
        chmod a+x /usr/share/applications/goody.desktop
    fi
  fi
  if [ -f "/usr/games/goody" ] ; then
    do_notificar "Novo jogo instalado :" "Goody é um jogo de plataforma, onde o objetivo é apanhar todos os sacos de dinheiro que estiverem pelo caminho."
    echo "OK"
  fi     
}

function do_jogo_roadfighter() {
#  if [ "$amd64" = "S" ] ; then
#    do_notificar "Erro :" "Jogo F1Spirit só é funcional em sistemas 32bits"
#    return
#  fi
 	if ! [ -f "/usr/games/roadfighter" ] ; then
     DOWNLOAD_URL="http://braingames.jorito.net/roadfighter/downloads/roadfighter.904_1.0-1269_i386.deb"
     [ "$amd64" = "S" ] && DOWNLOAD_URL="http://braingames.jorito.net/roadfighter/downloads/roadfighter.904_1.0-1269_amd64.deb"
     DOWNLOAD_AS=`basename $DOWNLOAD_URL`
     do_download "$DOWNLOAD_URL"
     if [ -f "$PASTA_TMP/$DOWNLOAD_AS" ] ; then
        do_cmd_exec "$DPKG_INSTALL $PASTA_TMP/$DOWNLOAD_AS "
    fi
  fi
  if [ -f "/usr/games/roadfighter" ] ; then
    do_notificar "Novo jogo instalado :" "Roadfighter - tente vencer seus adversários numa corrida de rua."
    echo "OK"
  fi
}

function do_jogo_f1spirit() {
#  if [ "$amd64" = "S" ] ; then
#    do_notificar "Erro :" "Jogo F1Spirit só é funcional em sistemas 32bits"
#    return
#  fi
 	if ! [ -f "/usr/games/f1spirit" ] ; then
     DOWNLOAD_URL="http://braingames.jorito.net/f1spirit/f1spirit.904_0.rc9-1615_i386.deb"
     [ "$amd64" = "S" ] && DOWNLOAD_URL="http://braingames.jorito.net/f1spirit/f1spirit.904_0.rc9-1615_amd64.deb"
     DOWNLOAD_AS=`basename $DOWNLOAD_URL`
     do_download "$DOWNLOAD_URL"
     if [ -f "$PASTA_TMP/$DOWNLOAD_AS" ] ; then
        do_cmd_exec "$DPKG_INSTALL $PASTA_TMP/$DOWNLOAD_AS "
    fi
  fi
  if [ -f "/usr/games/f1spirit" ] ; then
    do_notificar "Novo jogo instalado :" "F1 Spirit, vai encarar ?"
    echo "OK"
  fi
}

function do_jogo_opensonic() {
#  if [ "$amd64" = "S" ] ; then
#    do_notificar "Erro :" "Jogo F1Spirit só é funcional em sistemas 32bits"
#    return
#  fi
 	if ! [ -f "/usr/games/opensonic" ] ; then
    cmdlist=( "${cmdlist[@]}" "add-apt-repository ppa:szymonw/ppa" ) 
    cmdlist=( "${cmdlist[@]}" "apt-get -y --force-yes update" ) 
    cmdlist=( "${cmdlist[@]}" "apt-get install -y opensonic" ) 
    do_cmd_exec
  fi
  if [ -f "/usr/games/opensonic" ] ; then
    do_notificar "Novo jogo instalado :" "OpenSonic é um sonic-clone da versão MegaDrive com graficos melhorados"
    if [ -f "/etc/apt/sources.list.d/szymonw-ppa-$ppa_repos.list" ] ; then
       rm -f "/etc/apt/sources.list.d/szymonw-ppa-$ppa_repos.list"
       do_cmd_exec "apt-get -y --force-yes update"
    fi
    echo "OK"
  fi
}

function do_jogo_descent() {
  if [ "$amd64" = "S" ] ; then
    do_notificar "Erro :" "Jogo Descent 2 só é funcional em sistemas 32bits"
    echo "FALHOU"
    return
  fi
 	if ! [ -d "/usr/share/xxxx" ] || ! [ -d "/usr/share/xxxxxx" ] ; then
    	DOWNLOAD_URL1="http://files.lstandish.com/d2x-xl/d2x-xl-base.i386.deb"
  	  DOWNLOAD_AS1=`basename $DOWNLOAD_URL1`
  	  do_download "$DOWNLOAD_URL1"
    	DOWNLOAD_URL2="http://files.lstandish.com/d2x-xl/d2x-xl-demo.i386.deb"
  	  DOWNLOAD_AS2=`basename $DOWNLOAD_URL2`
  	  do_download "$DOWNLOAD_URL2"
    	DOWNLOAD_URL3="http://files.lstandish.com/d2x-xl/d2x-xl-executable.i386.deb"
  	  DOWNLOAD_AS3=`basename $DOWNLOAD_URL3`
  	  do_download "$DOWNLOAD_URL3"
    	DOWNLOAD_URL4="http://files.lstandish.com/d2x-xl/d2x-xl-midi.i386.deb"
  	  DOWNLOAD_AS4=`basename $DOWNLOAD_URL4`
  	  do_download "$DOWNLOAD_URL4"
    	DOWNLOAD_URL5="http://files.lstandish.com/d2x-xl/d2x-xl-sdl.i386.deb"
  	  DOWNLOAD_AS5=`basename $DOWNLOAD_URL5`
  	  do_download "$DOWNLOAD_URL5"

  	  if [ -f "$PASTA_TMP/$DOWNLOAD_AS1" ] || \
         [ -f "$PASTA_TMP/$DOWNLOAD_AS2" ] || \
         [ -f "$PASTA_TMP/$DOWNLOAD_AS3" ] || \
         [ -f "$PASTA_TMP/$DOWNLOAD_AS4" ] || \
         [ -f "$PASTA_TMP/$DOWNLOAD_AS5" ] ; then
         do_apt_install "timidity timidity-daemon gtkdialog"
         do_cmd_exec "find  $PASTA_TMP/ -iname dx2-xl*.deb -exec $DPKG_INSTALL {} \;"
      fi
  fi
 	if ! [ -d "/usr/share/xxxx" ] || ! [ -d "/usr/share/xxxxxx" ] ; then
    do_notificar "Novo jogo instalado :" "Descent 2 totalmente refeito para OpenGL"
    echo "OK"
  fi
}

function do_jogos_supertuxkart() {
  PROCEDIMENTO_EXECUTADO="FALHOU"
  TAREFA="Jogo SuperTuxKart para Linux"
  unset files
  ERRO="N"
  files=( "${files[@]}" "/usr/games/supertuxkart" )
  for test_file in "${files[@]}" ; do    
    if ! [ -e "$test_file" ] ; then
      ERRO="S"
    fi
  done
  
  if  ! [ -f "/usr/games/supertuxkart" ] ; then
    # Encara um supertuxkart ?
    do_apt_install "supertuxkart"
	fi

  # conferindo se todos os pacotes requeridos foram instalados
  if  ! [ -f "/usr/games/supertuxkart" ] ; then
      zenity --error --title="Problema :" \
              --text "Parece que não foi possivel instalar o SuperTuxKart, este jogo é muito grande (120M) e pode ter havido algum problema com o download.\n\Infelizmente essa tarefa não poderá ser concluída."

  else
    do_relatorio "$TAREFA [OK]"
    PROCEDIMENTO_EXECUTADO="OK"
  fi
}

function do_menuservicos() {
  PROCEDIMENTO_EXECUTADO="INDIFERENTE"

  #for linha_passwd in `cat /etc/passwd` ; do
  #  GET_UID=`echo "$linha_passwd"|cut -d":" -f3`
  #  GET_LOGINNAME=`echo "$linha_passwd"|cut -d":" -f1`
  #  GET_NAME=`echo "$linha_passwd"|cut -d":" -f5`
  #  if [ "$GET_UID" -ge "1000" 2> /dev/null ] && \
  #     [ "$GET_LOGINNAME" != "nobody" ] && \
  #     [ "$GET_LOGINNAME" != "root" ] && \
  #     [ -d "/home/$GET_LOGINNAME" ] ; then
  #    if ! [ -d "/home/$GET_LOGINNAME/.config/autostart" ] ; then
  #       mkdir -p "/home/$GET_LOGINNAME/.config/autostart"
  #       chown $GET_LOGINNAME "/home/$GET_LOGINNAME/.config"
  #       chown $GET_LOGINNAME "/home/$GET_LOGINNAME/.config/autostart"
  #    fi
  #    DESKTOP_FILE="/home/$GET_LOGINNAME/.config/autostart/ubuntuperfeito-roda_uma_unica_vez.desktop"
  #    echo "[Desktop Entry]">$DESKTOP_FILE
  #    echo "Type=Application">>$DESKTOP_FILE
  #    echo "Name=roda_uma_unica_vez">>$DESKTOP_FILE
  #    echo "Exec=/usr/share/$PACKAGE_NAME/ubuntuperfeito-roda_uma_unica_vez.sh">>$DESKTOP_FILE
  #    echo "Icon=system-run">>$DESKTOP_FILE
  #    echo "Comment=Só roda uma unica vez após o login, depois autoremove-se">>$DESKTOP_FILE
  #    chmod a+x "$DESKTOP_FILE"
  #    chmod 777 "$DESKTOP_FILE"
  #    chown $GET_LOGINNAME "$DESKTOP_FILE"
  #  fi
  #done
 
  #
  # Finalizando...
  #

  # alguns avisos
  do_notificar "Use o menu de Serviços" "Um novo atalho foi criando em :\nSistemas->Preferencias->Ubuntu Perfeito - Menu de serviços.Ele proverá várias outras opções que só se aplicam a conta em uso.Por exemplo : Exibir icones na área de trabalho. Exibir as fontes [Liberation] na área de trabalho. Escolher outros temas e muito mais."&
}

function do_idioma() {
  do_cmd_exec "/usr/bin/gnome-language-selector"
}

function do_instalar_scripts() {
  TAREFA="Instalando nautilus-scripts..."
  PROCEDIMENTO_EXECUTADO="FALHOU"

  #do_apt_install "nautilus-actions nautilus-pastebin"

  #  DOWNLOAD_URL=""
  #  DOWNLOAD_AS=`basename $DOWNLOAD_URL`
  #  PMS_INSTALL_TO=""
  #  do_download "$DOWNLOAD_URL"
  #  [ -s "$PASTA_TMP/currentline.tar.gz" ] && do_descompactar "$PASTA_TMP/$DOWNLOAD_AS" "/home/$CURRENT_USER/.gnome2/gedit/plugins"


  # instalando alguns scripts práticos
  do_menu_usuarios "Instalar scripts para o nautilus para :" "Selecione os usuários :"
  APPLY_USERS="$RETURN_VALUE"
  if ! [ -z "$APPLY_USERS" ] ; then
    for CURRENT_USER in $APPLY_USERS ; do
      # meu ovo de pascoa, um script que ajuda a converter videos para dvix e embutir legendas
      if ! [ -d /home/$CURRENT_USER/.gnome2/nautilus-scripts ] ; then
        mkdir -p /home/$CURRENT_USER/.gnome2/nautilus-scripts
        chmod 770 /home/$CURRENT_USER/.gnome2/nautilus-scripts
        chown $CURRENT_USER /home/$CURRENT_USER/.gnome2/nautilus-scripts
      fi   
      if [ -f /usr/share/$PACKAGE_NAME/ubuntuperfeito-converter_videos.sh ] && \
         ! [ -f /home/$CURRENT_USER/.gnome2/nautilus-scripts/ubuntuperfeito-converter_videos.sh ] ; then
           ln -s /usr/share/$PACKAGE_NAME/ubuntuperfeito-converter_videos.sh /home/$CURRENT_USER/.gnome2/nautilus-scripts/ubuntuperfeito-converter_videos.sh
      fi
      if [ -f /usr/share/$PACKAGE_NAME/ubuntuperfeito-converter_videos.sh ] && \
         [ -f /home/$CURRENT_USER/.gnome2/nautilus-scripts/ubuntuperfeito-converter_videos.sh ] ; then
           PROCEDIMENTO_EXECUTADO="OK"
           do_relatorio "$TAREFA [OK]"
      fi
    done
  fi
}

function do_sobre() {
  PROCEDIMENTO_EXECUTADO="INDIFERENTE"
  MSG="Este script foi testado com o [Ubuntu Lucid 10.04].\n\
É recomendável rodar este script a partir de instalações limpas ou recentes,\n\
não que não funcionaria em instalações mais antigas, mas acontece que pode\n\
haver possibilidade de conflitos com os programas existentes ou compilados.\n\
Este script usa repositórios de terceiros como PPAs, comerciais e consagrados \n\
para evitar que pacotes sinistros comprometam o sistema.\n
Ele reaproveita tudo que já foi baixado e instalado, podendo executa-los quantas\n\
vezes quiser neste ou outro computador.\n\
Basta manter a pasta :[$PASTA_TMP] onde se pretenda executar o script.\n\
A duração de execução desse script é de 1h num link de 512Kbps.\n\
É gerado um log das operações em $LEIAME.\n\n\
Se encontrar erros e quiser aponta-los, envie uma mensagem para :\n\
$EMAILME\n"
  zenity --info --title="$MSG_TITLE" --text "$MSG"
}

function do_atualizar() {
  PROCEDIMENTO_EXECUTADO="FALHOU"
  GRUB_COUNT_BEFORE=`/usr/bin/du /boot -cs |cut -f1|head -n1`
  # forcosamente as assinaturas serao [re]importadas.
  [ -f "$PASTA_TMP/assinaturas.txt" ] && rm -f "$PASTA_TMP/assinaturas.txt"
  do_repositorio "add-all"
  do_cmd_exec "apt-get -y --force-yes upgrade"
  do_install_deps
  # requer reboot?
  GRUB_COUNT_AFTER=`/usr/bin/du /boot -cs |cut -f1|head -n1`
  if [ "$GRUB_COUNT_BEFORE" != "$GRUB_COUNT_AFTER" ] ; then
	    zenity --question --title="Reinicio requerido"  --text "O sistema detectou que uma profunda mudança foi realizada nessa atualização prévia.\nÉ recomendado reiniciar o computador antes de prosseguir com o restante da atualização -terá de executar o Ubuntu Perfeito novamente após o reboot.\nReinicia o computador agora?"
	    if [ $? -eq 0 ] ; then
         rm -f "$LEIAME"
         reboot
      fi
  fi
  PROCEDIMENTO_EXECUTADO="OK"  
}

function do_reinit_menu() {
  PROCEDIMENTO_EXECUTADO="INDIFERENTE"
  [ -f "$PASTA_TMP/menu_$ppa_repos.cat" ] && rm -f "$PASTA_TMP/menu_$ppa_repos.cat"
}

function do_setconfig() {
  PROCEDIMENTO_EXECUTADO="INDIFERENTE"
  BEFORE_CONFIG=`md5sum "$UBUNTU_VARS"`
  gedit "$UBUNTU_VARS"
  AFTER_CONFIG=`md5sum "$UBUNTU_VARS"`
  if [ "$BEFORE_CONFIG" != "$AFTER_CONFIG" ] ; then
  	zenity --info --title="Reinicio do script requerido"  --text "As alterações de parametros desse script requerem o reinicio do mesmo.\nTerminarei a execução do script e voce terá de executa-lo novamente, ok ?"
    ! [ -z "$XTERM_PID" ] && kill -9 $XTERM_PID;
    exec "$UBUNTU_BIN"
    ! [ -z "$CURRENT_PID" ] && kill -9 $CURRENT_PID;
  fi
}

function do_menu() {
  OPC_MENU="---" 
  while   [ "$OPC_MENU" != "" ]; do
    # Criando um menu de seleção desses usuarios encontrados
    unset opcoes
    opcoes=( "${opcoes[@]}" "do_setconfig|false|Configurar a execução deste script" )
    opcoes=( "${opcoes[@]}" "do_atualizar|true|$atualizar_repositorios" )
    opcoes=( "${opcoes[@]}" "do_atualiza_ids|true|Atualizar lista de hardwares IDS" )
    opcoes=( "${opcoes[@]}" "do_idioma|true|Completar a instalação de idiomas" )
    opcoes=( "${opcoes[@]}" "do_compilacao_basicos|true|Pacote básico para compilar programas e modulos" )
    opcoes=( "${opcoes[@]}" "do_instalar_scripts|true|Instalar novos scripts para o Nautilus" )
    opcoes=( "${opcoes[@]}" "do_flash|true|Flash 10 (64bits incluso)" )
    opcoes=( "${opcoes[@]}" "do_compiz|true|Compiz" )
    opcoes=( "${opcoes[@]}" "do_parcellite|true|Gerenciador de clipboard Parcellite" )
    opcoes=( "${opcoes[@]}" "do_impressoras|true|Suporte melhorado a impressoras(inclui PDF)" )
    opcoes=( "${opcoes[@]}" "do_descompactadores|true|Descompactadores" )
    opcoes=( "${opcoes[@]}" "do_seguranca|true|Programas de segurança pessoal" )
    opcoes=( "${opcoes[@]}" "do_wine|true|Wine-manter sempre atualizado" )
    opcoes=( "${opcoes[@]}" "do_codecs|true|Codecs Multimedia" )
    opcoes=( "${opcoes[@]}" "do_vlc|true|Tocador VLC 1.0" )    
    opcoes=( "${opcoes[@]}" "do_multimedia|true|Aplicações para Multimedia" )
    opcoes=( "${opcoes[@]}" "do_mplayer|true|Tocador MPlayer" )
    opcoes=( "${opcoes[@]}" "do_fuse|true|Rede Windows e SSH (fuse)" )
    opcoes=( "${opcoes[@]}" "do_backup|true|Programas de cópia de segurança(backup)" )
    opcoes=( "${opcoes[@]}" "do_descarregar_manuais|true|Manuais e guias para usar o Ubuntu e outros programas" )
    opcoes=( "${opcoes[@]}" "do_gimp|false|Editor de imagens:The Gimp" )
    opcoes=( "${opcoes[@]}" "do_gnucash|false|Controle Financeiro com GNUCash" )
    opcoes=( "${opcoes[@]}" "do_amsn|false|Mensageiro instantaneo aMSN" )
    opcoes=( "${opcoes[@]}" "do_biscoito_da_sorte|false|Biscoito da sorte" )
    opcoes=( "${opcoes[@]}" "do_adobe_reader|false|Adobe Reader 8+Plugin DRM" )
    opcoes=( "${opcoes[@]}" "do_openshot|false|Aplicações para criação de SlideShow com o OpenShot" )
    opcoes=( "${opcoes[@]}" "do_winff|false|Promissor conversor de formatos de multimedia WinFF" )
    opcoes=( "${opcoes[@]}" "do_realplayer|false|Real Player e plugin para o firefox" )
    opcoes=( "${opcoes[@]}" "do_handbrake|false|Conversor de vídeos HandBrake 0.9.4" ) 
    opcoes=( "${opcoes[@]}" "do_filezilla|false|Cliente de FTP Filezilla" )
    opcoes=( "${opcoes[@]}" "do_deluge|false|Cliente de bittorrent Deluge" )
    opcoes=( "${opcoes[@]}" "do_java|false|Java(sun-java ou openjdk)" )
    opcoes=( "${opcoes[@]}" "do_frostwire|false|Cliente de redes P2P Frostwire" )
    opcoes=( "${opcoes[@]}" "do_cairo_dock|false|Cairo-Dock" )
    opcoes=( "${opcoes[@]}" "do_inkscape|false|Inkscape night build" )
    opcoes=( "${opcoes[@]}" "do_remaster_ubuntu|false|Ferramentas para remasterizar o Ubuntu v10.04.9" )
    opcoes=( "${opcoes[@]}" "do_escritorio_estendido|false|Mais programas para uso em escritório (OCR,vetorial,...)" )
    opcoes=( "${opcoes[@]}" "do_descarregar_modelos|false|OpenOffice.org:Modelos de documentos OpenDocuments" )
    opcoes=( "${opcoes[@]}" "do_descarregar_oo3_vero|false|OpenOffice.org:Vero, um corretor ortográfico" )
    opcoes=( "${opcoes[@]}" "do_descarregar_oo3_cogroo|false|OpenOffice.org:Cogroo, um corretor gramatical" )
    opcoes=( "${opcoes[@]}" "do_descarregar_oo3_dicsin|false|OpenOffice.org:DicSin, um dicionário de sinonimos/antonimos" )  
    opcoes=( "${opcoes[@]}" "do_descarregar_oo3_pdf|false|OpenOffice.org:ImportPDF, um editor de PDF" )  
    opcoes=( "${opcoes[@]}" "do_mscorefonts|false|Microsoft Core Fonts" )
    opcoes=( "${opcoes[@]}" "do_fontes|false|Fontes - Muitas fontes de caracteres tipográficos" )
    opcoes=( "${opcoes[@]}" "do_temas|false|Temas para o Ubuntu Perfeito v10.04.11" )
    opcoes=( "${opcoes[@]}" "do_gnomesubtitles|false|Editor de legendas gnome-subtitles(requer mono)" )
    opcoes=( "${opcoes[@]}" "do_temas_bisigi|false|Instalar a coleção de temas bisigi" )
    opcoes=( "${opcoes[@]}" "do_google_chrome|false|Google Chrome-versão estável" )
    opcoes=( "${opcoes[@]}" "do_skype|false|Skype" )
    opcoes=( "${opcoes[@]}" "do_google_earth|false|Google Earth" )
    opcoes=( "${opcoes[@]}" "do_google_picasa|false|Gerenciador de albuns de fotos Google Picasa" )
    opcoes=( "${opcoes[@]}" "do_virtualbox|false|VirtualBox 3.2" )
    opcoes=( "${opcoes[@]}" "do_klavaro|false|Curso de digitação usando o programa Klavaro" )
    opcoes=( "${opcoes[@]}" "do_jogos|false|Jogos para Linux" )
    opcoes=( "${opcoes[@]}" "do_jogos_supertuxkart|false|Entretenimento:SuperTuxKart" )
    opcoes=( "${opcoes[@]}" "do_instalar_ps3_multimedia_server|false|Servidor de Multimedia para PlayStation 3" )
    opcoes=( "${opcoes[@]}" "do_admin_rede|false|Ferramentas para Administradores de Rede/Segurança" )
    opcoes=( "${opcoes[@]}" "do_horario_verao|false|Ajuste automático do horário de verão" )
    opcoes=( "${opcoes[@]}" "do_programacao_gnome|false|Ferramentas para programação em Python e GNOME" )
    opcoes=( "${opcoes[@]}" "do_mono_remove|false|Remover bibliotecas Mono do Sistema" )
    opcoes=( "${opcoes[@]}" "do_repositorio_keys --force|false|Atualizar todas as chaves e assinaturas de repositórios" )
    opcoes=( "${opcoes[@]}" "do_repositorio remove|false|Remover repositórios acrescentados" )
    opcoes=( "${opcoes[@]}" "do_reinit_menu|false|Forçar este menu a mostrar todas as opções" )
    opcoes=( "${opcoes[@]}" "do_sobre|true|Sobre este programa" )
    
    # criando as opcoes para o menu atual
    STARTING=0
    FINISH=${#opcoes[*]} 
    tempmenu=""
    tempfile=`mktemp`
    unset linha
    for linha in "${opcoes[@]}" ; do
        STARTING=$((STARTING+1))
        acrescentar_no_menu="N"
        mainmenu_func=`echo $linha|cut -d"|" -f1`
        mainmenu_bool=`echo $linha|cut -d"|" -f2`
        # tenho que colocar _ no lugar dos espaços senao nao funciona
        mainmenu_texto=`echo $linha|cut -d"|" -f3|tr " " "_"`
        # eu preferia conforme abaixo, sem "_", mas infelizmente ainda não fui capaz.
        #mainmenu_texto=`echo $linha|cut -d"|" -f3`
        # verifica se esta opcao ja nao executada, se foi
        # entao nao acrescentar no menu
        if [ -f "$PASTA_TMP/menu_$ppa_repos.cat" ] ; then
          EXISTE=`cat "$PASTA_TMP/menu_$ppa_repos.cat"|grep "$mainmenu_texto"|wc -l`
          [ "$EXISTE" -eq 0 2>/dev/null ] && acrescentar_no_menu="S"
        else
          acrescentar_no_menu="S"
        fi
        [ "${acrescentar_no_menu}" = "S" ] && tempmenu="${tempmenu} ${mainmenu_bool} ${mainmenu_texto} "
        echo $tempmenu >$tempfile
        echo $((STARTING*100/$FINISH))
    done|zenity --progress --auto-close --title="Aguarde..." --text "Criando o menu principal e removendo as opçoes já executadas..."

    mainmenu=""
    while read next_line ; do
      mainmenu="${mainmenu} ${next_line}"
    done <$tempfile
    
    [ -f $tempfile ] && rm -f $tempfile
    SAIR_DO_MENU="N"
    unset OPC_MENU
    unset OPCOES_ESCOLHIDAS
    OPC_MENU=`zenity $ZEN_SIZE \
        --list --checklist --title "Ubuntu Perfeito" \
        --text "$WHOAMI, marque as tarefas que gostaria de instalar" \
        --column "#" --column "Tarefa" \
        ${mainmenu}`;
    [ "$?" -ne 0 ] && SAIR_DO_MENU="S"

    unset este_item
    unset linha
    unset mainmenu_func
    unset mainmenu_bool
    unset mainmenu_texto

    # Capturando as opcoes que foram escolhidas
    if [ "$SAIR_DO_MENU" != "S" ] ; then
      OPCOES_ESCOLHIDAS=`echo "$OPC_MENU"|tr "|" " " `
    fi
    
    #
    # Configurando um proxy, se esta opção foi marcada
    #
    [[ "$OPCOES_ESCOLHIDAS" =~ "Configurar_a_execução_deste_script" ]] && do_setconfig;
        
    #
    # Testando o acesso a internet
    #
    INTERNET_OK="N"
    [ "$SAIR_DO_MENU" != "S" ] && do_test_internet;

    if  [ "$PROXY_SERVER" = "" ] && \
        [ "$SAIR_DO_MENU" != "S" ] && \
        [ "$INTERNET_OK" != "S" ] ; then
        zenity --question --title="Ops ! Cadê a Internet ?" \
              --text "Infelizmente este programa só pode ser executado quando houver acesso a internet.\nSem o acesso a internet, algumas tarefas nunca poderão ser completadas.\nSe estiver sob restrição dum proxy então, configure-o no menu principal.\nContinuar assim mesmo ?"
        if [ $? -ne 0 ] ; then
          do_cmd_stop
          exit 3;
        fi
    fi
    #
    # Executando cada opção do menu que foi marcada
    #          
    for este_item in $OPCOES_ESCOLHIDAS ; do
      for linha in "${opcoes[@]}"; do
        CANCELAR="N"
        mainmenu_func=`echo $linha|cut -d"|" -f1`
        mainmenu_bool=`echo $linha|cut -d"|" -f2`
        mainmenu_texto=`echo $linha|cut -d"|" -f3|tr " " "_"`
        if [ "$este_item" = "$mainmenu_texto" ] ; then    
          [ "$SE_DEBUG" = "S" ] && zenity --title="Debug:" --info --text "opção escolhida: $mainmenu_texto\nfunção a executar:$mainmenu_func"
          if [ "$mainmenu_func" != "do_setconfig" ] ; then
            $mainmenu_func 
          fi
          if [ "$CANCELAR" = "S" ] ; then
             zenity --question --title="Sair?" --text "O botão [cancelar] foi pressionado ou algum erro ocorreu na tarefa anterior($TAREFA), devo sair deste script (botão [Não]) ou prosseguir (botão [Sim]) ?"
             if [ $? -ne 0 ] ; then
                do_cmd_stop
                exit 3;
             fi
             [ "$MYPID" -gt 0 2>/dev/null ] && kill $MYPID
          fi 
          if [ "$PROCEDIMENTO_EXECUTADO" = "OK" ] ; then
             [ "$MODO_TAGARELA" = "S" ] && $SPEAK "$TAREFA OK"&           
             do_remover_do_menu "$mainmenu_texto"
          fi
        fi
      done
    done
    do_cmd_stop
  done
}

#
# inicio do programa
#
clear;

if [ "$USER" != "root" ] ; then
  zenity --error --title="Ops, aconteceu um erro :" --text "Infelizmente este programa só pode ser executado com o uso do comando [gksu]"
  exit 3;
fi

# Vai para o diretorio de setup (se já não estiver nele)
cd `dirname $0`

# Instalando dependencias básicas

if ! [ -f "/usr/bin/zenity" ] || \
     ! [ -f "/usr/bin/wget" ] || \
     ! [ -f "/usr/bin/gdebi" ] || \
     ! [ -f "/usr/bin/xrandr" ] || \
     ! [ -f "/usr/bin/notify-send" ] || \
     ! [ -f "/bin/sed" ]  ; then
  do_install_deps;
  if ! [ -f "/usr/bin/zenity" ] || \
     ! [ -f "/usr/bin/wget" ] || \
     ! [ -f "/usr/bin/gdebi" ] || \
     ! [ -f "/usr/bin/xrandr" ] || \
     ! [ -f "/usr/bin/notify-send" ] || \
     ! [ -f "/bin/sed" ]  ; then
    echo "As dependencias basicas não foram encontrados no seu sistema. Instale-os :"
    echo "sudo apt-get install zenity wget sed x11-xserver-utils gdebi xrandr libnotify-bin"
    zenity --error --title="Ops, aconteceu um erro :" --text "As dependencias basicas não foram encontrados no seu sistema. Instale-os :\nsudo apt-get install zenity wget sed x11-xserver-utils gdebi xrandr libnotify-bin"
    exit 2;
  fi
fi

# Variaveis importantes
UBUNTU_BIN="/usr/share/ubuntuperfeito-lucid/ubuntu-perfeito.sh"
UBUNTU_VARS="/usr/share/ubuntuperfeito-lucid/ubuntu-perfeito.var"
. $UBUNTU_VARS

if [ -z "$EMAILME" ] || \
   [ -z "$PACKAGE_NAME" ] || \
   [ -z "$ICONE" ] || \
   [ -z "$PASTA_TMP" ] ; then
  echo "Arquivo de variaiveis [ubuntu-perfeito.var]  não foi encontrado."
  exit 2;
fi

SE_ATUALIZA_IDS="S"
DATA_INICIO=`date +%d-%m-%Y+%H:%M`

if ! [ -d "$PASTA_TMP" ] ; then
  mkdir -p "$PASTA_TMP"
fi
chmod 0755 "$PASTA_TMP"
    
LEIAME="/var/log/ubuntuperfeito-$DATA_INICIO.txt"
if [ -f "$LEIAME" ] ; then
   rm -f "$LEIAME"
   SE_ATUALIZA_IDS="N"
fi
echo "touch $LEIAME"
touch "$LEIAME"

CURRENT_PID=$$
INTERNET_OK="N"
WHOAMI=""
REQUER_MENU_SERVICOS="N"
ppa_repos=`lsb_release -cs`
atualizar_repositorios="Atualizar_lista_de_repositorios_e_o_sistema_operacional"

DPKG_INSTALL="/usr/bin/dpkg -i "
#DPKG_INSTALL="/usr/bin/gdebi -n " # -n -q (non-interative e quiet)
DISTRO=`uname -a`
if [[ "$DISTRO" =~ " x86_64 " ]] ; then
  amd64="S"
else
  amd64="N"
fi

# remover o alias para todos os comandos
#shopt -s expand_aliases
unalias -a

# Somente a versao 10.x é suportado por este script
if [ "$ppa_repos" != "lucid" ] ; then
   zenity --title="Ops !" \
          --info --text "Infelizmente este programa só pode ser executado por usuários do Ubuntu 10.04 Lucid"
   exit 3;
fi

# se o 'orca' estiver carregado, entao todas as tarefas iniciadas serão 'faladas'
MODO_TAGARELA="N"
! [ -z `pidof orca` ] && do_modo_tagarela "S"

[ "$MODO_TAGARELA" = "S" ] && $SPEAK "Iniciando o Ubuntu Perfeito"& 

MSG_TITLE="Notas importantes :"
[ "$amd64" = "S" ] && MSG_TITLE="$MSG_TITLE [64bits]"

do_relatorio "$MSG_TITLE"
do_relatorio "É recomendável rodar este script a partir de instalações limpas ou recentes,"
do_relatorio "não que não funcionaria em instalações mais antigas, mas acontece que pode"
do_relatorio "haver possibilidade de conflitos com os programas existentes ou compilados."
do_relatorio "Se encontrar erros e quiser aponta-los, envie uma mensagem para :"
do_relatorio "$EMAILME"
do_relatorio ""
do_relatorio "Inciando a execução em $DATA_INICIO"
do_relatorio "O arquivo de log será gravado em $LEIAME"
# Notas iniciais
zenity --title="$MSG_TITLE" \
       --info --text "Importante :\n\tEste programa só funciona se tiver internet presente, sem a internet ele poderá até ser executado, porém algumas tarefas requerem descarregar programas essenciais para o correto funcionamento do computador e se isso não for suprido, o sistema paralizará.\n\tCada tarefa quando executada não poderá ser interrompida bruscamente, em poucas palavras NAO DÊ CTRL+C quando alguma janela estiver dizendo que está instalando programas, pois isso poderá quebrar a dependencias de pacotes.\n\tEste sistema lhe é fornecido do jeito que se encontra, não há garantias, nem suporte. Use-o por sua conta e risco.\n\A qualquer pessoa é permitido copiar e distribuir cópias desse programa desde que respeite a titularidade do autor e a licença GNU Lesser General Public License (LGPL) cujos detalhes podem ser encontrados em :\n\thttp://pt.wikipedia.org/wiki/LGPL\n\thttp://www.fsfla.org/svnwiki/trad/GPLv3\n\nAte mais,\n\nH.\n$EMAILME"

# descobrindo quem sou eu
WHOAMI=`do_selecionar_usuario "Quem sou eu ?" "Para a correta execução desse script,\nPreciso saber quem é que está executando-o neste instante."`

if [ "$WHOAMI" = "" ] ; then
   zenity --question --title="Ops !"  --question --text "Foi requisitado na tela anterior a seleção do usuário que está executando esta instalação, mas aparentemente não foi selecionado nenhum.\nÉ altamente recomendável que voce especifique quem é você, pois algumas operações podem necessitar disso.\nVoce gostaria de prosseguir mesmo sem ter selecionado quem é você e assumir o risco de algumas etapas serem ignoradas ?"
   [ $? -ne 0 ] &&  exit 2;
fi

# verifica se todos os repositorios necessarios estao habilitados
do_confere_todos_repositorios

# finalmente o menu
do_menu;

[ -f "$PASTA_TMP/menu_$ppa_repos.cat" ] && chmod 666 "$PASTA_TMP/menu_$ppa_repos.cat"
[ "$REQUER_MENU_SERVICOS" = "S" ] && do_menuservicos;

DATA_FIM=`date +%d-%m-%Y+%H:%M`
do_relatorio "Finalizando o script em $DATA_FIM"
do_relatorio "Todos os arquivos descarregados da internet foram gravados em $PASTA_TMP."
do_relatorio "O guia Ubuntu Perfeito está concluído !"

# Exibindo relatorio
zenity --title="Guia Ubuntu Perfeito completo :" --text-info --filename="$LEIAME" &

exit 0;
