#!/bin/bash
# script para aplicar o tema Ubuntu Perfeito na area de trabalho
# primeiro desligamos todos os icones na tela :
function do_tema_sonoro_padrao() {
  if [ -d "/usr/share/sounds/sound-theme-freedesktop" ] ; then
      gconftool-2 --type string --set "/desktop/gnome/sound/theme_name" "sound-theme-freedesktop" 
      gconftool-2 --type bool --set "/desktop/gnome/sound/input_feedback_sounds" "true"       
      zenity --notification --text "Um novo tema sonoro foi instalado em [/usr/share/sounds/sound-theme-freedesktop].Use Sistema->Preferencias->Som para configura-lo caso não perceba nenhuma alteração sonora."&	        
  else
    zenity --error --title "Importante :" --text "O tema sonoro não foi instalado em [/usr/share/sounds/sound-theme-freedesktop].\nExecute novamente o Ubuntu Perfeito e execute a tarefa de instalação de temas."
  fi
}

function do_interface_padrao() {
  # Ajusta as cores do terminal, renderizacao das fontes, posicoes dos botoes fechar/minimizar/maximizar e ponteiro do mouse

  if [ "$SE_MONITOR_LCD" = "S" ] ; then
      # Monitores LCD podem ter a exibição das fontes melhoradas
      gconftool-2 --type string --set "/desktop/gnome/font_rendering/antialiasing" "rgba"
      gconftool-2 --type string --set "/desktop/gnome/font_rendering/hinting" "full"
      gconftool-2 --type string --set "/desktop/gnome/font_rendering/rgba_order" "rgb"
  else
      # Monitores CRT podem ter a exibição das fontes melhoradas
      gconftool-2 --type string --set "/desktop/gnome/font_rendering/antialiasing" "grayscale"
      gconftool-2 --type string --set "/desktop/gnome/font_rendering/hinting" "full"
      gconftool-2 --type string --set "/desktop/gnome/font_rendering/rgba_order" "rgb"
  fi

  # Mudando a cor de fundo do gnome-terminal
  gconftool-2 --type bool --set "/apps/gnome-terminal/profiles/Default/use_theme_colors" "false"
  gconftool-2 --type string --set "/apps/gnome-terminal/profiles/Default/background_color" "#000000"
  gconftool-2 --type string --set "/apps/gnome-terminal/profiles/Default/foreground_color" "#FFFFFF"
  if [ "$SE_MONITOR_LCD" = "S" ] ; then
    # Monitores LCD podem ter a exibição das fontes melhoradas
    gconftool-2 --type string --set "/desktop/gnome/font_rendering/antialiasing" "rgba"
    gconftool-2 --type string --set "/desktop/gnome/font_rendering/hinting" "slight"
    gconftool-2 --type string --set "/desktop/gnome/font_rendering/rgba_order" "rgb"
  else
    # Monitores CRT podem ter a exibição das fontes melhoradas
    gconftool-2 --type string --set "/desktop/gnome/font_rendering/antialiasing" "grayscale"
    gconftool-2 --type string --set "/desktop/gnome/font_rendering/hinting" "full"
    gconftool-2 --type string --set "/desktop/gnome/font_rendering/rgba_order" "rgb"
  fi

  # Ajusta as fontes da tela para aplicar as fontes Liberation
  #gconftool-2 --type string --set "/desktop/gnome/interface/document_font_name" "Liberation Sans 10"
  #gconftool-2 --type string --set "/desktop/gnome/interface/font_name" "Liberation Sans 10"
  #gconftool-2 --type string --set "/desktop/gnome/interface/monospace_font_name" "Liberation Mono 10"
  #gconftool-2 --type string --set "/apps/metacity/general/titlebar_font" "Liberation Sans Bold 10"
  #gconftool-2 --type string --set "/apps/nautilus/preferences/desktop_font" "Liberation Sans 10"
  # botoes de minimizar/maximizar/fechar
  gconftool-2 --type string --set /apps/metacity/general/button_layout  "menu:minimize,maximize,close"
  # cursor do mouse
  gconftool-2 --type string --set /desktop/gnome/peripherals/mouse/cursor_theme "default"
}

function do_tema_ubuntu_big() {
  # papel de parede
  #PAPEL_PAREDE="/usr/share/backgrounds/OTHER-LinuxJoinTheRevolution_1600x1200.jpg"
  PAPEL_PAREDE="/usr/share/backgrounds/ubuntu_big_1600x1200.jpg"
  [ "$RESY" = "1024" ] && PAPEL_PAREDE="/usr/share/backgrounds/ubuntu_big_1024x768.jpg"
  [ "$RESY" = "1280" ] && PAPEL_PAREDE="/usr/share/backgrounds/ubuntu_big_1280x1024.jpg"
  [ "$RESY" = "1440" ] && PAPEL_PAREDE="/usr/share/backgrounds/ubuntu_big_1440x900.jpg"
  [ "$RESY" = "1600" ] && PAPEL_PAREDE="/usr/share/backgrounds/ubuntu_big_1600x1200.jpg"

  [ -f "$PAPEL_PAREDE" ] && gconftool-2 --type string --set "/desktop/gnome/background/picture_filename" "$PAPEL_PAREDE"
  gconftool-2 --type string --set "/desktop/gnome/background/picture_options" "stretched"
  gconftool-2 --type string --set "/apps/metacity/general/theme" "Dust"
  gconftool-2 --type string --set "/desktop/gnome/interface/gtk_theme" "New Wave"  # trocar este tema
  gconftool-2 --type bool --set "/apps/metacity/general/titlebar_uses_system_font" "true"
  gconftool-2 --type string --set "/desktop/gnome/interface/icon_theme" "hydroxygen"

  # Ajusta as cores do terminal, renderizacao das fontes, posicoes dos botoes fechar/minimizar/maximizar e ponteiro do mouse
  do_interface_padrao;
}


function do_tema_ffox_laranja() {
  # papel de parede
  PAPEL_PAREDE="/usr/share/backgrounds/ffrtwg16.png"
  # Firefox #1 - laranja
  PAPEL_PAREDE="/usr/share/backgrounds/ffrtwg16.png"
  [ "$RESY" = "1024" ] && PAPEL_PAREDE="/usr/share/backgrounds/ffrtwg10.png"
  [ "$RESY" = "1280" ] && PAPEL_PAREDE="/usr/share/backgrounds/ffrtwg12.png"
  [ "$RESY" = "1440" ] && PAPEL_PAREDE="/usr/share/backgrounds/ffrtwg16.png"
  [ "$RESY" = "1600" ] && PAPEL_PAREDE="/usr/share/backgrounds/ffrtwg16.png"

  [ -f "$PAPEL_PAREDE" ] && gconftool-2 --type string --set "/desktop/gnome/background/picture_filename" "$PAPEL_PAREDE"
  gconftool-2 --type string --set "/desktop/gnome/background/picture_options" "stretched"
  gconftool-2 --type string --set "/apps/metacity/general/theme" "Dust"
  gconftool-2 --type string --set "/desktop/gnome/interface/gtk_theme" "New Wave"  # trocar este tema
  gconftool-2 --type bool --set "/apps/metacity/general/titlebar_uses_system_font" "true"
  gconftool-2 --type string --set "/desktop/gnome/interface/icon_theme" "hydroxygen"

  # Ajusta as cores do terminal, renderizacao das fontes, posicoes dos botoes fechar/minimizar/maximizar e ponteiro do mouse
  do_interface_padrao;
}

function do_tema_ffox_cinza() {
  # papel de parede
  PAPEL_PAREDE="/usr/share/backgrounds/ffrtws16.png"
  # Firefox #2 - cinza
  [ "$RESY" = "1024" ] && PAPEL_PAREDE="/usr/share/backgrounds/ffrtws10.png"
  [ "$RESY" = "1280" ] && PAPEL_PAREDE="/usr/share/backgrounds/ffrtws12.png"
  [ "$RESY" = "1440" ] && PAPEL_PAREDE="/usr/share/backgrounds/ffrtws16.png"
  [ "$RESY" = "1600" ] && PAPEL_PAREDE="/usr/share/backgrounds/ffrtws16.png"

  [ -f "$PAPEL_PAREDE" ] && gconftool-2 --type string --set "/desktop/gnome/background/picture_filename" "$PAPEL_PAREDE"
  gconftool-2 --type string --set "/desktop/gnome/background/picture_options" "stretched"
  gconftool-2 --type string --set "/apps/metacity/general/theme" "Dust"
  gconftool-2 --type string --set "/desktop/gnome/interface/gtk_theme" "Dust Sand"
  gconftool-2 --type bool --set "/apps/metacity/general/titlebar_uses_system_font" "true"
  gconftool-2 --type string --set "/desktop/gnome/interface/icon_theme" "elementary"

  # Ajusta as cores do terminal, renderizacao das fontes, posicoes dos botoes fechar/minimizar/maximizar e ponteiro do mouse
  do_interface_padrao;
}

function do_tema_ffox_azul() {
  # Firefox #3 - azul
  PAPEL_PAREDE="/usr/share/backgrounds/ffrtw16.png"
  [ "$RESY" = "1024" ] && PAPEL_PAREDE="/usr/share/backgrounds/ffrtw10.png"
  [ "$RESY" = "1280" ] && PAPEL_PAREDE="/usr/share/backgrounds/ffrtw12.png"
  [ "$RESY" = "1440" ] && PAPEL_PAREDE="/usr/share/backgrounds/ffrtw16.png"
  [ "$RESY" = "1600" ] && PAPEL_PAREDE="/usr/share/backgrounds/ffrtw16.png"


  [ -f "$PAPEL_PAREDE" ] && gconftool-2 --type string --set "/desktop/gnome/background/picture_filename" "$PAPEL_PAREDE"
  gconftool-2 --type string --set "/apps/metacity/general/theme" "Dust"
  gconftool-2 --type bool   --set "/apps/metacity/general/titlebar_uses_system_font" "true"
  gconftool-2 --type string --set "/desktop/gnome/interface/gtk_theme" "New Wave"  # trocar este tema
  gconftool-2 --type string --set "/desktop/gnome/interface/icon_theme" "hydroxygen"
  gconftool-2 --type string --set "/desktop/gnome/background/picture_options" "stretched"


  # Ajusta as cores do terminal, renderizacao das fontes, posicoes dos botoes fechar/minimizar/maximizar e ponteiro do mouse
  do_interface_padrao;
}

function do_tema_newwave() {
  # Newwave
  PAPEL_PAREDE="/usr/share/backgrounds/1163730421_0acf0bd682_o_d.png"

  [ -f "$PAPEL_PAREDE" ] && gconftool-2 --type string --set "/desktop/gnome/background/picture_filename" "$PAPEL_PAREDE"
  gconftool-2 --type string --set "/apps/metacity/general/theme" "New Wave"
  gconftool-2 --type bool   --set "/apps/metacity/general/titlebar_uses_system_font" "true"
  gconftool-2 --type string --set "/desktop/gnome/interface/gtk_theme" "New Wave"
  gconftool-2 --type string --set "/desktop/gnome/interface/icon_theme" "OxygenRefit2"
  gconftool-2 --type string --set "/desktop/gnome/background/picture_options" "stretched"

  # Ajusta as cores do terminal, renderizacao das fontes, posicoes dos botoes fechar/minimizar/maximizar e ponteiro do mouse
  do_interface_padrao;
}

function do_tema_ubuntuperfeito() {
  # Ajusta as cores do terminal, renderizacao das fontes, posicoes dos botoes fechar/minimizar/maximizar e ponteiro do mouse
  do_interface_padrao;

  PAPEL_PAREDE="/usr/share/backgrounds/BusquedaNocturna.jpg"
  TEMA_VISUAL="Equinox Glass"
  TEMA_ICONE="Faenza"
  TEMA_METACITY="Equinox Glass"
  TEMA_FONTE="Sans 10"
  TEMA_FONTE_MONO="Monospace 10"
  TEMA_FONTE_TITLEBAR="Sans Bold 10"
  [ -f "$PAPEL_PAREDE" ] && gconftool-2 --type string --set "/desktop/gnome/background/picture_filename" "$PAPEL_PAREDE"
  gconftool-2 --type string --set "/desktop/gnome/background/picture_options" "stretched" 

  gconftool-2 --type string --set "/desktop/gnome/interface/gtk_theme" "$TEMA_VISUAL"
  gconftool-2 --type string --set "/desktop/gnome/interface/icon_theme" "$TEMA_ICONE"
  gconftool-2 --type bool --set "/apps/metacity/general/titlebar_uses_system_font" "true"
  gconftool-2 --type string --set "/apps/metacity/general/theme" "$TEMA_METACITY"
  gconftool-2 --type string --set "/apps/metacity/general/button_layout" "menu:minimize,maximize,close"
  # Fontes liberation Sans
  gconftool-2 --type string --set "/desktop/gnome/interface/document_font_name" "$TEMA_FONTE"
  gconftool-2 --type string --set "/desktop/gnome/interface/font_name" "$TEMA_FONTE"
  gconftool-2 --type string --set "/desktop/gnome/interface/monospace_font_name" "$TEMA_FONTE_MONO"
  gconftool-2 --type string --set "/apps/metacity/general/titlebar_font" "$TEMA_FONTE_TITLEBAR"
  gconftool-2 --type string --set "/apps/nautilus/preferences/desktop_font" "$TEMA_FONTE"
}

#
# inicio do programa
#
. /usr/share/ubuntuperfeito-lucid/ubuntu-perfeito.var

if [ -z "$EMAILME" ] || \
   [ -z "$PACKAGE_NAME" ] || \
   [ -z "$ICONE" ] || \
   [ -z "$PASTA_TMP" ] ; then
  echo "Arquivo de variaiveis [ubuntu-perfeito.var]  não foi encontrado."
  exit 2;
fi

clear;

  ERRO="N"
  unset files
  files=( "${files[@]}" "/usr/share/icons/elementary" )
  files=( "${files[@]}" "/usr/share/icons/Discovery" )
  #files=( "${files[@]}" "/usr/share/themes/Mythbuntu" )
  #files=( "${files[@]}" "/usr/share/icons/nimbus" )
  files=( "${files[@]}" "/usr/share/themes/Dust" )
  files=( "${files[@]}" "/usr/share/themes/Dust Sand" )
  files=( "${files[@]}" "/usr/share/sounds/dream" )
  files=( "${files[@]}" "/usr/share/themes/New Wave" )
  files=( "${files[@]}" "/usr/share/icons/OxygenRefit2" )
  files=( "${files[@]}" "/usr/share/icons/hydroxygen" )
  for test_file in "${files[@]}" ; do    
    if ! [ -d "$test_file" ] ; then
      ERRO="S"
      zenity --error --title="Problema :" \
              --text "Parece que o tema :\n\t$test_file\nnão foi instalado.\nEle pode ser instalado atraves do Ubuntu Perfeito usando o tópico [Temas com aparencias variadas].\nSe este item não existir no menu então selecione e execute o item [Recriar este menu com todas as opções]."
    fi
  done

  if [ "$ERRO" = "S" ] ; then
     zenity --error --title="Temas faltantes"   --text "A aplicação dos temas do Ubuntu Perfeito requer que todos os temas indicados no menu do Ubuntu Perfeito estejam instalados, infelizmente parece que faltaram alguns.\nEles podem ser instalados atraves do Ubuntu Perfeito usando o tópico [Temas com aparencias variadas] que se não existir basta optar por [Recriar este menu com todas as opções]."   
     exit 2;
fi

METACITY="N"
COMPIZ="N"
SE_MONITOR_LCD="N"
# Verifica se há um ou mais monitores conectados ao sistema, se houver apenas um
# entao calcula a area que poderá usar na tela
# se houver dois entao usará o monimo possivel 800x600
if [ `/usr/bin/xrandr | grep '*'|cut -d"x" -f1|wc -l` -eq 1 ] ; then
# resolução atual, onde Y=larg, X=comprimento (1400x900, 1024x768,1280x1024,1280x900,...)
  RESY=`/usr/bin/xrandr | grep '*'|cut -d"x" -f1|tr -d " " |cut -d "@" -f1`
  RESX=`/usr/bin/xrandr | grep '*'|cut -d"x" -f2|cut -d " " -f1|cut -d "@" -f1`
  # Tamanho/icone para a janela do zenity
  ZEN_WIDTH=$((RESY-100))
  [ "$ZEN_WIDTH" -gt 640 ] && ZEN_WIDTH=640
  ZEN_HEIGHT=$((RESX-150))
  [ "$ZEN_HEIGHT" -gt 800 ] && ZEN_HEIGHT=800
else
  ZEN_WIDTH=600
  ZEN_HEIGHT=800
fi
ZEN_SIZE=" --width=$ZEN_WIDTH --height=$ZEN_HEIGHT --window-icon=$ICONE "
INTREPID="N"
HARDY="N"
[ `cat /etc/issue|grep "Ubuntu 8.10"|wc -l` -gt 0 2>/dev/null ] && INTREPID="S"
[ `cat /etc/issue|grep "Ubuntu 8.04"|wc -l` -gt 0 2>/dev/null ] && HARDY="S"

[ `ps aux|grep metacity|grep -v "grep"|wc -l` -gt 0 ] && METACITY="S"
[ `ps aux|grep /usr/bin/compiz.real|grep -v "grep"|wc -l` -gt 0 ] && COMPIZ="S"

TEMA=""
while [ "$TEMA" != "Sair" ] ; do
  TEMA=`zenity $ZEN_SIZE \
          --list --radiolist \
          --title "Aplicar tema do Repositório Ubuntu Perfeito :" \
          --text "Um tema é uma aparencia para seu dekstop formato por :\npapel de parede, fontes de letras, Controles, Cores, Margem da janela, ícones e ponteiro do mouse.\nEles mudam o aspecto de seu desktop tornando-o mais bonito a seu bel-prazer." \
          --column " " \
          --column "Escolha um dos temas :" \
          false "Ubuntu Perfeito" \
          false "New Wave" \
          false "Ubuntu Big" \
          false "Firefox Vermelho" \
          false "Firefox Cinza" \
          false "Firefox Azulado" \
          false "Sair"`;
  if [ $? -ne 0 ] ; then
     exit 3;
  fi

  if [ "$TEMA" != "Sair" ] ; then
    # Inicio das aplicacoes
    if [ "$METACITY" = "S" ] ; then
       zenity --question --title="Habilitar Compositing ?" --text "Posso habilitar o compositing no metacity ?"
       if [ $? -eq 0 ] ; then
         gconftool-2 --type bool --set "/apps/metacity/general/compositing_manager" "true"
         zenity --info --title="Compositing habilitado"   --text "O compositing do metacity está ativado, porém se for ativar o compiz no futuro, lembre de desativa-lo, pois conforme reporta este bug:\nhttps://bugs.launchpad.net/ubuntu/+source/metacity/+bug/178953\nNão é possivel ativar o compiz com o compositing-metacity habilitado.\nVoce poderá usar o menu de serviços para ativar/desativar o compositing-metacity."
       else
         gconftool-2 --type bool --set "/apps/metacity/general/compositing_manager" "false"
       fi
    fi

    /usr/bin/zenity --question --title="Renderização das fontes :"  --question --text "Gostaria de ativar a renderização das fontes para LCD ?"
    [ $? -eq 0 ] && SE_MONITOR_LCD="S"

    [ "$TEMA" == "New Wave" ] && do_tema_newwave;
    [ "$TEMA" == "Ubuntu Perfeito" ] && do_tema_ubuntuperfeito;
    [ "$TEMA" == "Ubuntu Big" ] && do_tema_ubuntu_big;
    [ "$TEMA" == "Firefox Vermelho" ] && do_tema_ffox_laranja;
    [ "$TEMA" == "Firefox Cinza" ] && do_tema_ffox_cinza;
    [ "$TEMA" == "Firefox Azulado" ] && do_tema_ffox_azul;
    #[ "$TEMA" == "xxxx" ] && xxxxx;
    # efeitos sonoros
    #do_tema_sonoro_padrao;
  fi
done

# aviso-alerta
zenity --info --title="Importante :" --text "O Ubuntu Perfeito aplicou um tema novo em seu sistema, devido aos caprichos desse novo visual ele poderá deixa-lo com resposividade menor para compor janelas.\nSe notar que a menor responsividade para exibir as janelas não compensa o apelo do novo visual então aplique o tema padrão do Ubuntu -via menu de serviços- que retornará a situação anterior.\nHá muitos outros temas instalados, talvez com outro você tenha um custo/beneficio melhor."
