#!/bin/bash
# Objetivo : Voltar a aplicar tema original do Ubuntu
. /usr/share/ubuntuperfeito-lucid/ubuntu-perfeito.var

if [ -z "$EMAILME" ] || \
   [ -z "$PACKAGE_NAME" ] || \
   [ -z "$ICONE" ] || \
   [ -z "$PASTA_TMP" ] ; then
  echo "Arquivo de variaiveis [ubuntu-perfeito.var]  não foi encontrado."
  exit 2;
fi

SE_MONITOR_LCD="N"
METACITY="N"
COMPIZ="N"
INTREPID="N"
HARDY="N"
[ `cat /etc/issue|grep "Ubuntu 8.10"|wc -l` -gt 0 2>/dev/null ] && INTREPID="S"
[ `cat /etc/issue|grep "Ubuntu 8.04"|wc -l` -gt 0 2>/dev/null ] && HARDY="S"

[ `ps aux|grep metacity|grep -v "grep"|wc -l` -gt 0 ] && METACITY="S"
[ `ps aux|grep /usr/bin/compiz.real|grep -v "grep"|wc -l` -gt 0 ] && COMPIZ="S"

/usr/bin/zenity --question --title="Renderização das fontes :"  --question --text "Gostaria de ativar a renderização das fontes para Monitores LCD ?"
[ $? -eq 0 ] && SE_MONITOR_LCD="S"
if [ "$SE_MONITOR_LCD" = "S" ] ; then
    # Monitores LCD podem ter a exibição das fontes melhoradas
    gconftool-2 --type string --set "/desktop/gnome/font_rendering/antialiasing" "rgba"
    gconftool-2 --type string --set "/desktop/gnome/font_rendering/hinting" "slight"
    gconftool-2 --type string --set "/desktop/gnome/font_rendering/rgba_order" "rgb"
else
    # Monitores CRT podem ter a exibição das fontes melhoradas
    gconftool-2 --type string --set "/desktop/gnome/font_rendering/antialiasing" "grayscale"
    gconftool-2 --type string --set "/desktop/gnome/font_rendering/hinting" "slight"
    gconftool-2 --type string --set "/desktop/gnome/font_rendering/rgba_order" "rgb"
fi
THEME_NAME="Human"
THEME_ICON="Human"
THEME_WALLPAPER="/usr/share/backgrounds/warty-final-ubuntu.png"
THEME_CURSOR="default"
gconftool-2 --type string --set "/desktop/gnome/background/picture_filename" "$THEME_WALLPAPER"
gconftool-2 --type string --set "/desktop/gnome/background/picture_options" "stretched"
gconftool-2 --type string --set "/desktop/gnome/interface/gtk_theme" "$THEME_NAME"
gconftool-2 --type string --set "/apps/metacity/general/theme" "$THEME_NAME"
gconftool-2 --type string --set /apps/metacity/general/button_layout  "menu:minimize,maximize,close"
gconftool-2 --type boolean --set /desktop/gnome/interface/menus_have_icons "true"
gconftool-2 --type string --set /desktop/gnome/interface/toolbar_style "icons"
gconftool-2 --type bool   --set "/apps/metacity/general/titlebar_uses_system_font" "false"
gconftool-2 --type string --set "/desktop/gnome/interface/icon_theme" "$THEME_ICON"
# cursor
gconftool-2 --type string --set "/desktop/gnome/peripherals/mouse/cursor_theme" "$THEME_CURSOR"  
# Ajusta as fontes da tela para aplicar as fontes Liberation
#gconftool-2 --type string --set "/desktop/gnome/interface/document_font_name" "Liberation Sans 10"
#gconftool-2 --type string --set "/desktop/gnome/interface/font_name" "Liberation Sans 10"
#gconftool-2 --type string --set "/desktop/gnome/interface/monospace_font_name" "Liberation Mono 10"
#gconftool-2 --type string --set "/apps/metacity/general/titlebar_font" "Liberation Sans Bold 10"
#gconftool-2 --type string --set "/apps/nautilus/preferences/desktop_font" "Liberation Sans 10"
if  [ "/home/$USERNAME/.config/autostart/cairo-dock.desktop" ] ; then
  rm -f "/home/$USERNAME/.config/autostart/cairo-dock.desktop"
fi
# removendo tema sonoro
if [ -f /home/$USERNAME/.gnome/sound/events/gnome.soundlist ] ; then
  rm -f /home/$USERNAME/.gnome/sound/events/gnome.soundlist
fi
if [ "$INTREPID" = "S" ] ; then
  gconftool-2 --type string --set "/desktop/gnome/sound/theme_name" "Ubuntu"  
fi
# removendo compositing
gconftool-2 --type bool --set "/apps/metacity/general/compositing_manager" "false"
# autohide
gconftool-2 --type bool --set "/apps/panel/toplevels/bottom_panel_screen0/auto_hide" "false"
gconftool-2 --type bool --set "/apps/panel/default_setup/toplevels/bottom_panel/auto_hide" "false"
# remove cairo-dock
killall cairo-dock
[ -f "$HOME/.config/autostart/cairo-dock.desktop" ] && rm -f "$HOME/.config/autostart/cairo-dock.desktop"
# removendo o tema sonoro
gconftool-2 --type string --set "/desktop/gnome/sound/theme_name" "Ubuntu"
# desabilitar o compiz e dar um ultimo aviso caso o compiz não tenha sido 100% desativado.
if [ "$COMPIZ" = "S" ] ; then
  gconftool-2 --recursive-unset /apps/compiz
  /usr/bin/metacity --replace &
  gconftool-2 --type string --set "/desktop/gnome/applications/window_manager/default" "/usr/bin/metacity"
  /usr/bin/zenity --info --title="Aplicando tema original do Ubuntu :"  --text "O compiz foi desativado, porém se no próximo login ele for reativado será porque o script não conseguiu sobrepor a politica de configuracoes em Sistema->Preferencias->Aparencia e depois a guia [Efeitos Visuais].\nSe voce não quer usar o compiz de forma alguma, então será nessas [Sistema->Prefenciais->Aparencia] que deverá modificar."
fi
