#!/bin/bash
echo "conversor e mesclador de legendas."
echo "se houver .srt de mesmo nome entao a legenda será mixada ao video"
echo "-"
ICONE="totem"
ZENITY="/usr/bin/zenity"
MENCODER="/usr/bin/mencoder"
if ! [ -f "$ZENITY" ] || ! [ -f "$MENCODER" ] ; then
  echo "O programa [zenity] ou [mencoder] não foram encontrados no seu sistema. Instale-os."
  [ -f "$ZENITY" ] && $ZENITY --title="Ops !" --info --text "O programa [mencoder] não foi encontrado no seu sistema. Instale-o !"
  exit 2;
fi


#
DATA_INICIO=`date +%d-%m-%Y+%H:%M`

# mencoder + audio
EXEC_CMD_PART1=""
# video
EXEC_CMD_PART2=""
# legenda
EXEC_CMD_PART3=""

# fonte que será usado se for mesclado legendas (FreeType only)
FONT_FILE="/usr/share/fonts/truetype/ttf-liberation/LiberationSans-Bold.ttf"

FONT_FILE=`zenity --width=600 --height=400 --window-icon=$ICONE \
        --list --radiolist \
        --title "Fonte para mesclar as legendas" \
        --text "Qual a fonte gostaria que fosse usada  ?" \
        --column " " \
        --column "Arquivo TTF" \
        true "/usr/share/fonts/truetype/ttf-liberation/LiberationSans-Bold.ttf" \
        false "/home/dados/scripts/arial.ttf" \
        false "/usr/share/fonts/truetype/msttcorefonts/arialbd.ttf" \
        false "/usr/share/fonts/truetype/freefont/FreeSans.ttf"`;
ERRO="$?"
if  [ "$?" -ne "$ERRO" ] ; then
  zenity --title="Ops !" --info --text "Operação cancelada pelo operador [erro $ERRO] !"
  exit $ERRO;
fi

if ! [ -f "$FONT_FILE" ] ; then
  zenity --title="Ops !" --info --text "A fonte especificada para ser usada quando houver legendas nao existe :\n$FONT_FILE."
  exit 2;
fi

# formato encodando o audio
VIDEO_AUDIO="copy"  ## copy ou mp3
ASK_VIDEO_AUDIO=`zenity --width=600 --height=400 --window-icon=$ICONE \
        --list --radiolist \
        --title "Formato de audio" \
        --text "Qual o formato de audio ?" \
        --column " " \
        --column "Formatos disponiveis" \
        true "copy" \
        false "mp3" \
        false "mp2"`;
ERRO="$?"
if  [ "$?" -ne "$ERRO" ] ; then
   zenity --title="Ops !" --info --text "Operação cancelada pelo operador !"
  exit 2;
fi

# Autoscala para legendas
# 1=baseado na altura 
# 2=baseado na diagonal da tela
#
LEGENDA_AUTOSCALE="2"

#
# Bitrate
#
#  A bitrate of 800 will give you near DVD quality when encoding hi-quality video like a DVD disc.
# VCD quality is around 400-500.
# Internet streaming quality is generally around 80-150.
# Mencoder's default bitrate is 687 kbits/s. 
BITRATE="687"
ASK_BITRATE=`zenity --width=600 --height=400 --window-icon=$ICONE \
        --list --radiolist \
        --title "Bitrate kbits/s" \
        --text "Escolhendo onde o video será exibido, \neu posso determinar o melhor bitrate para uso" \
        --column " " \
        --column "Onde o vídeo será exibido :" \
        true "DVD (800kbits/s)" \
        false "VCD (500kbits/s)" \
        false "Internet (150kbits/s)" \
        false "padrao do conversor (687kbits/s)"`;
ERRO="$?"
if  [ "$?" -ne "$ERRO" ] ; then
   zenity --title="Ops !" --info --text "Operação cancelada pelo operador !"
  exit 2;
fi

[ "$ASK_BITRATE" == "DVD (800kbits/s)" ] && BITRATE="800"
[ "$ASK_BITRATE" == "VCD (500kbits/s)" ] && BITRATE="500"
[ "$ASK_BITRATE" == "Internet (150kbits/s)" ] && BITRATE="150"


# formato encodando o video (tambem pode determinar a extensao final)
VIDEO_FORMAT="xvid"  ## copy,xvid,x264 ou mp4
ASK_VIDEO_FORMAT=`zenity --width=600 --height=400 --window-icon=$ICONE \
        --list --radiolist \
        --title "Formato de [encode] video" \
        --text "Qual o formato de [encode] video ?" \
        --column " " \
        --column "Formatos disponiveis" \
        false "copy-apenas mantém o formato original" \
        true "xvid-toca na maioria dos DVDs" \
        false "xvid-para portateis" \
        false "x264-toca somente em aparelhos especiais como PS3, PSP dentre outros"`;


# Se for para portateis entao deve-se definir qual a resolucao
VIDEO_RES=""
VIDEO_ASPECT=""
if [ "$ASK_VIDEO_FORMAT" == "xvid-para portateis" ] ; then
  BITRATE="500"  
  ASK_VIDEO_RES=`zenity --width=600 --height=400 --window-icon=$ICONE \
        --list --radiolist \
        --title "Qual a resolução máxima permitida pelo portatil :" \
        --text "Qual a resolução máxima permitida pelo portatil ?" \
        --column " " \
        --column "Tamanhos disponiveis" \
        false "240x320" \
        false "320x240" \
        false "320x480" \
        true  "480x320" \
        false "640x480" \
        false "480x640" \
        false "272x480" \
        false "480x272" \
        false "600x800" \
        false "800x600"`;
  ERRO="$?"
  if  [ "$?" -ne "$ERRO" ] ; then
      zenity --title="Ops !" --info --text "Operação cancelada pelo operador !"
      exit 2;
  fi
  if [ "$ASK_VIDEO_RES" == "320x240" ] ; then
     VIDEO_RES="320:240"
     VIDEO_ASPECT="16:9"
  fi
  if [ "$ASK_VIDEO_RES" == "240x320" ] ; then 
     VIDEO_RES="240:320" 
     VIDEO_ASPECT="4:3"
     LEGENDA_AUTOSCALE="1"
  fi
  if [ "$ASK_VIDEO_RES" == "480x320" ] ; then 
     VIDEO_RES="480:320" 
     VIDEO_ASPECT="16:9"
     LEGENDA_AUTOSCALE="1"
  fi
  if [ "$ASK_VIDEO_RES" == "320x480" ] ; then 
     VIDEO_RES="320:480" 
     VIDEO_ASPECT="4:3"
     LEGENDA_AUTOSCALE="1"
  fi
  if [ "$ASK_VIDEO_RES" == "640x480" ] ; then 
     VIDEO_RES="640:480" 
     VIDEO_ASPECT="16:9"
  fi
  if [ "$ASK_VIDEO_RES" == "480x640" ] ; then 
     VIDEO_RES="480:640" 
     VIDEO_ASPECT="4:3"
     LEGENDA_AUTOSCALE="1"
  fi
  if [ "$ASK_VIDEO_RES" == "272x480" ] ; then 
     VIDEO_RES="272:480" 
     VIDEO_ASPECT="4:3"
     LEGENDA_AUTOSCALE="1"
  fi
  if [ "$ASK_VIDEO_RES" == "480x272" ] ; then 
     VIDEO_RES="480:272" 
     VIDEO_ASPECT="16:9"
  fi
  if [ "$ASK_VIDEO_RES" == "600x800" ] ; then 
     VIDEO_RES="600:800"
     VIDEO_ASPECT="4:3"
     LEGENDA_AUTOSCALE="1"
  fi
  if [ "$ASK_VIDEO_RES" == "800x600" ] ; then 
     VIDEO_RES="800:600"
     VIDEO_ASPECT="16:9"
  fi
fi

# formato de tela
if [ "$VIDEO_ASPECT" == "" ] ; then
  VIDEO_ASPECT="16:9"
  ASK_VIDEO_ASPECT=`zenity --width=600 --height=400 --window-icon=$ICONE \
        --list --radiolist \
        --title "Formato de tela a ser utilizado" \
        --text "Qual o formato de tela ?" \
        --column " " \
        --column "Formatos disponiveis" \
        true "16:9 (widescreen)" \
        false "4:3 (fullscreen)"`;
  ERRO="$?"
  if [ "$?" -ne "$ERRO" ] ; then
     zenity --title="Ops !" --info --text "Operação cancelada pelo operador !"
     exit 2;
  fi
  if [ "$ASK_VIDEO_ASPECT" == "16:9 (widescreen)" ] ; then
     VIDEO_ASPECT="16:9"
     LEGENDA_AUTOSCALE="2"
     [ "$VIDEO_RES" = "" ] && VIDEO_RES="624:352"
  fi
  if [ "$ASK_VIDEO_ASPECT" == "4:3 (fullscreen)" ] ; then
     VIDEO_ASPECT="4:3"
     LEGENDA_AUTOSCALE="1"
     [ "$VIDEO_RES" = "" ] && VIDEO_RES="720:480"
  fi
fi

# a linha abaixo apenas pergunta se irá executar o procedimento agora
# ou se apenas mostra onde esta o script que fará a conversao, assim
# voce poderá guardar o script na pasta dos videos e realizar a 
# operação de conversao quando bem entender.
ASK_EXECUTE=`zenity --width=600 --height=400 --window-icon=$ICONE \
        --list --radiolist \
        --title "Qual a opção a ser realizada agora ?" \
        --text "Procedimento final" \
        --column " " \
        --column "Procedimento final" \
        true "Executar a conversão agora" \
        false "Apenas gerar o script para converter mais tarde"`;
ERRO="$?"
if  [ "$?" -ne "$ERRO" ] ; then
   zenity --title="Ops !" --info --text "Operação cancelada pelo operador !"
  exit 2;
fi

if [ "$ASK_EXECUTE" == "Executar a conversão agora" ] ; then
  SOMENTE_EXIBIR_CMD="N"  
else
  SOMENTE_EXIBIR_CMD="S"  
fi

#
# Daqui em diante voce nao pode alterar mais nada
# 
if [ "$ASK_VIDEO_AUDIO" == "copy" ] ; then
  VIDEO_AUDIO="copy"
  EXEC_CMD_PART1=" -oac copy "
fi
if [ "$ASK_VIDEO_AUDIO" == "mp3" ] ; then
  VIDEO_AUDIO="mp3"
  EXEC_CMD_PART1=" -oac mp3lame -lameopts q=5:vbr=2:abr=160:aq=5:ratio=50:mode=0:vol=8 "
fi
if [ "$ASK_VIDEO_AUDIO" == "mp2" ] ; then
  VIDEO_AUDIO="mp2"
  EXEC_CMD_PART1=" -oac lavc "
fi

if [ "$ASK_VIDEO_FORMAT" == "copy-apenas mantém o formato original" ] ; then
  echo "Estou reutilizando o formato de video que acompanha este arquivo"
  VIDEO_FORMAT="copy"
  EXEC_CMD_PART2=" -ovc raw "
  ARQUIVO_OUT_EXT="avi"
fi

if [ "$ASK_VIDEO_FORMAT" == "xvid-toca na maioria dos DVDs" ] ; then
  VIDEO_FORMAT="xvid"
  EXEC_CMD_PART2=" -ovc xvid -xvidencopts pass=2:bitrate=$BITRATE -vf lavcdeint,scale=$VIDEO_RES,harddup "
  ARQUIVO_OUT_EXT="avi"
fi

if [ "$ASK_VIDEO_FORMAT" == "xvid-para portateis" ] ; then
  VIDEO_FORMAT="xvid"
  EXEC_CMD_PART2=" -ovc xvid -xvidencopts pass=2:bitrate=$BITRATE -vf lavcdeint,scale=$VIDEO_RES,harddup "
  ARQUIVO_OUT_EXT="avi"
fi

if [ "$ASK_VIDEO_FORMAT" == "x264-toca somente em aparelhos especiais como PS3, PSP dentre outros" ] ; then
  echo "O formato x624 toca somente em aparelhos especiais como PS3, PSP dentre outros"
  echo "Também requer que o mencoder/mplayer tenha sido compilado para usar x624"
  VIDEO_FORMAT="x264"
  EXEC_CMD_PART2=" -ovc x264 -x264encopts bitrate=$BITRATE -oac mp3lame -lameopts abr:br=52 "
  ARQUIVO_OUT_EXT="mp4"
fi

if [ "$EXEC_CMD_PART1" = "" ] || \
   [ "$EXEC_CMD_PART2" = "" ] ; then
  zenity --title="Ops !" --info --text "Variaveis nulas :\nEXEC_CMD_PART1=$EXEC_CMD_PART1\nEXEC_CMD_PART2=$EXEC_CMD_PART2"
  exit 3;
fi
SCRIPT_FILE="/tmp/converter_arquivos_$DATA_INICIO.sh"
[ -f "$SCRIPT_FILE" ] && rm -f "$SCRIPT_FILE"
echo "#!/bin/bash">$SCRIPT_FILE
echo "# Nome do Script : $SCRIPT_FILE">>$SCRIPT_FILE
# traduz os itens e coloca-os em aspas para o correto processamento de
# nome de arquivos que contenham espacos no nome
ITEMS_SELECIONADOS=$(echo -e "$NAUTILUS_SCRIPT_SELECTED_FILE_PATHS" | awk 'BEGIN {FS = "\n" } { printf "\"%s\" ", $1 }' | sed -e s#\"\"##)
LISTA=`mktemp`
eval find $ITEMS_SELECIONADOS >$LISTA
while read ARQUIVO_AVI ; do
 #zenity --title="debug !" --info --text "$ARQUIVO_AVI"
  arquivo_ext=${ARQUIVO_AVI##*.}
  if [ "$arquivo_ext" = "avi" ] ; then
    arquivo_basename=`basename "$ARQUIVO_AVI" .$arquivo_ext`
    arquivo_basename_nospace=${arquivo_basename// /_}
    arquivo_pasta=`dirname "$ARQUIVO_AVI"`
    arquivo_out=`echo $arquivo_basename_nospace-pt_br.$ARQUIVO_OUT_EXT|tr '[:upper:]' '[:lower:]'`
    arquivo_out="$arquivo_pasta/$arquivo_out"
    arquivo_legenda="$arquivo_pasta/$arquivo_basename.srt"
    comentario1="### $ARQUIVO_AVI"
    EXEC_CMD_PART3=" "
    comentario2="#  arquivo ext=$arquivo_ext">>$SCRIPT_FILE
    comentario3="#  arquivo base=$arquivo_basename">>$SCRIPT_FILE
    comentario4="#  arquivo legenda=$arquivo_legenda">>$SCRIPT_FILE
    if ! [ -f "$arquivo_legenda" ] ; then
      comentario5="#    Nao Possui arquivo de legenda : $arquivo_legenda">>$SCRIPT_FILE
    else
      comentario5="# aplicando arquivo de legenda"
      EXEC_CMD_PART3=" -subpos 95 -subcp iso-8859-15 -sub \"$arquivo_legenda\" -subfont-autoscale $LEGENDA_AUTOSCALE -font \"$FONT_FILE\" "
    fi
    EXEC_CMD_PART0="mencoder \"$ARQUIVO_AVI\"  -o \"$arquivo_out\" "
    EXEC_CMD="$EXEC_CMD_PART0 $EXEC_CMD_PART1 $EXEC_CMD_PART2 $EXEC_CMD_PART3"
    cat >> $SCRIPT_FILE <<END
$comentario1
$comentario2
$comentario3
$comentario4
$comentario5
tempfile=\`mktemp\`
TIMESTART=\`date +%H:%M\`
$EXEC_CMD >\$tempfile&
MYPID=\$!
while ! [ -z \`ps -p \${MYPID} | grep \${MYPID}\` 2>/dev/null ] ; do
  perc_concluido=\`cat \$tempfile|grep "%"|tail -c 120|cut -d"(" -f2|cut -d "%" -f1\`
  echo \$perc_concluido
  sleep 1s
done |zenity --progress --auto-close --title="Convertendo video" --text "Convertendo de :\n\t$ARQUIVO_AVI\nPara:\n\t$arquivo_out"
TIMEFINISH=\`date +%H:%M\`
if ! [ -z \`ps -p \${MYPID} | grep \${MYPID}\` 2>/dev/null ] ; then
  kill \$MYPID
  zenity --notification --text "Conversao do video $ARQUIVO_AVI para $arquivo_out foi cancelada.[executado de \$TIMESTART ate \$TIMEFINISH]" &
else
  zenity --notification --text "Conversao do video $ARQUIVO_AVI para $arquivo_out foi concluída.[executado de \$TIMESTART ate \$TIMEFINISH]" &
fi
[ -f \"\$tempfile\" ] && rm -f \"\$tempfile\"
END
    if [ -f "$SCRIPT_FILE" ] ; then
      chmod a+x "$SCRIPT_FILE"
      chmod 777 "$SCRIPT_FILE"
    fi
  fi
done <$LISTA

# removendo o script no final
echo "[ -f \"$SCRIPT_FILE\" ] && rm -f \"$SCRIPT_FILE\"">>$SCRIPT_FILE

# Executando o batch
if [ "$SOMENTE_EXIBIR_CMD" = "S" ] ; then
      $ZENITY  --title="Os comandos a serem executados encontram-se em $$SCRIPT_FILE" --text-info --filename="$SCRIPT_FILE" &
else
  if [ -f "$SCRIPT_FILE" ] ; then
    chmod a+x "$SCRIPT_FILE"
    $SCRIPT_FILE&
  fi
fi

exit 0;
