#!/bin/bash
. /usr/share/ubuntuperfeito-lucid/ubuntu-perfeito.var

if [ -z "$EMAILME" ] || \
   [ -z "$PACKAGE_NAME" ] || \
   [ -z "$ICONE" ] || \
   [ -z "$PASTA_TMP" ] ; then
  echo "Arquivo de variaiveis [ubuntu-perfeito.var]  não foi encontrado."
  exit 2;
fi

/usr/bin/zenity --question --title="Copiar manuais e apostilas" --text "Gostaria de copiar manuais e apostilas de programas populares instalados ?"
if [ $? -eq 0 ] ; then
  PASTA_DOCUMENTO_NOME=""
  if [ -d "$HOME/documentos" ] && [ "$PASTA_DOCUMENTO_NOME" = "" ] ; then
    PASTA_DOCUMENTO_NOME="documentos"

  fi
  if [ -d "/home/$USER/Documentos" ] && [ "$PASTA_DOCUMENTO_NOME" = "" ] ; then
    PASTA_DOCUMENTO_NOME="Documentos"
  fi
  if [ "$PASTA_DOCUMENTO_NOME" = "" ] ; then
    /usr/bin/zenity --error --title="Copiar manuais e apostilas" --text "Voce não possui a pasta de Documentos em seu sistema." 
    exit 2;
  fi

  PASTA_MANUAIS="$HOME/$PASTA_DOCUMENTO_NOME/manuais"  
  echo "Nome da pasta de documentos : $PASTA_DOCUMENTO_NOME"
  echo "Origem dos manuais          : /etc/skel/$PASTA_DOCUMENTO_NOME/manuais/"
  echo "Destino dos manuais         : $PASTA_MANUAIS"
  ! [ -d "$PASTA_MANUAIS" ] && mkdir -p "$HOME/$PASTA_DOCUMENTO_NOME"
  ln -s "/etc/skel/$NOME_PASTA_DOCUMENTOS/manuais" "/home/$USER/$NOME_PASTA_DOCUMENTOS/manuais" 

  ! [ -f $HOME/.gtk-bookmarks ] && touch $HOME/.gtk-bookmarks
  URI="file://$PASTA_MANUAIS"
  EXISTE_ATALHO=`cat $HOME/.gtk-bookmarks |grep "$URI" |wc -l`
  if [ "$EXISTE_ATALHO" -eq 0 ] ; then
     echo "$URI" >>"$HOME/.gtk-bookmarks"
  fi
  /usr/bin/zenity --info --title="Copiar manuais e apostilas" --text "Os manuais e apostilas foram copiados com sucesso." 
fi
