#!/bin/bash
# script para corrigir um bug no rdesktop, o qual a tecla caps lock nao funciona


function do_correcao_geral() {
  BUG_FILE="/usr/share/rdesktop/keymaps/common" 
  TEMPFILE2="/tmp/corrigir_bug_rdesktop.sh"
  chmod a+x $TEMPFILE2
  BUG_LINE="Caps_Lock 0x0 inhibit"
 
  # verifica se este patch nao foi aplicado antes
  if [ -f "$BUG_FILE" ] ; then
    EXISTE=`cat "$BUG_FILE"|grep "#$BUG_LINE"|wc -l`
    if [ "$EXISTE" -gt 0 ] ; then
      zenity --info --title="Ops !"  --text "A correção já se encontra aplicada."
      return ; 
    fi
  fi

  # resolvendo o problema
cat > "$TEMPFILE2" <<END
#!/bin/bash
sed -i "/^\\$BUG_LINE/ s/^/#/g" $BUG_FILE 
END
  chmod a+x "$TEMPFILE2"
  gksu "$TEMPFILE2"
  EXISTE=`cat "$BUG_FILE"|grep "#$BUG_LINE"|wc -l`
  if [ "$EXISTE" -gt 0 ] ; then
    zenity --info --title="Correção aplicada com sucesso."  --text "Se estiver interessado em visualizar as modificações realizadas veja o arquivo :\n$BUG_FILE\n$TEMPFILE2"
  else
    zenity --info --title="Erro na aplicação da correção."  --text "Houve um erro na aplicação da correção."
  fi
}

#
# inicio do programa
#
clear;

# aplicando solucao
CORRECAO=`zenity --question \
          --title "Resolver bug do Rdesktop :" \
          --text "O Rdesktop é um backend para vários programas clientes de protocolo RDP que na pratica são usados para acessarem servidores de Terminal Services.\nHá um bug no programa rdesktop que deixa a tecla CAPS_LOCK sem funcionar.\nA solucao do problema é simples e posso resolve-lo.\n.\nPosso aplicar a correção ?" `;
  if [ $? -eq 0 ] ; then
     do_correcao_geral;
  fi
