#!/bin/bash
# script para exibir icones na area de trabalho
# Verifica se há um ou mais monitores conectados ao sistema, se houver apenas um
# entao calcula a area que poderá usar na tela
# se houver dois entao usará o monimo possivel 800x600
. /usr/share/ubuntuperfeito-lucid/ubuntu-perfeito.var

if [ -z "$EMAILME" ] || \
   [ -z "$PACKAGE_NAME" ] || \
   [ -z "$ICONE" ] || \
   [ -z "$PASTA_TMP" ] ; then
  echo "Arquivo de variaiveis [ubuntu-perfeito.var]  não foi encontrado."
  exit 2;
fi

LISTA=`/usr/bin/zenity $ZEN_SIZE --list --checklist \
      --title "Quais icones voce gostaria de ver na sua área de trabalho?" \
      --text "Quais icones voce gostaria de ver na área de trabalho de [root]?" \
      --column "Nome" --column "Descrição" \
      false "Meu Computador" \
      false "Ambiente de Rede" \
      true "Minha Pasta Pessoal" \
      true "Lixeira" `;
# primeiro desligamos todos os icones na tela :
gconftool-2 --type bool --set "/apps/nautilus/desktop/computer_icon_visible" "false"
gconftool-2 --type bool --set "/apps/nautilus/desktop/network_icon_visible" "false"
gconftool-2 --type bool --set "/apps/nautilus/desktop/home_icon_visible" "false"
gconftool-2 --type bool --set "/apps/nautilus/desktop/trash_icon_visible" "false"
# depois ligamos apenas os que nos interessam :
[[ "$LISTA" =~ "Meu Computador" ]] && gconftool-2 --type bool --set "/apps/nautilus/desktop/computer_icon_visible" "true"
[[ "$LISTA" =~ "Ambiente de Rede" ]] && gconftool-2 --type bool --set "/apps/nautilus/desktop/network_icon_visible" "true"
[[ "$LISTA" =~ "Minha Pasta Pessoal" ]] && gconftool-2 --type bool --set "/apps/nautilus/desktop/home_icon_visible" "true"
[[ "$LISTA" =~ "Lixeira" ]] && gconftool-2 --type bool --set "/apps/nautilus/desktop/trash_icon_visible" "true"
