#!/bin/bash
# Menu de serviços do Ubuntu Perfeito
. /usr/share/ubuntuperfeito-lucid/ubuntu-perfeito.var

if [ -z "$EMAILME" ] || \
   [ -z "$PACKAGE_NAME" ] || \
   [ -z "$ICONE" ] || \
   [ -z "$PASTA_TMP" ] ; then
  echo "Arquivo de variaiveis [ubuntu-perfeito.var]  não foi encontrado."
  exit 2;
fi

METACITY="N"
COMPIZ="N"
SE_MONITOR_LCD="N"

[ `ps aux|grep metacity|grep -v "grep"|wc -l` -gt 0 ] && METACITY="S"
[ `ps aux|grep /usr/bin/compiz.real|grep -v "grep"|wc -l` -gt 0 ] && COMPIZ="S"
if ! [ -f "/usr/bin/zenity" ] || ! [ -f "/bin/sed" ]  ; then
  echo "Preparando e instalando minhas próprias dependencias..."
  sudo apt-get install -y zenity sed
fi

if ! [ -f "/usr/bin/zenity" ] || ! [ -f "/bin/sed" ]  ; then
   echo "Dependencias não instaladas : zenity, sed."
   exit 2;
fi

# diretorio mandatório
! [ -d "/home/$USERNAME/.config/autostart" ] && mkdir -p "/home/$USERNAME/.config/autostart"

ICONE=gnome-control-center
SERVICOS='---'
while   [ "$SERVICOS" != "" ]; do
  SERVICOS=`zenity  $ZEN_SIZE --list --radiolist \
    --title 'Menu de Serviços do Ubuntu Perfeito' \
    --text 'Todos os serviços alistados abaixo afetam apenas seu perfil.' \
    --column ' ' --column 'Qual a tarefa que gostaria de executar :' \
    false 'Aplicar tema default do Ubuntu Perfeito'\
    false 'Aplicar tema original do Ubuntu' \
    false 'Instalar complementos para o Firefox' \
    false 'Exibir ícones na área de trabalho' \
    false 'Usar fontes [Liberation] na área de trabalho' \
    false 'Copiar manuais e apostilas' \
    false 'Ativar/Desativar CTRL+ALT+DEL para chamar o gnome-system-monitor' \
    false 'Ativar/Desativar [compositing] nativo do Metacity' \
    false 'Acrescentar/Remover o aMSN na inicialização do sistema' \
    false 'Acrescentar/Remover o cairo-dock na inicialização do sistema' \
    false 'Acrescentar/Remover o Skype na inicialização do sistema' \
    false 'Acrescentar/Remover o script [converter_videos] para o nautilus' \
    false 'Resolver bug de teclado no Rdesktop' \
    false 'Testar e resolver bug com numero de ciclos elevados no HD' \
    false 'Criar pacote .deb do UbuntuPerfeito para transporte' \
    false 'Script Ubuntu Perfeito'`;


  if [ "$SERVICOS" == "Ativar/Desativar CTRL+ALT+DEL para chamar o gnome-system-monitor" ] ; then  
     if [ -f $APPLICATION_PATH/ubuntuperfeito-gnomesystemmonitor.sh ] ; then
        $APPLICATION_PATH/ubuntuperfeito-gnomesystemmonitor.sh
     else
       zenity --error --title="Erro :"  --text "Script não existe :\n$APPLICATION_PATH/ubuntuperfeito-gnomesystemmonitor.sh"
     fi
  fi 

  if [ "$SERVICOS" == "Instalar complementos para o Firefox" ] ; then  
     if [ -f "$APPLICATION_PATH/ubuntuperfeito-firefox3.sh" ] ; then
       $APPLICATION_PATH/ubuntuperfeito-firefox3.sh
     else
       zenity --error --title="Erro :"  --text "Script não existe :\n$APPLICATION_PATH/ubuntuperfeito-firefox3.sh"
     fi
  fi 

  if [ "$SERVICOS" == "Copiar manuais e apostilas" ] ; then  
     if [ -f "$APPLICATION_PATH/ubuntuperfeito-copiar_manuais.sh" ] ; then
        $APPLICATION_PATH/ubuntuperfeito-copiar_manuais.sh
     else
       zenity --error --title="Erro :"  --text "Script não existe :\n$APPLICATION_PATH/ubuntuperfeito-copiar_manuais.sh"
     fi
  fi   
  	     
  if [ "$SERVICOS" == "Aplicar tema default do Ubuntu Perfeito" ] ; then  
     if [ -f $APPLICATION_PATH/ubuntuperfeito-aplicar_tema.sh ] ; then
        $APPLICATION_PATH/ubuntuperfeito-aplicar_tema.sh
     else
       zenity --error --title="Erro :"  --text "Os temas não estão instalados."
     fi
  fi   

  if [ "$SERVICOS" == "Aplicar tema original do Ubuntu" ] ; then  
     if [ -f $APPLICATION_PATH/ubuntuperfeito-aplicar_tema_ubuntu.sh ] ; then
        $APPLICATION_PATH/ubuntuperfeito-aplicar_tema_ubuntu.sh
     else
       zenity --error --title="Erro :"  --text "Script não existe :\n$APPLICATION_PATH/ubuntuperfeito-aplicar_tema_ubuntu.sh"
     fi
  fi

  if [ "$SERVICOS" == "Ativar/Desativar [compositing] nativo do Metacity" ] ; then
     if [ "$METACITY" != "S" ] ; then
        zenity --error --title="Erro ao ativar compositing"  --text "Habilitar compositing no metacity requer o uso do metacity."
     else
  	   zenity --question --title="Ativar/Desativar [compositing]"  --question --text "O [compositing] ativa efeitos de transparencia e sombras na área de trabalho, mas só é indicada para usuários do metacity, se voce estiver usando o compiz então não deve executar esta opção.\nGostaria de ativar o [compositing] (botão OK) ou desativa-lo (botão Cancelar) ?"
	     if [ $? -eq 0 ] ; then
          gconftool-2 --type bool --set "/apps/metacity/general/compositing_manager" "true"
          zenity --info --title="Compositing habilitado"   --text "O compositing do metacity está ativado, porém se for ativar o compiz no futuro, lembre de desativa-lo, pois conforme reporta este bug:\nhttps://bugs.launchpad.net/ubuntu/+source/metacity/+bug/178953\nNão é possivel ativar o compiz com o compositing-metacity habilitado.\nVoce poderá usar o menu de serviços para ativar/desativar o compositing-metacity."&
       else
          gconftool-2 --type bool --set "/apps/metacity/general/compositing_manager" "false"
       fi
     fi
  fi

  if [ "$SERVICOS" == "Exibir ícones na área de trabalho" ] ; then  
     if [ -f /usr/share/ubuntuperfeito/ubuntuperfeito-exibir_icones.sh ] ; then
        /usr/share/ubuntuperfeito/ubuntuperfeito-exibir_icones.sh
     else
       zenity --info --title="Erro :"  --text "O script :\n\t/usr/share/ubuntuperfeito/ubuntuperfeito-exibir_icones.sh\n não está instalado. Reinstale o Ubuntu Perfeito."
     fi
  fi

  if [ "$SERVICOS" == "Usar fontes [Liberation] na área de trabalho" ] ; then  
     if [ -f $APPLICATION_PATH/ubuntuperfeito-set_font_liberation.sh ] ; then
        $APPLICATION_PATH/ubuntuperfeito-set_font_liberation.sh
     else
       zenity --question --title="Erro :"  --text "O script :\n\t$APPLICATION_PATH/ubuntuperfeito-set_font_liberation.sh\n não está instalado. Reinstale o Ubuntu Perfeito."
     fi
  fi

  if [ "$SERVICOS" == "Script Ubuntu Perfeito" ] ; then  
     if [ -f $APPLICATION_PATH/ubuntu-perfeito.sh ] ; then
        gksu $APPLICATION_PATH/ubuntu-perfeito.sh
     else
       zenity --info --title="Script Ubuntu Perfeito"  --text "O script Ubuntu Perfeito não está em :\n$APPLICATION_PATH/ubuntu-perfeito.sh"
     fi     
  fi  

  if [ "$SERVICOS" == "Acrescentar/Remover o cairo-dock na inicialização do sistema" ] ; then  
     if ! [ -f "$HOME/.config/autostart/cairo-dock.desktop" ] ; then
       [ -f "/usr/share/applications/cairo-dock.desktop" ] && ln -s /usr/share/applications/cairo-dock.desktop "$HOME/.config/autostart/cairo-dock.desktop"
       if [ "$METACITY" == "S" ] ; then
         gconftool-2 --type bool --set "/apps/metacity/general/compositing_manager" "true"
         zenity --info --title="Compositing habilitado"   --text "O compositing do metacity está ativado, porém se for ativar o compiz no futuro, lembre de desativa-lo, pois conforme reporta este bug:\nhttps://bugs.launchpad.net/ubuntu/+source/metacity/+bug/178953\nNão é possivel ativar o compiz com o compositing-metacity habilitado.\nVoce poderá usar o menu de serviços para ativar/desativar o compositing-metacity."&
       fi
     else
       rm -f "$HOME/.config/autostart/cairo-dock.desktop"
     fi
  fi  
   
  if [ "$SERVICOS" == "Acrescentar/Remover o aMSN na inicialização do sistema" ] ; then  
     if ! [ -f "$HOME/.config/autostart/amsn.desktop" ] ; then
       if [ -f "/usr/share/applications/amsn.desktop" ] ; then 
         ln -s /usr/share/applications/amsn.desktop "$HOME/.config/autostart/amsn.desktop"
         /usr/bin/amsn&
       fi
     else
       rm -f "$HOME/.config/autostart/amsn.desktop"
     fi
  fi    
   
  if [ "$SERVICOS" == "Acrescentar/Remover o Skype na inicialização do sistema" ] ; then  
     if ! [ -f "$HOME/.config/autostart/skype.desktop" ] ; then
       if [ -f "/usr/share/applications/skype.desktop" ] ; then
          ln -s /usr/share/applications/skype.desktop "$HOME/.config/autostart/skype.desktop"
          /usr/bin/skype&
       fi
     else
       rm -f "$HOME/.config/autostart/skype.desktop"
     fi
  fi 

  if [ "$SERVICOS" == "Acrescentar/Remover o script [converter_videos] para o nautilus" ] ; then  
     if ! [ -f "$HOME/.gnome2/nautilus-scripts/ubuntuperfeito-converter_videos.sh" ] ; then
       if [ -f "$APPLICATION_PATH/ubuntuperfeito-converter_videos.sh" ] ; then
         ln -s $APPLICATION_PATH/ubuntuperfeito-converter_videos.sh "$HOME/.gnome2/nautilus-scripts/ubuntuperfeito-converter_videos.sh"
       else
         zenity --error --title="Script Ubuntu Perfeito"  --text "O script não está em :\n$APPLICATION_PATH/ubuntuperfeito-converter_videos.sh"       
       fi
     else
       rm -f "$HOME/.gnome2/nautilus-scripts/ubuntuperfeito-converter_videos.sh"
     fi
     if [ -f "$HOME/.gnome2/nautilus-scripts/ubuntuperfeito-converter_videos.sh" ] ; then
         zenity --info --title="Script [converter_videos.sh] instalado com sucesso"   --text "O script que converte videos para dvix/xvid e mescla legendas foi instalado em seu nautilus.\nPara usar basta selecionar arquivos *.avi no nautilus,\nclicar com o botão direito e selecionar Scripts->Converter Videos."
     else
         zenity --info --title="Script [converter_videos.sh] foi removido com sucesso"   --text "O script que converte videos para dvix/xvid e mescla legendas foi removido de nautilus."
     fi
  fi   
  
  if [ "$SERVICOS" == "Resolver bug de teclado no Rdesktop" ] ; then 
     if [ -f $APPLICATION_PATH/ubuntuperfeito-corrigir-bug-teclado-rdesktop.sh ] ; then
        #gksu "gnome-terminal -e /usr/share/ubuntuperfeito/ubuntuperfeito-corrigir-bug-teclado-rdesktop.sh"
        $APPLICATION_PATH/ubuntuperfeito-corrigir-bug-teclado-rdesktop.sh
     else
       zenity --error --title="Ubuntu Perfeito com problemas"  --text "O script :\n\t$APPLICATION_PATH/ubuntuperfeito-corrigir-bug-teclado-rdesktop.sh\n não está instalado. Reinstale o Ubuntu Perfeito."
     fi
  fi
  
  if [ "$SERVICOS" == "Testar e resolver bug com numero de ciclos elevados no HD" ] ; then  
     if [ -f $APPLICATION_PATH/ubuntuperfeito-hdd-spin-fix.sh ] ; then
        gksudo "xterm -e $APPLICATION_PATH/ubuntuperfeito-hdd-spin-fix.sh"
     else
       zenity --error --title="Ubuntu Perfeito com problemas"  --text "O script :\n\t$APPLICATION_PATH/ubuntuperfeito-hdd-spin-fix.sh\n não está instalado. Reinstale o Ubuntu Perfeito."
     fi
  fi  

  if [ "$SERVICOS" == "Criar pacote .deb do UbuntuPerfeito para transporte" ] ; then  
     if [ -f "$APPLICATION_PATH/criar-pacote-ubuntuperfeito.sh" ] ; then
      tempfile=`mktemp`
      echo "#!/bin/bash">$tempfile
      echo "cd $APPLICATION_PATH">>$tempfile
      echo "./criar-pacote-ubuntuperfeito.sh custom_$USER">>$tempfile
      echo "echo 'copie o pacote acima e transporte-o para qualquer computador similar'">>$tempfile
      echo "echo 'pressione [ENTER] para prosseguir...'">>$tempfile
      echo "read espera">>$tempfile
      chmod a+x $tempfile
      gksudo "xterm -e $tempfile"
      rm -f "$tempfile"
     fi
  fi   


done
