#!/bin/bash
. /usr/share/ubuntuperfeito-lucid/ubuntu-perfeito.var

if [ -z "$EMAILME" ] || \
   [ -z "$PACKAGE_NAME" ] || \
   [ -z "$ICONE" ] || \
   [ -z "$PASTA_TMP" ] ; then
  echo "Arquivo de variaiveis [ubuntu-perfeito.var]  não foi encontrado."
  exit 2;
fi

SE_MONITOR_LCD="N"


/usr/bin/zenity --question --title="Fontes [Liberation]"  --question --text "Gostaria de ativar as fontes [Liberation] na área de desktop?"
if [ $? -eq 0 ] ; then
  /usr/bin/zenity --question --title="Renderização das fontes :"  --question --text "Gostaria de ativar a renderização das fontes para LCD ?"
  [ $? -eq 0 ] && SE_MONITOR_LCD="S"
  if [ "$SE_MONITOR_LCD" = "S" ] ; then
    # Monitores LCD podem ter a exibição das fontes melhoradas
    gconftool-2 --type string --set "/desktop/gnome/font_rendering/antialiasing" "rgba"
    gconftool-2 --type string --set "/desktop/gnome/font_rendering/hinting" "slight"
    gconftool-2 --type string --set "/desktop/gnome/font_rendering/rgba_order" "rgb"
  else
    # Monitores CRT podem ter a exibição das fontes melhoradas
    gconftool-2 --type string --set "/desktop/gnome/font_rendering/antialiasing" "grayscale"
    gconftool-2 --type string --set "/desktop/gnome/font_rendering/hinting" "full"
    gconftool-2 --type string --set "/desktop/gnome/font_rendering/rgba_order" "rgb"
  fi
  # Ajusta as fontes da tela para aplicar as fontes Liberation
  gconftool-2 --type string --set "/desktop/gnome/interface/document_font_name" "Liberation Sans 10"
  gconftool-2 --type string --set "/desktop/gnome/interface/font_name" "Liberation Sans 10"
  gconftool-2 --type string --set "/desktop/gnome/interface/monospace_font_name" "Liberation Mono 10"
  gconftool-2 --type string --set "/apps/metacity/general/titlebar_font" "Liberation Sans Bold 10"
  gconftool-2 --type bool --set "/apps/metacity/general/titlebar_uses_system_font" "true"
  gconftool-2 --type string --set "/apps/nautilus/preferences/desktop_font" "Liberation Sans 10"
  /usr/bin/zenity --info --title="Leia com atenção :" --text "Após ter aplicado as fontes [Liberation] na sua área de trabalho \né possivel que elas aparecem com uma resolução muito ruim,\nisso pode indicar que a renderização das fontes está mal-selecionada.\nPara corrigir este problema vá no menu do sistema->preferencias->Aparencia,\nselecione a guia [Fontes] e modifique o campo de renderização."
fi
